import QtQuick 2.0
import "."
import com.wemx 1.0

WEMXComponent {
    id : wemx
    //anchors.fill: parent;
	
    property var properties: wemx.getProperties();
    property var multigestureDisable;
	property var multigestureDisable_reg;
	property var org_width;
	property var org_height;
	property var x_ratio:1;
	property var y_ratio:1;
	
	// Debug ON
	property var dbg_on;
	property var dbgScreen_on;
	
    // TAb AREA
    property var useTapArea;
    property var tapX;
    property var tapY;
    property var tapStatus;   
    property double tapStartTime:0;

    property var useLongTapArea;
    property var longtapX;
    property var longtapY;
    property var longtapStatus;  
	property var longtapActive;
    property double longtapStartTime:0;
	property var longtabDelay;

    property var useDoubleTapArea;
    property var doubletapX;
    property var doubletapY;
    property var doubletapStatus;  
	property var createDoubleTap;
    property double doubletapStartTime:0;
	property var doubletapPoint1X;
	property var doubletapPoint1Y;
	property var doubletabDelay;

    property var tap_X;
    property var tap_Y;
    property var tap_UX;
    property var tap_UY;    
	property var tap_ScreenX;
	property var tap_ScreenY;

    //SWIPE AREA
    property var useSwipeArea;    
    property var swipeDirection;
    property var swipeAngle;
    property var swipeStatus;
    property var swipe_X;
    property var swipe_Y;
    property var swipe_Angle;
    property var swipe_Direction;
	property var swipeActive;
    
    //PAN AREA
    property var usePanArea;        
    property var panStartX;
    property var panStartY;
    property var panOffsetX;
    property var panOffsetY;
    property var panStatus;
	property var panActive;
	
	
    //PINCH AREA
    property var usePinchArea;  
    property var pinchX;
    property var pinchY;
    property var pinchX2;
    property var pinchY2;
    property var pinchCenterX;
    property var pinchCenterY;
    property var pinchOffX;
    property var pinchOffY;
    property var pinchOffX2;
    property var pinchOffY2;
    property var pinchOffCenterX;
    property var pinchOffCenterY;	
    property var pinchScale;
    property var pinchRotation;
    property var pinchStatus;
	
    property var pinch_Angle;    
    property var pinch_center_x;
    property var pinch_center_y;
    property var pinch_Scale;

	
	//SCREEN FUNCTION
    property var useScreenScale;  
    property var useVectorScale;  
    property var minScreenScale;  
    property var maxScreenScale;  
    property var useMoveScreen;  
    property var useMoveScreenBy;  
    property var useRevertOriginal;  
    property var useRevertOriginalBy;  
    property var useRotateScreen;  
	property var startScreenScale;
	property var inScreenMoving;
	property var startMoveX;
	property var startMoveY;
	property var startMoveAbsoluteScreenPositionX;
	property var startMoveAbsoluteScreenPositionY;
	property var tmpMoveX;
	property var tmpMoveY;
	property var startAngle;
	property var screenMoveOffX;
	property var screenMoveOffY;
	property var screenMoveOnPinch;
	
	
	
	function printItemTree(root)
	{
		console.log("[printItemTree]"+root);
		for(var i = root.children.length-1 ; i >= 0 ; i--)
		{
			var child = root.children[i];
			var child_str = child.toString();
			console.log(root+"-->"+child+",parent:"+child.parent);
		}
		for(var i = root.children.length-1 ; i >= 0 ; i--)
		{
			var child = root.children[i];
			printItemTree(child);		
		}
	}

	function resetScreenOperCallback()
	{
		var pos = [0,0];
		
		if ( dbgScreen_on == 1 )
			console.log("resetScreenOper");
			
		wemx.get("ScreenPosition").writeClass(pos);
		wemx.get("ScreenScale").writeReal(1);	
		wemx.get("ScreenRotate").writeReal(0);
		wemx.get("ScreenScaleCenter").writeClass(pos);
		wemx.get("UseVectorScale").writeInteger(1);
	}	
	
    Timer {
        id:resetScreenTimer
        interval:100
        repeat:false
        onTriggered:resetScreenOperCallback()
    }

	function resetScreenOper()
	{
		resetScreenTimer.stop();
		resetScreenTimer.start();
	}
	
	
    // TAP FUCTION
    Timer {
        id:procLongTapTimer
        interval:1000
        repeat:false
        onTriggered: {
            if ( longtapStartTime != 0)
            {
				longtapActive = 1;
				longtapStartTime = 0;
				if ( useLongTapArea != 0  && longtapStatus) longtapStatus.writeInteger(1); 
            }
        }
    }
    
    function proTabArea_onPressd()
    {
		tap_X = point1.x;
		tap_Y = point1.y;
        tap_UX = tap_X;
        tap_UY = tap_Y;  
		tap_ScreenX = tap_X;
		tap_ScreenY = tap_Y;
		
        if ( useTapArea != 0 || ( useRevertOriginal != 0 && useRevertOriginalBy == 1) )
        {
			if ( point1.pressed && !point2.pressed )
			{
				if ( useTapArea != 0 && tapStatus ) tapStatus.writeInteger(1); 
				tapStartTime = new Date().getTime();
			}
			if ( point1.pressed && point2.pressed )
			{
				if ( useTapArea != 0 && tapStatus ) tapStatus.writeInteger(4); 
				tapStartTime = 0;
			}
        }
		
        if ( useLongTapArea != 0 || ( useRevertOriginal != 0 && useRevertOriginalBy == 2) )
        {
			if ( point1.pressed && !point2.pressed )
			{
				procLongTapTimer.stop();
				longtapStartTime = new Date().getTime();
				if ( longtabDelay )
				{
					var t = longtabDelay.readInteger();
					if ( t <  500 ) t = 500;
					if ( t > 3000 ) t = 3000;
					procLongTapTimer.interval = t;
				}
				procLongTapTimer.start();
			}
 			if ( point1.pressed && point2.pressed )
			{
				procLongTapTimer.stop();
				longtapStartTime = 0;
			}
		}
        if ( useDoubleTapArea != 0 || ( useRevertOriginal != 0 && useRevertOriginalBy == 3))
        {
            if ( doubletapStartTime != 0 && point1.pressed && !point2.pressed)
            {
				var t = 300;
				
				if ( doubletabDelay )
				{
					var t = doubletabDelay.readInteger();
					if ( t <  100 ) t = 100;
					if ( t > 1000 ) t = 1000;
				} 
			
                if ( (new Date().getTime() - doubletapStartTime) < t )
                {
					var a = point1.x - doubletapPoint1X;
					var b = point1.y - doubletapPoint1Y;
					var dist =  wemx.getStartDragDistance();
					if ( dist <= 0 ) 
						dist = 10;
					if ( Math.sqrt(a*a+b*b) < dist ) 
					{
						if ( dbg_on == 1 )
							console.log(point1.x+","+point1.y+":"+doubletapPoint1X+","+doubletapPoint1Y+" DIST:"+Math.sqrt(a*a+b*b)+" StartDragDistance:"+dist);
							
						createDoubleTap = 1;
						if ( useDoubleTapArea != 0 && doubletapStatus) doubletapStatus.writeInteger(1);
					}
					else
					{
						doubletapStartTime = 0;
						createDoubleTap = 0;
					}
                }
                doubletapStartTime = 0;
            }
			else if ( doubletapStartTime != 0 && point1.pressed && point2.pressed)
			{
				if ( useDoubleTapArea != 0 && doubletapStatus && createDoubleTap != 0 )  doubletapStatus.writeInteger(4); 
				doubletapStartTime = 0;
				createDoubleTap = 0;
			}
            else if ( doubletapStartTime == 0 && point1.pressed && !point2.pressed)
            {
				createDoubleTap = 0;
				doubletapPoint1X = point1.x;
				doubletapPoint1Y = point1.y;
                doubletapStartTime = new Date().getTime();
            }
        }
    }

    function proTabArea_onUpdates()
    {
        tap_UX = point1.x;
        tap_UY = point1.y;  
        if ( ( useLongTapArea != 0 && longtapStartTime != 0) || (useRevertOriginal != 0 && useRevertOriginalBy == 2 && longtapStartTime != 0))
        {        
			var t = 1000;
			if ( longtabDelay )
			{
				t = longtabDelay.readInteger();
				if ( t <  500 ) t = 500;
				if ( t > 3000 ) t = 3000;
			}
			if ( (new Date().getTime() - longtapStartTime) > t )
            {
				procLongTapTimer.stop();
				longtapActive = 1;
				longtapStartTime = 0;
				if ( useLongTapArea != 0 && longtapStatus) longtapStatus.writeInteger(1); 
			}
        }   
    }

    function proTabArea_onReleased()
    {
        tap_UX = point1.x;
        tap_UY = point1.y;          
        if (( useTapArea != 0 && tapStartTime != 0 ) || (useRevertOriginal != 0 && useRevertOriginalBy == 1 && tapStartTime != 0))
        {
			if ( dbg_on == 1 )
				console.log("creats tab event");
			if (useTapArea != 0 && tapX) tapX.writeReal(tap_ScreenX*x_ratio);
			if (useTapArea != 0 && tapY) tapY.writeReal(tap_ScreenY*y_ratio);
			if (useTapArea != 0 && tapStatus) tapStatus.writeInteger(3); 
			
			if ( useRevertOriginal == 1 && useRevertOriginalBy == 1 ) 
				resetScreenOper();
        }

        if (( useLongTapArea != 0 && longtapActive == 1 ) || (useRevertOriginal != 0 && useRevertOriginalBy == 2 && longtapActive == 1 ))
		{
			if ( dbg_on == 1 )
				console.log("creats long tab event");
			if (useLongTapArea != 0 &&longtapX) longtapX.writeReal(tap_ScreenX*x_ratio);
			if (useLongTapArea != 0 &&longtapY) longtapY.writeReal(tap_ScreenY*y_ratio);
			if (useLongTapArea != 0 &&longtapStatus) longtapStatus.writeInteger(3); 
			if ( useRevertOriginal == 1 && useRevertOriginalBy == 2 ) 
				resetScreenOper();

			procLongTapTimer.stop();
			longtapActive = 0;
			longtapStartTime = 0;
		}
		else
		{
			procLongTapTimer.stop();
			longtapActive = 0;
			longtapStartTime = 0;
		}

        if (( useDoubleTapArea != 0 && createDoubleTap != 0 ) || (useRevertOriginal != 0 && useRevertOriginalBy == 3 &&  createDoubleTap != 0 ))
        {         
			var a = point1.x - doubletapPoint1X;
			var b = point1.y - doubletapPoint1Y;
			var dist =  wemx.getStartDragDistance();
			if ( dist <= 0 ) 
				dist = 10;
			if ( Math.sqrt(a*a+b*b) < dist ) 
			{
				if ( dbg_on == 1 )
					console.log("creats double tab event");
		
				if (useDoubleTapArea != 0 && doubletapX) doubletapX.writeReal(tap_ScreenX*x_ratio);
				if (useDoubleTapArea != 0 && doubletapY) doubletapY.writeReal(tap_ScreenY*y_ratio);
				if (useDoubleTapArea != 0 && doubletapStatus)  doubletapStatus.writeInteger(3); 
				createDoubleTap = 0;
				
				if ( useRevertOriginal == 1 && useRevertOriginalBy == 3 ) 
					resetScreenOper();

			}
			else
			{
				if (useDoubleTapArea != 0 && doubletapStatus)  doubletapStatus.writeInteger(4); 
				createDoubleTap = 0;
			}
        }
    }
    
    function proTabArea_onCanceled()
    {
		if ( dbg_on == 1 )
			console.log("proTabArea_onCanceled");
			
        if ( useTapArea != 0  || (useRevertOriginal != 0 && useRevertOriginalBy == 1))
        {
            if ( useTapArea != 0  && tapStatus) tapStatus.writeInteger(4); 
			tapStartTime = 0;
        }
        if (( useLongTapArea != 0 && longtapActive != 0 ) ||  (useRevertOriginal != 0 && useRevertOriginalBy == 2 && longtapActive != 0 ))
        {        
            if ( useLongTapArea != 0 && longtapStatus) longtapStatus.writeInteger(4); 
            procLongTapTimer.stop();
            longtapStartTime = 0;
			longtapActive = 0;
        }
        if ( useDoubleTapArea != 0 ||  (useRevertOriginal != 0 && useRevertOriginalBy == 3) )
        {   
			if ( createDoubleTap != 0 )
			{
				if ( useDoubleTapArea != 0 && doubletapStatus) doubletapStatus.writeInteger(4); 
			}
			createDoubleTap = 0;	
            doubletapStartTime = 0;
        }        
    }      

    // SWIPE FUNCTION
    function swipe_calcDirection()
    {
        if ( ( swipe_Angle >= 0 ) && ( swipe_Angle < 5 ) )
            swipe_Direction = 2;
        else if ( ( swipe_Angle >= 5 ) && ( swipe_Angle < 85 ) )
            swipe_Direction = 6;
        else if ( ( swipe_Angle >= 85 ) && ( swipe_Angle < 95 ) )
            swipe_Direction = 4;
        else if ( ( swipe_Angle >= 95 ) && ( swipe_Angle < 175 ) )
            swipe_Direction = 5;
        else if ( ( swipe_Angle >= 175 ) && ( swipe_Angle < 185 ) )
            swipe_Direction = 1;
        else if ( ( swipe_Angle >= 185 ) && ( swipe_Angle < 265 ) )
            swipe_Direction = 9;
        else if ( ( swipe_Angle >= 265 ) && ( swipe_Angle < 275 ) )
            swipe_Direction = 8;
        else if ( ( swipe_Angle >= 275 ) && ( swipe_Angle < 355 ) )
            swipe_Direction = 10;
        else
            swipe_Direction = 2;    
    }

    function swipe_onPressed()
    {
        if ( useSwipeArea != 0 )
        {
			if (  point1.pressed && point2.pressed  )
			{
				if (swipeStatus) swipeStatus.writeInteger(4);
				swipeActive = 0;
			}	
			else
			{
				if ( swipeActive == 0 ) 
				{
					swipe_X=point1.x;
					swipe_Y=point1.y;
					if (swipeDirection) swipeDirection.writeReal(0);
					if (swipeAngle) swipeAngle.writeReal(0);
					if (swipeStatus) swipeStatus.writeInteger(1);
					swipeActive = 1;
				}
			}
        }
    }
    
    function swipe_onReleased()
    {    
        if ( useSwipeArea != 0 )
        {
            if ( swipeActive == 1 )
            {
                if (swipeStatus) swipeStatus.writeInteger(3);
            }
            swipeActive = 0;
        }    
    }

    function swipe_onUpdated()
    {    
        if ( useSwipeArea != 0 )
        {
            if ( swipeActive == 1 )
            {
				if (  point1.pressed && point2.pressed  )
				{
					if (swipeStatus) swipeStatus.writeInteger(4);
					swipeActive = 0;
				}	
				else
				{
					//var angleRadians = Math.atan2(point1.y - swipe_Y, point1.x - swipe_X);
					var angleDeg = Math.atan2(point1.y - swipe_Y, point1.x - swipe_X) * 180 / Math.PI;
					if ( angleDeg < 0 )
						swipe_Angle = angleDeg*-1;
					else if ( angleDeg > 0 )
						swipe_Angle = 360 - angleDeg;
					else
						swipe_Angle = angleDeg;
					if ( point1.x < 0 || point1.y < 0 || point1.x >= parent.width || point1.y >= parent.height )
					{
						swipeActive = 0;
						if (swipeStatus) swipeStatus.writeInteger(4);
					}
					else
					{
						swipe_calcDirection();
						if ( swipe_Angle != 0 ) {
							if (swipeAngle) swipeAngle.writeReal(360-swipe_Angle); 
						} else  {                        
							if (swipeAngle) swipeAngle.writeReal(swipe_Angle);
						}
						if (swipeDirection) swipeDirection.writeReal(swipe_Direction);
						if (swipeStatus) swipeStatus.writeInteger(2);
					}
				}
            }
        }
    }

    function swipe_onCanceled()
    {    
        if ( useSwipeArea != 0 )
        {
            swipeActive = 0;
            if (swipeStatus) swipeStatus.writeInteger(4);
        }
    }
    
	function screen_startMove()
	{
		if ( useMoveScreen == 1 && ((useMoveScreenBy == 1) || ( useMoveScreenBy == 2 && point1.pressed && point2.pressed ) ) )
		{
			if ( inScreenMoving ==  0 )
			{
				startMoveX = wemx.get("ScreenPosition.X").readReal();
				startMoveY = wemx.get("ScreenPosition.Y").readReal();
				startMoveAbsoluteScreenPositionX = wemx.get("AbsoluteScreenPosition.X").readReal();
				startMoveAbsoluteScreenPositionY = wemx.get("AbsoluteScreenPosition.Y").readReal();
				tmpMoveX=startMoveX;
				tmpMoveY=startMoveY;
				wemx.get("UseVectorScale").writeInteger(0);
				inScreenMoving = 1;
				if ( dbgScreen_on == 1 )
				{
					var displayWidth = wemx.get("DisplayWidth").readReal()
					var displayHeight = wemx.get("DisplayHeight").readReal()
	 
					console.log("Screen Move Start:  startMoveX=" + startMoveX + " startMoveY="+startMoveY);
					console.log("*****************:  startMoveAbsoluteScreenPositionX=" + startMoveAbsoluteScreenPositionX + " startMoveAbsoluteScreenPositionY="+startMoveAbsoluteScreenPositionY);
					console.log("*****************:  displayWidth=" + displayWidth + " displayHeight="+displayHeight);
				}
			}
			else
			{
				if ( dbgScreen_on == 1 )
				{
						console.log("Screen Move Start: inScreenMoving is Not NULL");
				}
					inScreenMoving = inScreenMoving+1;
			}
		}			
	}
	
	
    // PAN AREA FUNCTION
    function pan_onPressed()
    {    
        if ( usePanArea != 0 || useMoveScreen == 1)
        {
			if (  point1.pressed && point2.pressed  )
			{
				if (usePanArea != 0 && panStatus) panStatus.writeInteger(4);
				panActive = 0;
			}
			else
			{
				if ( panActive == 0 ) 
				{
					if (usePanArea != 0 && panStartX) panStartX.writeReal(point1.x*x_ratio);
					if (usePanArea != 0 && panStartY) panStartY.writeReal(point1.y*y_ratio);
					if (usePanArea != 0 && panOffsetX) panOffsetX.writeReal(0);
					if (usePanArea != 0 && panOffsetY) panOffsetY.writeReal(0);
					if (usePanArea != 0 && panStatus) panStatus.writeInteger(1);
					panActive = 1;
				}
			}
        }
    }

    function pan_onReleased()
    {    
        if ( usePanArea != 0  || useMoveScreen == 1)
        {
			var offX = (point1.x-point1.startX)*x_ratio;
			var offY = (point1.y-point1.startY)*y_ratio;
			
            if ( panActive == 1 )
            {
                if (usePanArea != 0 && panOffsetX) panOffsetX.writeReal(offX);
                if (usePanArea != 0 && panOffsetY) panOffsetY.writeReal(offY);
                if (usePanArea != 0 && panStatus) panStatus.writeInteger(3);
            }
            panActive = 0;
			if ( useMoveScreen == 1 && ((useMoveScreenBy == 1) || ( useMoveScreenBy == 2 && !point1.pressed && point2.pressed ) ) )
			{
				if ( inScreenMoving == 1 )
				{
					var newPos = [0,0];
					inScreenMoving = 0;
					wemx.get("UseVectorScale").writeInteger(1);
					
					var scaleXY=wemx.get("ScreenScale").readReal();
					var scaledScreenWidth = pinch_area.width;
					var scaledScreenHeight = pinch_area.height;
					var displayWidth = wemx.get("DisplayWidth").readReal()
					var displayHeight = wemx.get("DisplayHeight").readReal()

					var minLimitX = -1*(scaledScreenWidth-(displayWidth*0.3));
					var maxLimitX = displayWidth*0.7;
					var minLimitY = -1*(scaledScreenHeight-(displayHeight*0.3));
					var maxLimitY = displayHeight*0.7;
					if ( scaleXY < 1 )
					{
						minLimitX = -1*(scaledScreenWidth*0.5);
						maxLimitX = displayWidth-scaledScreenWidth*0.5;
						minLimitY = -1*(scaledScreenHeight*0.5);
						maxLimitY = displayHeight-scaledScreenHeight*0.5;
					}
					
					offX = (point1.x-point1.startX);
					offY = (point1.y-point1.startY);		

					var absX = startMoveAbsoluteScreenPositionX+offX;
					var absY = startMoveAbsoluteScreenPositionY+offY;
					
					if ( dbgScreen_on == 1 )
					{
						var displayX = wemx.get("AbsoluteScreenPosition.X").readReal();
						var displayY = wemx.get("AbsoluteScreenPosition.Y").readReal();
						console.log("Screen Move END:  minLimitX=" + minLimitX + " maxLimitX="+maxLimitX+" minLimitY="+minLimitY+" maxLimitY = "+maxLimitY);
						console.log("***************:  offX=" + offX + " offY="+offY+" absX="+absX+" absY = "+absY);
						console.log("***********:  displayX=" + displayX + " displayY="+displayY);
					}
					
					if ( absX < minLimitX )
						offX = offX+minLimitX-absX;
					else if ( absX > maxLimitX ) 	
						offX = offX-(absX-maxLimitX);
					if ( absY < minLimitY )
						offY = offY+minLimitY-absY;
					else if ( absY > maxLimitY ) 	
						offY = offY-(absY-maxLimitY);
						
					newPos[0] = startMoveX+offX*x_ratio*scaleXY;
					newPos[1] = startMoveY+offY*x_ratio*scaleXY;
					
					wemx.get("ScreenPosition").writeClass(newPos);
					if ( dbgScreen_on == 1 )
					{
						console.log("***************:  MoveX=" + newPos[0] + " MoveY="+newPos[1]+" OffX="+offX+" OffY = "+offY);
						console.log("***************:  minLimitX="+minLimitX+" maxLimitX = "+maxLimitX+" minLimitY="+minLimitY+" maxLimitY = "+maxLimitY);
						console.log("***************:  pinch_area.width="+pinch_area.width+" pinch_area.height="+pinch_area.height+" scaleXY="+scaleXY+" x_ratio="+x_ratio+" y_ratio="+y_ratio);
					}
				}
				else
				{
					inScreenMoving = 0;
					if ( dbgScreen_on == 1 )
					{
						console.log("Screen Move END: Corrupted Move");
					}
				}
			}
		}
    }

    function pan_onUpdated()
    {    
        if ( usePanArea != 0  || useMoveScreen == 1)
        {
			var offX = (point1.x-point1.startX)*x_ratio;
			var offY = (point1.y-point1.startY)*y_ratio;
		
            if ( panActive == 1 )
            {
				if (  point1.pressed && point2.pressed  )
				{
					if (usePanArea != 0 && panStatus) panStatus.writeInteger(4);
					panActive = 0;
				}
				else
				{				
					if ( point1.x < 0 || point1.y < 0 || point1.x >= parent.width || point1.y >= parent.height )
					{
						pan_OnTouching = 0;
						if (usePanArea != 0 && panStatus) panStatus.writeInteger(4);
					}
					else
					{
						if (usePanArea != 0 && panOffsetX) panOffsetX.writeReal(offX);
						if (usePanArea != 0 && panOffsetY) panOffsetY.writeReal(offY);
						if (usePanArea != 0 && panStatus) panStatus.writeInteger(2);
					}
				}
            }
			if ( useMoveScreen == 1 && ((useMoveScreenBy == 1) || ( useMoveScreenBy == 2 && point1.pressed && point2.pressed ) ) )
			{
				var newPos = [0,0];
				screenMoveOffX = offX;
				screenMoveOffY = offY;
				newPos[0] = startMoveX+offX;
				newPos[1] = startMoveY+offY;
				var a = newPos[0] - tmpMoveX;
				var b = newPos[1] - tmpMoveY;
				if ( Math.sqrt(a*a+b*b) >= 10 ) 
				{
					if ( inScreenMoving == 1 ) 
					{
						var scaleXY=wemx.get("ScreenScale").readReal();
						var scaledScreenWidth = pinch_area.width;
						var scaledScreenHeight = pinch_area.height;
						var displayWidth = wemx.get("DisplayWidth").readReal()
						var displayHeight = wemx.get("DisplayHeight").readReal()

						var minLimitX = -1*(scaledScreenWidth-(displayWidth*0.3));
						var maxLimitX = displayWidth*0.7;
						var minLimitY = -1*(scaledScreenHeight-(displayHeight*0.3));
						var maxLimitY = displayHeight*0.7;

						if ( scaleXY < 1 )
						{
							minLimitX = -1*(scaledScreenWidth*0.5);
							maxLimitX = displayWidth-scaledScreenWidth*0.5;
							minLimitY = -1*(scaledScreenHeight*0.5);
							maxLimitY = displayHeight-scaledScreenHeight*0.5;
						}

						offX = (point1.x-point1.startX);
						offY = (point1.y-point1.startY);		

						var absX = startMoveAbsoluteScreenPositionX+offX;
						var absY = startMoveAbsoluteScreenPositionY+offY;
						if ( dbgScreen_on == 1 )
						{
							var displayX = wemx.get("AbsoluteScreenPosition.X").readReal();
							var displayY = wemx.get("AbsoluteScreenPosition.Y").readReal();
							var dispOffX = displayX-startMoveAbsoluteScreenPositionX;
							var dispOffY = displayY-startMoveAbsoluteScreenPositionY;
							
							console.log("Screen Move:  X Range(" + minLimitX.toFixed(2) + ":"+maxLimitX.toFixed(2) +")  Y Range("+minLimitY.toFixed(2) +":"+maxLimitY.toFixed(2) +")");
							console.log("***********:  startMoveAbsoluteScreenPosition:" + startMoveAbsoluteScreenPositionX.toFixed(2)  + "x"+startMoveAbsoluteScreenPositionY.toFixed(2) );
							console.log("***********:  currentAbsoluteScreenPosition:" + displayX.toFixed(2)  + "x"+displayY.toFixed(2) + " OffsetToStart:"+dispOffX.toFixed(2)+"x"+dispOffY.toFixed(2));
							console.log("***********:  off:" + offX.toFixed(2)  + "x"+offY.toFixed(2) +" abs:"+absX.toFixed(2) +"x"+absY.toFixed(2) );
							console.log("***********:  pinch_area:"+pinch_area.width.toFixed(2)+"x"+pinch_area.height.toFixed(2)+" scaleXY="+scaleXY.toFixed(2) +" x_ratio="+x_ratio.toFixed(2) +" y_ratio="+y_ratio.toFixed(2) );
						}
					
						if ( absX < minLimitX )
							offX = offX+minLimitX-absX;
						else if ( absX > maxLimitX ) 	
							offX = offX-(absX-maxLimitX);
							
						if ( absY < minLimitY )
							offY = offY+minLimitY-absY;
						else if ( absY > maxLimitY ) 	
							offY = offY-(absY-maxLimitY);
							
						newPos[0] = startMoveX+offX*x_ratio*scaleXY;
						newPos[1] = startMoveY+offY*x_ratio*scaleXY;
					
						wemx.get("ScreenPosition").writeClass(newPos);
						tmpMoveX = newPos[0];
						tmpMoveY = newPos[1];
						if ( dbgScreen_on == 1 )
						{
							console.log("***********:  Move:" + newPos[0].toFixed(2) + "x"+newPos[1].toFixed(2)+" Off="+offX.toFixed(2)+"x"+offY.toFixed(2)+" evt:"+point1.x.toFixed(2)+"x"+point1.y.toFixed(2)+"  TID:"+point1.pointId);
						}
					}
				}
			}
        }

    }
    
    function pan_onCanceled()
    {    
        if ( usePanArea != 0 )
        {
           if (panStatus) panStatus.writeInteger(4);
		   panActive = 0;
        }
    }
        

        MultiPointTouchArea {
			id: multitouchpoint_area
            //anchors.fill: parent
            maximumTouchPoints:2
            minimumTouchPoints:1
            mouseEnabled:false
            enabled:true
            touchPoints: [
				TouchPoint { id: point1 },
				TouchPoint { id: point2 }
            ]

            onPressed:
			{
                if ( dbg_on == 1 ) 
				{
					var _t_ = new Date().getTime();
					console.log("onPressed ( event:"+point1.x+","+point1.y+") time:"+_t_+" pressed:"+point1.pressed+"  TID:"+point1.pointId);
					console.log("********* ( event:"+point2.x+","+point2.y+") time:"+_t_+" pressed:"+point2.pressed+"  TID:"+point2.pointId);
				}
				
                proTabArea_onPressd();
				screen_startMove();
           }

            onGestureStarted: {
                if ( dbg_on == 1 )
				{
					console.log("onGestureStarted ( event:"+point1.x+","+point1.y+") pressed:"+point1.pressed+"  TID:"+point1.pointId);
					console.log("**************** ( event:"+point2.x+","+point2.y+") pressed:"+point2.pressed+"  TID:"+point2.pointId);
				}
				proTabArea_onCanceled();
                swipe_onPressed();
                pan_onPressed();
             }

            onTouchUpdated:{
                if ( dbg_on == 1 )
				{
					console.log("onTouchUpdated ( event:"+point1.x+","+point1.y+")  pressed:"+point1.pressed+"  TID:"+point1.pointId);
					console.log("************** ( event:"+point2.x+","+point2.y+")  pressed:"+point2.pressed+"  TID:"+point2.pointId);
				}
			}

            onUpdated:{
                if ( dbg_on == 1 )
				{
					console.log("onUpdated ( event:"+point1.x+","+point1.y+")  pressed:"+point1.pressed+"  TID:"+point1.pointId);
					console.log("********* ( event:"+point2.x+","+point2.y+")  pressed:"+point2.pressed+"  TID:"+point2.pointId);
				}
                proTabArea_onUpdates();
                swipe_onUpdated();
                pan_onUpdated();
            }

            onReleased: {
                if ( dbg_on == 1 )
				{
					console.log("onReleased ( event:"+point1.x+","+point1.y+")  pressed:"+point1.pressed+"  TID:"+point1.pointId);
					console.log("********** ( event:"+point2.x+","+point2.y+")  pressed:"+point2.pressed+"  TID:"+point2.pointId);
				}
                proTabArea_onReleased();
                swipe_onReleased();
                pan_onReleased();
            }
                
            onCanceled: {
                //console.log("onCanceled");
				swipe_onCanceled();
                pan_onCanceled();
                proTabArea_onCanceled();
            }
			
			
			PinchArea {
				id: pinch_area
				enabled:true
				anchors.fill: parent
					
				onPinchStarted: {
				
					proTabArea_onCanceled();
					swipe_onCanceled();
					pan_onCanceled();	
					
					if ( usePinchArea != 0 || useScreenScale == 1 || useRotateScreen == 1  || (useMoveScreen == 1 && useMoveScreenBy == 2)) 
					{
						if ( dbg_on == 1 )
							console.log("pinch START");
						
						if ( usePinchArea != 0 && pinchX ) pinchX.writeReal(pinch.point1.x*x_ratio);
						if ( usePinchArea != 0 && pinchY ) pinchY.writeReal(pinch.point1.y*y_ratio);
						if ( usePinchArea != 0 && pinchX2 ) pinchX2.writeReal(pinch.point2.x*x_ratio);
						if ( usePinchArea != 0 && pinchY2 ) pinchY2.writeReal(pinch.point2.y*y_ratio);
						
						pinch_center_x = pinch.startCenter.x;
						pinch_center_y = pinch.startCenter.y;
							
						if (usePinchArea != 0 && pinchCenterX) pinchCenterX.writeReal(pinch_center_x*x_ratio);
						if (usePinchArea != 0 && pinchCenterY) pinchCenterY.writeReal(pinch_center_y*y_ratio);

						if ( dbg_on == 1 )
						{
							var cx = pinch_center_x*x_ratio;
							var cy = pinch_center_y*y_ratio;
							
							console.log("startCenter: " + pinch.startCenter.x + "," + pinch.startCenter.y+"-->"+cx+","+cy+" : "+x_ratio+","+y_ratio);
						}
						
						pinch_Scale = 1;
						pinch_Angle = 0;  
						
						if (usePinchArea != 0 && pinchRotation) pinchRotation.writeReal(0);       
						if (usePinchArea != 0 && pinchStatus) pinchStatus.writeInteger (1);     
						
						if ( useScreenScale == 1 || useRotateScreen == 1  )
						{
							var posArr = [0,0];
							posArr[0]  = pinch_center_x*x_ratio;
							posArr[1] = pinch_center_y*y_ratio;
							wemx.get("ScreenScaleCenter").writeClass(posArr);
						}
						if ( useScreenScale == 1 )
						{
							// ScreenScale,ScreenScaleCenter.X,ScreenScaleCenter.Y
							wemx.get("UseVectorScale").writeInteger(0);
							startScreenScale = wemx.get("ScreenScale").readReal();
						}
						
						if ( useRotateScreen == 1 )
						{
							startAngle = wemx.get("ScreenRotate").readReal();
						}		

						if (useMoveScreen == 1 && useMoveScreenBy == 2 && screenMoveOnPinch == 1)
						{
							if ( inScreenMoving == 0 ) 
							{
								startMoveX = wemx.get("ScreenPosition.X").readReal();
								startMoveY = wemx.get("ScreenPosition.Y").readReal();
								startMoveAbsoluteScreenPositionX = wemx.get("AbsoluteScreenPosition.X").readReal();
								startMoveAbsoluteScreenPositionY = wemx.get("AbsoluteScreenPosition.Y").readReal();
								tmpMoveX=startMoveX;
								tmpMoveY=startMoveY;
								wemx.get("UseVectorScale").writeInteger(0);
								inScreenMoving = 1;
								screenMoveOffX=0;
								screenMoveOffY=0;
							}
						}
					}   
				}
				
				onPinchUpdated: {
					if ( usePinchArea != 0  || useScreenScale == 1 || useRotateScreen == 1 || (useMoveScreen == 1 && useMoveScreenBy == 2)) 
					{   
						var offset = pinch.scale-pinch.previousScale;
						pinch_Scale = pinch_Scale+offset;

						if ( usePinchArea != 0 && pinchOffX )  pinchOffX.writeReal(pinch.point1.x*x_ratio);
						if ( usePinchArea != 0 && pinchOffY ) pinchOffY.writeReal(pinch.point1.y*y_ratio);
						if ( usePinchArea != 0 && pinchOffX2 ) pinchOffX2.writeReal(pinch.point2.x*x_ratio);
						if ( usePinchArea != 0 && pinchOffY2 ) pinchOffY2.writeReal(pinch.point2.y*y_ratio);
						if ( usePinchArea != 0 && pinchOffCenterX ) pinchOffCenterX.writeReal(pinch.center.x*x_ratio);
						if ( usePinchArea != 0 && pinchOffCenterY ) pinchOffCenterY.writeReal(pinch.center.y*y_ratio);
						
						if (usePinchArea != 0 && pinchScale) 
						{
							pinchScale.writeReal(pinch_Scale);     
						}
						
						pinch_Angle = pinch.rotation % 360 ;
						if ( pinch_Angle < 0 )
							pinch_Angle = 360+pinch_Angle;
						if (usePinchArea != 0 && pinchRotation) pinchRotation.writeReal(pinch_Angle);  
						if (usePinchArea != 0 && pinchStatus) pinchStatus.writeInteger (2); 
						
						if ( dbg_on == 1 )
							console.log("pinch updated:  scale=" + pinch.scale + " rotation="+pinch_Angle);
							
						if ( useMoveScreen == 1 && useMoveScreenBy == 2 && screenMoveOnPinch == 1)
						{
							if ( wemx.get("ScreenScale").readReal() >= 1 ) 
							{
								var newPos = [0,0];
								var offX = pinch.center.x - pinch.startCenter.x+screenMoveOffX;
								var offY = pinch.center.y - pinch.startCenter.y+screenMoveOffY;
								newPos[0] = startMoveX+offX;
								newPos[1] = startMoveY+offY;
								var a = newPos[0] - tmpMoveX;
								var b = newPos[1] - tmpMoveY;
								if ( Math.sqrt(a*a+b*b) >= 10 ) 
								{
									if ( inScreenMoving == 1 ) 
									{
										var scaleXY=wemx.get("ScreenScale").readReal();
										var scaledScreenWidth = pinch_area.width;
										var scaledScreenHeight = pinch_area.height;
										var displayWidth = wemx.get("DisplayWidth").readReal()
										var displayHeight = wemx.get("DisplayHeight").readReal()

										var minLimitX = -1*(scaledScreenWidth-(displayWidth*0.3));
										var maxLimitX = displayWidth*0.7;
										var minLimitY = -1*(scaledScreenHeight-(displayHeight*0.3));
										var maxLimitY = displayHeight*0.7;

										if ( scaleXY < 1 )
										{
											minLimitX = -1*(scaledScreenWidth*0.7);
											maxLimitX = displayWidth-scaledScreenWidth*0.3;
											minLimitY = -1*(scaledScreenHeight*0.7);
											maxLimitY = displayHeight-scaledScreenHeight*0.3;
										}

										//offX = (point1.x-point1.startX)*scaleXY;
										//offY = (point1.y-point1.startY)*scaleXY;			
										
										var absX = startMoveAbsoluteScreenPositionX+offX;
										var absY = startMoveAbsoluteScreenPositionY+offY;
										if ( dbgScreen_on == 1 )
										{
											console.log("Screen Move:  minLimitX=" + minLimitX + " maxLimitX="+maxLimitX+" minLimitY="+minLimitY+" maxLimitY = "+maxLimitY);
											console.log("***********:  offX=" + offX + " offY="+offY+" absX="+absX+" absY = "+absY);
										}
									
										if ( absX < minLimitX )
											offX = offX+minLimitX-absX;
										else if ( absX > maxLimitX ) 	
											offX = offX-(absX-maxLimitX);
											
										if ( absY < minLimitY )
											offY = offY+minLimitY-absY;
										else if ( absY > maxLimitY ) 	
											offY = offY-(absY-maxLimitY);
											
										newPos[0] = startMoveX+offX*x_ratio;
										newPos[1] = startMoveY+offY*y_ratio;
									
										wemx.get("ScreenPosition").writeClass(newPos);
										tmpMoveX = newPos[0];
										tmpMoveY = newPos[1];
										if ( dbgScreen_on == 1 )
										{
											console.log("***********:  MoveX=" + newPos[0] + " MoveY="+newPos[1]+" OffX="+offX+" OffY = "+offY+" evt:"+point1.x+"x"+point1.y+"  TID:"+point1.pointId);
											console.log("***********:  minLimitX="+minLimitX+" maxLimitX = "+maxLimitX+" minLimitY="+minLimitY+" maxLimitY = "+maxLimitY);
											console.log("***********:  pinch_area.width="+pinch_area.width+" pinch_area.height="+pinch_area.height+" scaleXY="+scaleXY+" x_ratio="+x_ratio+" y_ratio="+y_ratio);
										}
									}
								}
							}
						}		
						
						if ( useScreenScale == 1 )
						{
							// ScreenScale,ScreenScaleCenter.X,ScreenScaleCenter.Y
							var scaling = startScreenScale*pinch_Scale;
							if ( scaling < minScreenScale )
								scaling = minScreenScale ;
							if ( scaling > maxScreenScale )
								scaling = maxScreenScale;
							if ( dbgScreen_on == 1 )
								console.log("scaling = "+scaling+",minScreenScale="+minScreenScale+",maxScreenScale="+maxScreenScale );
							wemx.get("ScreenScale").writeReal(scaling);
						}	
						if (useRotateScreen == 1)
						{
							wemx.get("ScreenRotate").writeReal((startAngle+pinch_Angle) % 360);
							if ( dbgScreen_on == 1 )
								console.log("ScreenRotate = "+pinch_Angle);
							
						}


					}
				}

				onPinchFinished: {
					if ( usePinchArea != 0  || useScreenScale == 1 || useRotateScreen == 1 || (useMoveScreen == 1 && useMoveScreenBy == 2)) 
					{
						var offset = pinch.scale-pinch.previousScale;
						pinch_Scale = pinch_Scale+offset;
						
						if ( dbg_on == 1 )
							console.log("pinch finished");

						if ( usePinchArea != 0 && pinchOffX )  pinchOffX.writeReal(pinch.point1.x*x_ratio);
						if ( usePinchArea != 0 && pinchOffY ) pinchOffY.writeReal(pinch.point1.y*y_ratio);
						if ( usePinchArea != 0 && pinchOffX2 ) pinchOffX2.writeReal(pinch.point2.x*x_ratio);
						if ( usePinchArea != 0 && pinchOffY2 ) pinchOffY2.writeReal(pinch.point2.y*y_ratio);
						if ( usePinchArea != 0 && pinchOffCenterX ) pinchOffCenterX.writeReal(pinch.center.x*x_ratio);
						if ( usePinchArea != 0 && pinchOffCenterY ) pinchOffCenterY.writeReal(pinch.center.y*y_ratio);

						if (usePinchArea != 0 && pinchScale) 
						{
							pinchScale.writeReal(pinch_Scale);     
						}
						

						if ( useScreenScale == 1 )
						{
							var scaling = startScreenScale*pinch_Scale;
							if ( useVectorScale == 1 ) 
								wemx.get("UseVectorScale").writeInteger(1);
							if ( scaling < minScreenScale )
								scaling = minScreenScale ;
							if ( scaling > maxScreenScale )
								scaling = maxScreenScale;
							wemx.get("ScreenScale").writeReal(scaling);
						}
						if (pinchStatus) pinchStatus.writeInteger (3); 
						pinch_Scale=1;
						
						if ( (useMoveScreen == 1 && useMoveScreenBy == 2) )
						{
							inScreenMoving = 0;
						}
						
						if (  ( useScreenScale == 1 ) || (useMoveScreen == 1 && useMoveScreenBy == 2) || (useRotateScreen == 1) )
							wemx.get("UseVectorScale").writeInteger(1);
					}
				}
			}  			
        }                      
	
	function procDisable() {
		var val;
		if ( multigestureDisable )
		{
			val = multigestureDisable.readInteger();
			if ( val == 1 ) 
			{
				multitouchpoint_area.enabled=false;
				pinch_area.enabled=false;
				wemx.setEventDispatherType(1); 
			}
			else if ( val == 0 ) 
			{
				multitouchpoint_area.enabled=true;
				pinch_area.enabled=true;
				wemx.setEventDispatherType(0); 
			}
			else if ( val == 2 ) 
			{
				multitouchpoint_area.enabled=true;
				pinch_area.enabled=true;
				wemx.setEventDispatherType(2); 
			}
			else
			{
				multitouchpoint_area.enabled=false;
				pinch_area.enabled=false;
				wemx.setEventDispatherType(1); 
			}
		}
	}
	
    function onItemOpened(){
		console.log("GESTURE ONITEMOPEND");
		console.log("pinch_area.width:"+pinch_area.width+",pinch_area.height:"+pinch_area.height);
		
		swipeActive = 0;
		panActive = 0;
		doubletapStartTime = 0;
		createDoubleTap = 0;
		tapStartTime = 0;
		longtapStartTime = 0;
		longtapActive = 0;
		pinch_Scale = 1;
		inScreenMoving = 0;
		screenMoveOffX = 0;
		screenMoveOffY = 0;	
		screenMoveOnPinch = 0;		
		
		if ( useMoveScreen == 1 || useScreenScale == 1 || useRotateScreen == 1 )
			resetScreenOperCallback();
		
		if ( multigestureDisable )
		{
			procDisable();
			multigestureDisable_reg = multigestureDisable.registerChangeNotify(procDisable, null, null)
		}
		else
		{
			wemx.setEventDispatherType(0); 
		}
	}

    function onItemClosed(){
		console.log("GESTURE ONITEMCOLOSED");
		if ( multigestureDisable )
		{
			if ( multigestureDisable_reg )
			{
				multigestureDisable.unregisterChangeNotify(multigestureDisable_reg);
			}
		}
		wemx.setEventDispatherType(0); 
	}        	
	
    onWidthChanged: {
        multitouchpoint_area.width = wemx.width;
		multitouchpoint_area.height = wemx.height;
        pinch_area.width = wemx.width;
		pinch_area.height = wemx.height;
		
		if ( org_width == 0 ) 
			org_width = wemx.width;
			
		x_ratio = org_width/pinch_area.width;
		y_ratio = org_height/pinch_area.height;
	}
   
    onHeightChanged: {
        multitouchpoint_area.width = wemx.width;
		multitouchpoint_area.height = wemx.height;
        pinch_area.width = wemx.width;
		pinch_area.height = wemx.height;
		
		if ( org_height == 0 ) 
			org_height = wemx.height;
			
		x_ratio = org_width/pinch_area.width;
		y_ratio = org_height/pinch_area.height;
    }
	
    Component.onCompleted: {
		//var screen_rect = wemx.getDesktopRect();
		dbg_on = 0;
		dbgScreen_on = 0;
		createDoubleTap = 0;
		org_width = 0;
		org_height = 0;
		
        wemx.conn.itemOpened.connect(onItemOpened)    
        wemx.conn.itemClosed.connect(onItemClosed)		
		
		properties=wemx.getProperties();
		
		console.log("GESTURE Component.onCompleted START");
		//console.log("screen width:"+screen_rect.width+",height:"+screen_rect.height);
		
		multigestureDisable	= wemx.get(properties.tagDisable);	
		
		useTapArea = 0;
		tapX = wemx.get(properties.tapX);
		tapY = wemx.get(properties.tapY);
		tapStatus = wemx.get(properties.tapStatus);
		if ( tapX || tapY || tapStatus )
			useTapArea = 1;

		if ( dbg_on )
			console.log("useTapArea:"+useTapArea);
			
		useLongTapArea = 0;
		longtapX = wemx.get(properties.longtapX);
		longtapY = wemx.get(properties.longtapY);
		longtapStatus = wemx.get(properties.longtapStatus);
		if ( longtapX || longtapY || longtapStatus )
		{
			longtabDelay = wemx.get("LongTabDelay");
			useLongTapArea = 1;
			longtapActive = 0;
		}
		if ( dbg_on )
			console.log("useLongTapArea:"+useLongTapArea);
			

		useDoubleTapArea = 0;
		doubletapX = wemx.get(properties.doubletapX);
		doubletapY = wemx.get(properties.doubletapY);
		doubletapStatus = wemx.get(properties.doubletapStatus);
		if ( doubletapX || doubletapY || doubletapStatus )
		{
			doubletabDelay = wemx.get("DoubleTabDelay");
			useDoubleTapArea = 1;
			createDoubleTap = 0;	
            doubletapStartTime = 0;
		}
		if ( dbg_on )
			console.log("useDoubleTapArea:"+useDoubleTapArea);
			

		useSwipeArea = 0;
        swipeDirection = wemx.get(properties.swipeDirection);
        swipeAngle = wemx.get(properties.swipeAngle);
        swipeStatus = wemx.get(properties.swipeStatus);    
        swipeActive = 0;
        swipe_X = 0;
        swipe_Y = 0;
		if ( swipeDirection || swipeAngle || swipeStatus )
		{
			swipeActive = 0;
			useSwipeArea = 1;
		}
		if ( dbg_on )
			console.log("useSwipeArea:"+useSwipeArea);
			

        usePanArea = 0;
        panStartX = wemx.get(properties.panStartX);
        panStartY = wemx.get(properties.panStartY);
        panOffsetX = wemx.get(properties.panOffsetX);
        panOffsetY = wemx.get(properties.panOffsetY);
        panStatus = wemx.get(properties.panStatus);
		if ( panStartX || panStartY || panOffsetX || panOffsetY || panStatus )
		{
			panActive = 0;
			usePanArea = 1;
		}
		if ( dbg_on )
			console.log("usePanArea:"+usePanArea);
			
 

		usePinchArea = 0;
		
		pinchX = wemx.get(properties.pinchX);
		pinchY = wemx.get(properties.pinchY);
		pinchX2 = wemx.get(properties.pinchX2);
		pinchY2 = wemx.get(properties.pinchY2);
		pinchCenterX = wemx.get(properties.pinchCenterX);
		pinchCenterY = wemx.get(properties.pinchCenterY);
		pinchOffX = wemx.get(properties.pinchOffX);
		pinchOffY = wemx.get(properties.pinchOffY);
		pinchOffX2 = wemx.get(properties.pinchOffX2);
		pinchOffY2 = wemx.get(properties.pinchOffY2);
		pinchOffCenterX = wemx.get(properties.pinchOffCenterX);
		pinchOffCenterY = wemx.get(properties.pinchOffCenterY);		
		pinchScale = wemx.get(properties.pinchScale);
		pinchRotation = wemx.get(properties.pinchRotation);
		pinchStatus = wemx.get(properties.pinchStatus);
		
		if ( pinchScale )
			pinch_Scale = pinchScale.readReal();
		else
			pinch_Scale = 0;
		if ( pinch_Scale == 0 ) 
		{
			pinch_Scale = 1;
			if ( pinchScale )
				pinchScale.writeReal(pinch_Scale);   
		}
		if ( pinchX || pinchY || pinchX2 ||  pinchY2 || pinchCenterX || pinchCenterY || 
			pinchOffX || pinchOffY || pinchOffX2 || pinchOffY2 || pinchOffCenterX ||  pinchOffCenterY ||
			pinchScale || pinchRotation || pinchStatus )
			usePinchArea = 1;
		if ( dbg_on )
			console.log("usePinchArea:"+usePinchArea);
			
		//SCREEN FUNCTION
		
		useScreenScale = 0;
		useVectorScale = 0;
		minScreenScale = 1.0;
		maxScreenScale = 2.0;
		
		if ( properties.useScreenScale )
		{
			if ( properties.useScreenScale == "true" )
				useScreenScale = 1;
		}
		
		if ( useScreenScale == 1 ) 
		{
			if ( properties.useVectorScale )
			{
				if ( properties.useVectorScale == "true" )
					useVectorScale = 1;
			}
			if ( properties.minScreenScale )
			{
				minScreenScale = parseFloat(properties.minScreenScale);
			}
			if ( properties.maxScreenScale )
			{
				maxScreenScale = parseFloat(properties.maxScreenScale);
			}
		}
		
		useMoveScreen = 0;  
		useMoveScreenBy = 0;  
		if ( properties.useMoveScreen )
		{
			if ( properties.useMoveScreen == "true" )
				useMoveScreen = 1;
		}
		if ( useMoveScreen == 1 )
		{
			if ( properties.useMoveScreenBy )
			{
				if ( properties.useMoveScreenBy == "0" )
					useMoveScreenBy = 1;
				if ( properties.useMoveScreenBy == "1" )
					useMoveScreenBy = 2;
			}
			inScreenMoving = 0;
		}
		
		useRevertOriginal = 0;  
		useRevertOriginalBy = 0;  
		if ( properties.useRevertOriginal )
		{
			if ( properties.useRevertOriginal == "true" )
				useRevertOriginal = 1;
		}
		if ( useRevertOriginal == 1 )
		{
			if ( properties.useRevertOriginalBy )
			{
				if ( properties.useRevertOriginalBy == "0" )
					useRevertOriginalBy = 1;
				if ( properties.useRevertOriginalBy == "1" )
					useRevertOriginalBy = 2;
				if ( properties.useRevertOriginalBy == "2" )
					useRevertOriginalBy = 3;
			}
		}
		
		useRotateScreen = 0;  
		if ( properties.useRotateScreen )
		{
			if ( properties.useRotateScreen == "true" )
				useRotateScreen = 1;
		}

		if ( dbg_on )
		{
			console.log("useScreenScale:"+useScreenScale);
			console.log("useVectorScale:"+useVectorScale);
			console.log("minScreenScale:"+minScreenScale);
			console.log("maxScreenScale:"+maxScreenScale);
			console.log("useMoveScreen:"+useMoveScreen);
			console.log("useMoveScreenBy:"+useMoveScreenBy);
			console.log("useRevertOriginal:"+useRevertOriginal);
			console.log("useRevertOriginalBy:"+useRevertOriginalBy);
			console.log("useRotateScreen:"+useRotateScreen);
		}
		
 		console.log("GESTURE Component.onCompleted END");
		
    }
}