window.onload = function () {
	var sid = getCookie("sid");
	if (sid == undefined) {	
		document.getElementById("logoutID").style.visibility = "hidden";
	} else {
		var id = getCookie( "loginid" );
		if (id) {
			document.getElementById("loginInfo").innerHTML = id + " | Logout";
		} else {
			document.getElementById("loginInfo").innerHTML = "Login";
		}
	}
}

window.onunload = function () {
}

function isEmpty(str) {
	if (typeof str === 'string' || str instanceof String)
		return (!str || 0 === str.length);
	return true;
}

function createHttp() {
	if (window.ActiveXObject){
		try {
			return new ActiveXObject("Msxml2.XMLHTTP");
		} catch(e1) {
			try {
				return new ActiveXObject("Microsoft.XMLHTTP");
			}catch(e1){
				return null;
			}
		}
	} else if (window.XMLHttpRequest) {
		return new XMLHttpRequest();	
	}
	
	return null;
}

function request() {
	getData();
}

function getByteLength(s,b,i,c){
	for(b=i=0;c=s.charCodeAt(i++);b+=c>>11?3:c>>7?2:1);
	return b;
}

function getData() {	
	var tag = document.getElementById("address").value;
	var value = document.getElementById("value").value;	
	var data = {};
	var url;
	var json = {};
	
	if (document.location.protocol == 'https:') {
		url = "https://" + window.location.host + "/feeds/tag?tagname=" + tag;	
	}
	else {
		url = "http://" + window.location.host + "/feeds/tag?tagname=" + tag;	
	}
	
	json["value"] = encodeURIComponent(value);

	data = JSON.stringify(json);

    var xmlhttp = createHttp();
    if (!xmlhttp) {
      alert('Giving up :( Cannot create an XMLHTTP instance');
      return;
    }
	
	var sid = getCookie("sid");
	
    xmlhttp.open("PUT", url, true);
	xmlhttp.setRequestHeader("weMX-Auth",sid);	
    xmlhttp.onreadystatechange = function () {
		
        if (xmlhttp.readyState == 4 /* XMLHttpRequest.DONE - ie state problem */) {			
			console.log("xmlhttp.status : " + xmlhttp.status);
			
			if (xmlhttp.status == 200) {
				console.log("xmlhttp.responseText : " + xmlhttp.responseText);
				var json = JSON.parse(xmlhttp.responseText);
				
				if (json == undefined) {
					displayError("wrong data");
					return;
				}
				
				var error = json["error"];
				if (error != undefined) {
					displayError(error);
					return;
				}
				
				displayData(json);
			} else{
				displayError(xmlhttp.responseText);
			}
        }
    }

	xmlhttp.send(data);
}

function displayData(json) {
	var listContainer = document.getElementById("listContainer");

	while (listContainer.firstChild) {
		listContainer.removeChild(listContainer.firstChild);
	}
	
	var listElement = document.createElement("tr");
	listContainer.appendChild(listElement);
	listElement.style.border = "solid";
	listElement.style.borderColor = "#5B5B5B";
	listElement.style.borderWidth = "1px";
	listElement.style.backgroundColor = "#EEEEEE";
	listElement.height = "28px";
	listElement.style.fontSize = "12pt";
	listElement.style.fontWeight = "normal";
	listElement.style.textAlign = "center";

	var listItem = document.createElement("th");
	listItem.style.border = "solid";
	listItem.style.borderColor = "#5B5B5B";
	listItem.style.borderWidth = "1px";
	listItem.innerHTML = "Result";
	listElement.appendChild(listItem);		
	
	listElement = document.createElement("tr");
	listContainer.appendChild(listElement);
	listElement.height = "28px";
	listElement.style.fontSize = "12pt";
	listElement.style.textAlign = "center";

	listItem = document.createElement("td");
	listItem.style.border = "solid";
	listItem.style.borderColor = "#5B5B5B";
	listItem.style.borderWidth = "1px";
	listItem.innerHTML = "OK";
	listElement.appendChild(listItem);
}

function displayError(error) {
	var listContainer = document.getElementById("listContainer");

	while (listContainer.firstChild) {
		listContainer.removeChild(listContainer.firstChild);
	}
				
	var listElement = document.createElement("tr");
	listContainer.appendChild(listElement);
	listElement.style.border = "solid";
	listElement.style.borderColor = "#5B5B5B";
	listElement.style.borderWidth = "1px";
	listElement.style.backgroundColor = "#EEEEEE";
	listElement.height = "28px";
	listElement.style.fontSize = "12pt";
	listElement.style.fontWeight = "normal";
	listElement.style.textAlign = "center";

	var listItem = document.createElement("th");
	listItem.innerHTML = "Error";
	listElement.appendChild(listItem);

	listElement = document.createElement("tr");
	listContainer.appendChild(listElement);
	listElement.height = "28px";
	listElement.style.fontSize = "12pt";
	listElement.style.textAlign = "center";
	
	listItem = document.createElement("td");
	listItem.style.border = "solid";
	listItem.style.borderColor = "#5B5B5B";
	listItem.style.borderWidth = "1px";
	listItem.innerHTML = error;
	listElement.appendChild(listItem);
}

function onLogout() {
	removeCookie("sid");
	removeCookie("loginid");
	location.href = "index.html";
}
