window.onload = function () {
	var sid = getCookie("sid");

	if (sid == undefined) {	
		document.getElementById("logoutID").style.visibility = "hidden";
	} else {
		var id = getCookie( "loginid" );
		if (id) {
			document.getElementById("loginInfo").innerHTML = id + " | Logout";
		} else {
			document.getElementById("loginInfo").innerHTML = "Login";
		}
	}
}

window.onunload = function () {
}

function isEmpty(str) {
	if (typeof str === 'string' || str instanceof String)
		return (!str || 0 === str.length);
	return true;
}

function createHttp() {
	if (window.ActiveXObject){
		try {
			return new ActiveXObject("Msxml2.XMLHTTP");
		} catch(e1) {
			try {
				return new ActiveXObject("Microsoft.XMLHTTP");
			}catch(e1){
				return null;
			}
		}
	} else if (window.XMLHttpRequest) {
		return new XMLHttpRequest();	
	}
	
	return null;
}

function request() {
	getData();
}

function getData() {	
	var path = document.getElementById("path").value;
	var command = document.getElementById("command").value;
	var param1 = document.getElementById("param1").value;	
	var param2 = document.getElementById("param2").value;	

	var json = {};

	json["path"] = path;
	json["command"] = command;
	json["param1"] = param1;
	json["param2"] = param2;

	sendExecuteCommand(json);
}

function sendExecuteCommand(json)
{
	var data = {};
	var url;

	if (document.location.protocol == 'https:') {
		url = "https://" + window.location.host + "/service";
	} else {
		url = "http://" + window.location.host + "/service";
	}
		
	if (isEmpty(json["path"]) || isEmpty(json["command"]))
		return;

	data = JSON.stringify(json);

    var xmlhttp = createHttp();
    if (!xmlhttp) {
      alert('Giving up :( Cannot create an XMLHTTP instance');
      return;
    }
	
	var sid = getCookie("sid");
	
    xmlhttp.open("POST", url, true);
	xmlhttp.setRequestHeader("weMX-Auth",sid);	
    xmlhttp.onreadystatechange = function () {
		
        if (xmlhttp.readyState == 4 /* XMLHttpRequest.DONE - ie state problem */) {			
			console.log("xmlhttp.status : " + xmlhttp.status);
			
			if (xmlhttp.status == 200) {
				console.log("xmlhttp.responseText : " + xmlhttp.responseText);
				var json = JSON.parse(xmlhttp.responseText);
				
				if (json == undefined) {
					displayError("wrong data");
					return;
				}
				
				var error = json["error"];
				if (error != undefined) {
					displayError(error);
					return;
				}
				
				displayData(xmlhttp.responseText);
			} else{
				displayError(xmlhttp.responseText);
			}
        }
    }

    xmlhttp.send(data);	
}

function displayData(responseText) {
	var listContainer = document.getElementById("listContainer");

	while (listContainer.firstChild) {
		listContainer.removeChild(listContainer.firstChild);
	}
	
	var listElement = document.createElement("tr");
	listContainer.appendChild(listElement);
	listElement.style.border = "solid";
	listElement.style.borderColor = "#5B5B5B";
	listElement.style.borderWidth = "1px";
	listElement.style.backgroundColor = "#EEEEEE";
	listElement.height = "28px";
	listElement.style.fontSize = "12pt";
	listElement.style.fontWeight = "normal";
	listElement.style.textAlign = "center";

	var listItem = document.createElement("th");
	listItem.style.border = "solid";
	listItem.style.borderColor = "#5B5B5B";
	listItem.style.borderWidth = "1px";
	listItem.innerHTML = "OK";
	listElement.appendChild(listItem);		
	
	listElement = document.createElement("tr");
	listContainer.appendChild(listElement);
	listElement.height = "28px";
	listElement.style.fontSize = "12pt";
	listElement.style.textAlign = "center";

	listItem = document.createElement("td");
	listItem.style.border = "solid";
	listItem.style.borderColor = "#5B5B5B";
	listItem.style.borderWidth = "1px";
	listItem.innerHTML = responseText;
	listElement.appendChild(listItem);
}

function displayError(error) {
	var listContainer = document.getElementById("listContainer");

	while (listContainer.firstChild) {
		listContainer.removeChild(listContainer.firstChild);
	}
				
	var listElement = document.createElement("tr");
	listContainer.appendChild(listElement);
	listElement.style.border = "solid";
	listElement.style.borderColor = "#5B5B5B";
	listElement.style.borderWidth = "1px";
	listElement.style.backgroundColor = "#EEEEEE";
	listElement.height = "28px";
	listElement.style.fontSize = "12pt";
	listElement.style.fontWeight = "normal";
	listElement.style.textAlign = "center";

	var listItem = document.createElement("th");
	listItem.innerHTML = "Error";
	listElement.appendChild(listItem);

	listElement = document.createElement("tr");
	listContainer.appendChild(listElement);
	listElement.height = "28px";
	listElement.style.fontSize = "12pt";
	listElement.style.textAlign = "center";
	
	listItem = document.createElement("td");
	listItem.style.border = "solid";
	listItem.style.borderColor = "#5B5B5B";
	listItem.style.borderWidth = "1px";
	listItem.innerHTML = error;
	listElement.appendChild(listItem);
}

function onLogout() {
	removeCookie("sid");
	removeCookie("loginid");
	location.href = "index.html";
}
