


/* Change or add a new value in the cache
 * We overwrite the entry if it already exists
 */
 /*
LruCache.prototype.set = function(key, value) {
    var node = new LruCache.prototype.lrunode(key, value);
    if (this.map[key]) {
        this.map[key].value = node.value;
        this.remove(node.key);
    } else {
        if (this.size >= this.limit) {
            delete this.map[this.tail.key];
            this.size--;
            this.tail = this.tail.prev;
            this.tail.next = null;
        }
    }
    this.setHead(node);
};
*/


function LruCache()
{
    this.size = 0;
    this.map = {};
    this.head = null;
    this.tail = null;
}

LruCache.prototype.lrunode = function()
{
/*    this.prev = null;
    this.next = null;*/
}



/* Retrieve a single entry from the cache */
LruCache.prototype.getNode = function(key) {
    var node = this.map[key];
    if ( node ) {
        this.removeNode(node);
        return node;
        
    } else {
        //console.log("Key " + key + " does not exist in the cache.")
        return(null);
    }
};


LruCache.prototype.insertHash = function(node) {
    this.map[node.key] = node;
    this.size++;
}


LruCache.prototype.outTailNode = function() {
    var tailNode = this.tail;
    this.removeNode(tailNode);
    this.map[tailNode.key] = null;
    this.size--;
    return(tailNode);
}


LruCache.prototype.setHeadNode = function(node) {
    node.next = this.head;
    node.prev = null;
    if (this.head !== null) {
        this.head.prev = node;
    }
    this.head = node;
    if (this.tail === null) {
        this.tail = node;
    }
    
//    this.size++;
//    this.map[key] = node;
}


/* Remove a single entry from the cache */
LruCache.prototype.removeNode = function(node) {
//    var node = this.map[key];

    if (node.prev !== null) {
        node.prev.next = node.next;
    } else {
        this.head = node.next;
    }
    if (node.next !== null) {
        node.next.prev = node.prev;
    } else {
        this.tail = node.prev;
    }
    
//    delete this.map[key];
//    this.size--;
};


/* Resets the entire cache - Argument limit is optional to be reset */
/*
LruCache.prototype.removeAll = function(limit) {
    this.size = 0;
    this.map = {};
    this.head = null;
    this.tail = null;
    if (typeof limit == "number") {
        this.limit = limit;
    }
};
*/

