

function LruQueue()
{
    this.mSize = 0;
    this.head = null;
    this.tail = null;
}


LruQueue.prototype.size = function() 
{
    return(this.mSize);
}


LruQueue.prototype.push_back = function(rscOpScript) 
{
    if ( this.tail == null )
    {
        this.tail = this.head = rscOpScript;
        rscOpScript.qNext = rscOpScript;
        rscOpScript.qPrev = rscOpScript;
    }
    else
    {
        rscOpScript.qPrev = this.tail;
        rscOpScript.qNext = this.head;

        this.tail.qNext = rscOpScript;
        this.head.qPrev = rscOpScript;
            
        this.tail = rscOpScript;
    }
    
    this.mSize++;
}


LruQueue.prototype.out = function(rscOpScript) 
{
    if ( this.mSize == 1 )
    {
        this.mSize = 0;
        this.head = this.tail = null;
        return;
    }
    
    rscOpScript.qPrev.qNext = rscOpScript.qNext;
    rscOpScript.qNext.qPrev = rscOpScript.qPrev;

    if ( this.head == rscOpScript )
    {
        this.head = rscOpScript.qNext;
    }
    else if ( this.tail == rscOpScript )
    {
        this.tail = rscOpScript.qPrev;
    }
    
    this.mSize--;
    return;
}


LruQueue.prototype.outFirst = function() 
{   
    if ( this.mSize == 0 )
    {
        return(null);
    }
    
    var rscOpScript = this.head;
    this.out(rscOpScript);
    return(rscOpScript);
}

LruQueue.prototype.outLast = function() 
{
    if ( this.mSize == 0 )
    {
        return(null);
    }
    
    var rscOpScript = this.tail;
    this.out(rscOpScript);
    return(rscOpScript);
}


