

function SubDriver(serviceBlockDriver)
{
    this.serviceBlockDriver = serviceBlockDriver;
}


SubDriver.prototype.executed = function(cmd, args1, args2, cb, connId)
{
//console.log("RDS_BlockDriver --------------   ============ >>> ", cmd );

    switch(cmd)
    {
        case "disConnection":
            this.parentDriver.disConnection(connId, this.slaveEnvIdx);
            break;
            
        case "connect":
            this.parentDriver.connect(cb, this.slaveEnvIdx);
            break;

        case "disconnect":
            this.parentDriver.disconnect(this.slaveEnvIdx);
            break;

        case "setProperty":
            this.parentDriver.setProperty(this.slaveEnvIdx, args1, args2, cb);
            break;

        case "getProperty":
            this.parentDriver.getProperty(this.slaveEnvIdx, args1, cb);
            break;


        case "registerCommBlockStateNotify":
            this.parentDriver.registerCommBlockStateNotify(cb, connId, this.slaveEnvIdx);         
            break;

        // 이하 internal only            
        case "changeNotifyCommBlockSettingMap":
            this.parentDriver.changeNotifyCommBlockSettingMap(args1, cb, this.slaveEnvIdx);
            break;
        
        case "changeNotifyCommBlockExtraSettingMap":
            this.parentDriver.changeNotifyCommBlockExtraSettingMap(args1, cb, this.slaveEnvIdx);
            break;            
    }
}



SubDriver.prototype.init = function(parentDriver, cbName)
{
    this.serviceBlockDriver.registerChangeNotify.connect(parentDriver.doRegisterChangeNotify);
    this.serviceBlockDriver.reregisterChangeNotify.connect(parentDriver.doReregisterChangeNotify);
    this.serviceBlockDriver.write.connect(parentDriver.doWrite);
    this.serviceBlockDriver.activate.connect(parentDriver.doActivate);
    this.serviceBlockDriver.deactivate.connect(parentDriver.doDeactivate);
    

    var slaveEnvIdx = parentDriver.openSlaveEnv(cbName);
    if ( slaveEnvIdx < 0 )
    {
        console.log("RDSDeviceSubMain >> openSlaveEnvIdx() fail...");
        return(false);
    }
    
    this.slaveEnvIdx = slaveEnvIdx;
    this.parentDriver = parentDriver;
    this.serviceBlockDriver.data = this;

    return(true);
}


