

var drvEnv = {}
var inf1;

function WEMXJSAPI1Stub()
{
    this.chId = -1;
}

WEMXJSAPI1Stub.prototype.init = function(serviceDriver, driverPath)
{
    drvEnv.thisPath = driverPath; 

    //var rUrl = Qt.resolvedUrl(path);
    var rPath = "file:///" + driverPath;
    
    var stubStr =   'import QtQuick 2.0;\
                    import com.wemx 1.0;\
                    import "' + rPath + '" as Js;\
                    Item {\
                        function openChannel(drvEnv, openParam) {\
                            return(Js.WEMXDriverAPI1_openChannel(drvEnv, openParam))\
                        }\
                        function openSlaveEnv(chId) {\
                            return(Js.WEMXDriverAPI1_openSlaveEnv(chId))\
                        }\
                        function connect(chId) {\
                            return(Js.WEMXDriverAPI1_connect(chId))\
                        }\
                        function disconnect(chId) {\
                            return(Js.WEMXDriverAPI1_disconnect(chId))\
                        }\
                        function readData(chId, slaveEnvIdx, unitId, address, arrDataBuf, nWords) {\
                            return(Js.WEMXDriverAPI1_readData(chId, slaveEnvIdx, unitId, address, arrDataBuf, nWords))\
                        }\
                        function writeData(chId, slaveEnvIdx, unitId, address, arrDataBuf, nWords) {\
                            return(Js.WEMXDriverAPI1_writeData(chId, slaveEnvIdx, unitId, address, arrDataBuf, nWords))\
                        }\
                        function setProperty(chId, slaveEnvIdx, key, value) {\
                            if ( Js.WEMXDriverAPI1_setProperty == null )\
                            {\
                                return(-10002)\
                            }\
                            return(Js.WEMXDriverAPI1_setProperty(chId, slaveEnvIdx, key, value))\
                        }\
                        function getProperty(chId, slaveEnvIdx, key) {\
                            if ( Js.WEMXDriverAPI1_getProperty == null )\
                            {\
                                return(-10002)\
                            }\
                            return(Js.WEMXDriverAPI1_getProperty(chId, slaveEnvIdx, key))\
                        }\
                        function changeConnParam(chId, devProps) {\
                            if ( Js.WEMXDriverAPI1_changeConnParam == null )\
                            {\
                                return(-10002)\
                            }\
                            return(Js.WEMXDriverAPI1_changeConnParam(chId, devProps))\
                        }\                        
                    }';     // "
                    
    inf1 = Qt.createQmlObject(stubStr, wemx);
    if ( inf1 == null )
    {
        return(-1);
    }
    return(0);
}

WEMXJSAPI1Stub.prototype.open = function(devProperties)
{
/*
    for(var key in devProperties)
    {
        console.log(key, ": ", devProperties[key]);
    }
    */
    
    this.chId = inf1.openChannel(drvEnv, devProperties);
    return(this.chId);
}

WEMXJSAPI1Stub.prototype.openSlaveEnv = function()
{
    if ( this.chId < 0 )
    {
        return(-1);
    }
    return( inf1.openSlaveEnv(this.chId) );
}


// addrInfo.address
// addrInfo.bitOff
// addrInfo.addrBitSize
// addrInfo.devCodeIdx

WEMXJSAPI1Stub.prototype.addressInfo = function(slaveEnvIdx, strAddr)
{
//console.log("WEMXJSAPI1Stub addressInfo 1 >> -------------------- ", slaveEnvIdx, strAddr);

    var tokenList = strAddr.split(":");
    var bitOff = -1;
    var address;

    switch(tokenList.length)
    {
        case 2:
        case 3:
            if ( tokenList[0].toUpperCase() != "W" )
            {
                return(WEMXDRV_E_ERROR);   
            }

            address = parseInt(tokenList[1]);
            if ( address == undefined )
            {
                return(WEMXDRV_E_ERROR);
            }

            if ( tokenList.length == 3 )
            {
                bitOff = parseInt(tokenList[2]);
                if ( bitOff == undefined )
                {
                    return(WEMXDRV_E_ERROR);
                }
                if ( (bitOff < 0) || (bitOff >= 16) )
                {
                    return(WEMXDRV_E_ERROR);
                }
            }            
            break;

        default:
            return(WEMXDRV_E_ERROR);
    }
    
       
 	var addrInfo = {};
	addrInfo.address = address;	
    addrInfo.bitOff = bitOff; 
	addrInfo.addrBitSize = 16
    addrInfo.devCodeIdx = 0;

//console.log("WEMXJSAPI1Stub addressInfo 2 >> -------------------- ", strAddr, address, bitOff);
 
    return(addrInfo);
}


WEMXJSAPI1Stub.prototype.readData = function(slaveEnvIdx, unitId, devCodeIdx, address, arrDataBuf, nBits)
{
    if ( this.chId < 0 )
    {
        return(-1);
    }

    var iRtn = inf1.readData(this.chId, slaveEnvIdx, unitId, address, arrDataBuf, nBits >> 4);
    if ( iRtn < 0 )
    {
        return(iRtn);    
    }
    else
    {
        return(iRtn << 4);    
    }
}

WEMXJSAPI1Stub.prototype.writeData = function(slaveEnvIdx, unitId, devCodeIdx, address, arrDataBuf, nBits)
{
    if ( this.chId < 0 )
    {
        return(-1);
    }

    var iRtn = inf1.writeData(this.chId, slaveEnvIdx, unitId, address, arrDataBuf, nBits >> 4);
    if ( iRtn < 0 )
    {
        return(iRtn);    
    }
    else
    {
        return(iRtn << 4);    
    }
}

WEMXJSAPI1Stub.prototype.connect = function()
{
    if ( this.chId < 0 )
    {
        return(-1);
    }
    
    return( inf1.connect(this.chId) );
}

WEMXJSAPI1Stub.prototype.disconnect = function()
{
    if ( this.chId < 0 )
    {
        return; //(-1);
    }
    
    inf1.disconnect(this.chId);
}



WEMXJSAPI1Stub.prototype.changeDevProperties = function(devProperties)
{
//console.log("WEMXJSAPI1Stub changeConnParam 2 >> -------------------- ");

    if ( this.chId < 0 )
    {
        return(-1);
    }

    return( inf1.changeConnParam(this.chId, devProperties) );
}


WEMXJSAPI1Stub.prototype.setProperty = function(slaveEnvIdx, key, value)
{
//console.log("WEMXJSAPI1Stub setProperty 1 >> -------------------- ", key, value);

    if ( this.chId < 0 )
    {
        return(-1);
    }

    return( inf1.setProperty(this.chId, slaveEnvIdx, key, value) );
}

WEMXJSAPI1Stub.prototype.getProperty = function(slaveEnvIdx, key)
{
//console.log("WEMXJSAPI1Stub getProperty >> -------------------- ", key);

    if ( this.chId < 0 )
    {
        return(-1);
    }    

    return( inf1.getProperty(this.chId, slaveEnvIdx, key) );
}

