.import QtQuick.LocalStorage 2.0 as Sql
.import "WEMXAlarmBackup.js" as Backup


var DATA_TYPE = { BIT:0, DEC16:1, DEC32:2 };
var ALARM_DISPLAY_MODE = { HISTORY:0, LOG:1, ACTIVE:2 };
var DATA_TYPE = { BIT:0, DEC16:1, DEC32:2 };
var ALARM_STATUS_TYPE = { RECOVERY:0, TRIGGER:1, ACK:2, NORMAL:3 };

var TABLE_NAME = [ "", "BLOCK1", "BLOCK2", "BLOCK3", "BLOCK4", "BLOCK5", "BLOCK6", "BLOCK7", "BLOCK8"];
var MODE_NAME = [ "HISTORY", "LOG", "ACTIVE" ];

var alarmBlocks = [];
var alarmDB;

var notifyList = [];

var isBackup = false;
var alarmCtrlHAddr;

var alarmMonitorList = [];

var alarmStatusHAddr;

var messageType = 0;
var textTableHAddr;
var textTableSelIdx;

var pushNotificationService;
var usePushNotification = false;
        

/*
function registerChangeAlarmNotify(targetService, blockNumber, mode)
{

    var notifyEle = { targetService: targetService , blockNumber: blockNumber, mode: mode };
	notifyEle.screenNumber = wemx.getScreenNumber(targetService);
    notifyList.push(notifyEle);

    
    notifyChangeAlarm(blockNumber, mode)
}

function unregisterChangeAlarmNotify(targetService)
{    
    for(var i=0; i < notifyList.length; i++)
    {
        if ( notifyList[i].targetService == targetService )
        {
            notifyList.splice(i, 1);
        }
    }

//console.log("unregisterChanageAlarmNotify ", notifyList.length);    
}
*/

function notifyChangeAlarm(blockNumber, mode)
{
    for(var i=0; i < notifyList.length; i++)
    {
        if ( (notifyList[i].blockNumber == blockNumber) && (notifyList[i].mode == mode) )
        {
            var msg = { kind: "notifyAlarm" } //, count: count};
            wemx.sendMessage(notifyList[i].targetService, msg);
        }
    }
}

function onScreenClosed(screenNumber)
{
//console.log(" onScreenClosed2 >>> ", notifyList.length, screenNumber, uniqueScreenNumber)

    var newList = [];    
    for(var i=0; i < notifyList.length; i++)
    {
        if ( notifyList[i].screenNumber != screenNumber )
        {
            newList.push(notifyList[i]);
        }
    }
    notifyList = newList;
    
//console.log(" onScreenClosed3 >>> ", notifyList.length, screenNumber, uniqueScreenNumber)    
}

function pushAlarmToPushNotificationService(alarm, mode, status, occurTime, recoveryTime, ackTime, message, count, level)
{
    var alarmData = {};
    var dateStr;
    var date;

    if (alarm == undefined || alarm == null)
    {
        return;
    }

    alarmData.block = alarm.alarmBlock.id;

    if (mode === ALARM_DISPLAY_MODE.HISTORY)
    {
        alarmData.type = "history";
    }
    else if (mode === ALARM_DISPLAY_MODE.LOG)
    {
        alarmData.type = "log";
    }
    else if (mode === ALARM_DISPLAY_MODE.ACK)
    {
        alarmData.type = "active";
    }

    if ( occurTime !== 0 )
    {
        date = new Date(occurTime);
        alarmData.time = date.toISOString();
        alarmData.status_type = "trigger";
    }
    else if ( recoveryTime !== 0 )
    {
        date = new Date(recoveryTime);
        alarmData.time = date.toISOString();
        alarmData.status_type = "recovery";
    }
    else
    {
        date = new Date(ackTime);
        alarmData.time = date.toISOString();
        alarmData.status_type = "ack";
    }

    alarmData.message = message;
    alarmData.count = count;
    alarmData.level = level;

    //console.log(">> alarmData: " + JSON.stringify(alarmData));
    //wemx.log_e(">> alarmData: " + JSON.stringify(alarmData));

    var msg = { kind: "appendAlarmPushData" };
    msg.pushData = alarmData;
    wemx.sendMessage(pushNotificationService, msg);
}


function insertRecordPriv(alarm, mode, status, occurTime, recoveryTime, ackTime, message, count, level, tx)
{
//console.log("insertRecordPriv", alarmBlock.mode[mode].currentRecordCount, alarmBlock.mode[mode].limitRecordCount)        
    var alarmBlock = alarm.alarmBlock;
    if ( alarmBlock.mode[mode].currentRecordCount >= alarmBlock.mode[mode].limitRecordCount )
    {
        var sqlCmd = "DELETE FROM " + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] + " WHERE id = (SELECT id FROM " + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] + " LIMIT 1)";
        tx.executeSql(sqlCmd);
    }
    else
    {
        alarmBlock.mode[mode].currentRecordCount++;
    }

    var sqlCmd = "INSERT INTO " + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] + " VALUES(null, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
    tx.executeSql(sqlCmd, [alarm.id, occurTime, recoveryTime, ackTime, mode, status, message, alarm.alarmCount, level]);        

//console.log("DB insert ", alarm.id, occurTime, recoveryTime, ackTime, mode, status, message, alarm.alarmCount, level);
    
    //notifyChangeAlarm(alarmBlock.id, mode);    //, alarmBlock.mode[mode].currentRecordCount);
}

function insertRecord(alarm, mode, status, occurTime, recoveryTime, ackTime, message, count, level)
{
    alarmDB.transaction(
        function(tx) {
            insertRecordPriv(alarm, mode, status, occurTime, recoveryTime, ackTime, message, count, level, tx);
        }
    )

    notifyChangeAlarm(alarm.alarmBlock.id, mode);
}

function insertLogAckRecord(alarmBlock, mode, ackTime, recordId, toBackup)
{
    var alarmRecord;
    var alarmId;
    var message;
    var count;
    var level;
    
    alarmDB.transaction(
        function(tx) {            
            var sqlCmd = "SELECT alarm_id, status, message, count, level FROM " + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] + " WHERE id = ? AND status = ?";
            alarmRecord = tx.executeSql(sqlCmd, [recordId, ALARM_STATUS_TYPE.TRIGGER]);
            
            if ( alarmRecord.rows.length != 1 )
            {
                return;
            }
			
            var row_item = alarmRecord.rows.item(0);
			
            alarmId = row_item.alarm_id;
            message = row_item.message;
            count = row_item.count;
            level = row_item.level;
            
            insertRecordPriv(alarmBlock.alarmList[alarmId], ALARM_DISPLAY_MODE.LOG, ALARM_STATUS_TYPE.ACK, 0, 0, ackTime, message, count, level, tx);
        }
    )

    if ( toBackup == true )
    {
        Backup.insertRecord(alarmBlock.alarmList[alarmId], ALARM_DISPLAY_MODE.LOG, ALARM_STATUS_TYPE.ACK, 0, 0, ackTime, message, count, level);    
    }

    if ( usePushNotification == true )
    {
        pushAlarmToPushNotificationService(alarmBlock.alarmList[alarmId], ALARM_DISPLAY_MODE.LOG, ALARM_STATUS_TYPE.ACK, 0, 0, ackTime, message, count, level);
    }


    notifyChangeAlarm(alarmBlock.id, mode);
}

function insertAllLogAckRecord(alarmBlock, mode, ackTime, toBackup)
{
    var alarmRecord;
    
    alarmDB.transaction(
        function(tx) {            
            var sqlCmd = "SELECT alarm_id, status, message, count, level FROM " + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] + " WHERE status = ?";
            alarmRecord = tx.executeSql(sqlCmd, [ALARM_STATUS_TYPE.TRIGGER]);
            
            for(var i = 0; i < alarmRecord.rows.length; i++) 
            {           
            	var row_item = alarmRecord.rows.item(i);
				
                var alarmId = row_item.alarm_id;
                var message = row_item.message;
                var count = row_item.count;
                var level = row_item.level;
                
                insertRecordPriv(alarmBlock.alarmList[alarmId], ALARM_DISPLAY_MODE.LOG, ALARM_STATUS_TYPE.ACK, 0, 0, ackTime, message, count, level, tx);            
            }
        }
    )

    if ( toBackup == true )
    {
        for(var i = 0; i < alarmRecord.rows.length; i++) 
        {                
        	var row_item = alarmRecord.rows.item(i);
			
            var alarmId = row_item.alarm_id;
            var message = row_item.message;
            var count = row_item.count;
            var level = row_item.level;
            
            Backup.insertRecord(alarmBlock.alarmList[alarmId], ALARM_DISPLAY_MODE.LOG, ALARM_STATUS_TYPE.ACK, 0, 0, ackTime, message, count, level);    
        }
    }

    if ( usePushNotification == true )
    {
        for(var i = 0; i < alarmRecord.rows.length; i++)
        {
            var row_item = alarmRecord.rows.item(i);

            var alarmId = row_item.alarm_id;
            var message = row_item.message;
            var count = row_item.count;
            var level = row_item.level;

            pushAlarmToPushNotificationService(alarmBlock.alarmList[alarmId], ALARM_DISPLAY_MODE.LOG, ALARM_STATUS_TYPE.ACK, 0, 0, ackTime, message, count, level);
        }
    }

    notifyChangeAlarm(alarmBlock.id, mode);
}


function updateAckField(alarmBlock, mode, ackTime, recordId, toBackup)
{
    var alarmRecord;
    var row_item;
    var alarmId;
    var message;
    var count;
    var level;
    
    alarmDB.transaction(
        function(tx) {
            var sqlCmd = "SELECT alarm_id, status, message, count, level FROM " + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] + " WHERE id = ? AND status = ?";
            alarmRecord = tx.executeSql(sqlCmd, [recordId, ALARM_STATUS_TYPE.TRIGGER]);
            if ( alarmRecord.rows.length != 1 )
            {
                return;
            }
        
             sqlCmd = "UPDATE " + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] + " SET ack_time = ?, status = ? WHERE id = ? AND status = ?";
            tx.executeSql(sqlCmd, [ackTime, ALARM_STATUS_TYPE.ACK, recordId, ALARM_STATUS_TYPE.TRIGGER]);
        }
    )
                
    if ( toBackup == true && alarmRecord.rows.length > 0 /*fix #3055*/ )
    {
        row_item = alarmRecord.rows.item(0);
        
        alarmId = row_item.alarm_id;
        message = row_item.message;
        count = row_item.count;
        level = row_item.level;
        
        Backup.insertRecord(alarmBlock.alarmList[alarmId], ALARM_DISPLAY_MODE.LOG, ALARM_STATUS_TYPE.ACK, 0, 0, ackTime, message, count, level);    
    }

    if ( usePushNotification == true && alarmRecord.rows.length > 0 /*fix #3055*/ )
    {
        row_item = alarmRecord.rows.item(0);

        alarmId = row_item.alarm_id;
        message = row_item.message;
        count = row_item.count;
        level = row_item.level;

        pushAlarmToPushNotificationService(alarmBlock.alarmList[alarmId], ALARM_DISPLAY_MODE.LOG, ALARM_STATUS_TYPE.ACK, 0, 0, ackTime, message, count, level);
    }
    
    notifyChangeAlarm(alarmBlock.id, mode);
}

function updateAllAckField(alarmBlock, mode, ackTime, toBackup)
{
    var alarmRecord;
    
    alarmDB.transaction(
        function(tx) {
            var sqlCmd = "SELECT alarm_id, status, message, count, level FROM " + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] + " WHERE status = ?";
            alarmRecord = tx.executeSql(sqlCmd, [ALARM_STATUS_TYPE.TRIGGER]);
            if ( alarmRecord.rows.length < 1 )
            {
                return;
            }
            
             sqlCmd = "UPDATE " + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] + " SET ack_time = ?, status = ? WHERE status = ?";
            tx.executeSql(sqlCmd, [ackTime, ALARM_STATUS_TYPE.ACK, ALARM_STATUS_TYPE.TRIGGER]);            
        }
    )

    if ( toBackup == true )
    {
        for(var i = 0; i < alarmRecord.rows.length; i++) 
        {                
        	var row_item = alarmRecord.rows.item(i);
			
            var alarmId = row_item.alarm_id;
            var message = row_item.message;
            var count = row_item.count;
            var level = row_item.level;
            
            Backup.insertRecord(alarmBlock.alarmList[alarmId], ALARM_DISPLAY_MODE.LOG, ALARM_STATUS_TYPE.ACK, 0, 0, ackTime, message, count, level);    
        }
    }

    if ( usePushNotification == true )
    {
        for(var i = 0; i < alarmRecord.rows.length; i++)
        {
            var row_item = alarmRecord.rows.item(i);

            var alarmId = row_item.alarm_id;
            var message = row_item.message;
            var count = row_item.count;
            var level = row_item.level;

            pushAlarmToPushNotificationService(alarmBlock.alarmList[alarmId], ALARM_DISPLAY_MODE.LOG, ALARM_STATUS_TYPE.ACK, 0, 0, ackTime, message, count, level);
        }
    }
    
    notifyChangeAlarm(alarmBlock.id, mode);
}


    
    



function updateRecoveryField(alarm, mode, recoveryTime)
{
    var alarmBlock = alarm.alarmBlock;
    alarmDB.transaction(
        function(tx) {
             var sqlCmd = "UPDATE " + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] + " SET recovery_time = ?, status = ? WHERE alarm_id = ? AND status != ?";
            var alarmRecord = tx.executeSql(sqlCmd, [recoveryTime, ALARM_STATUS_TYPE.RECOVERY, alarm.id, ALARM_STATUS_TYPE.RECOVERY]);            
        }
    )
    
    notifyChangeAlarm(alarmBlock.id, mode);
}
    

    

    
    





function ackRecord(blockNumber, mode, recordId)
{
//console.log(" Service : ackRecord ", blockNumber, mode, recordId)
    if ( (blockNumber < 1) || (blockNumber > 8) )
    {
        return;
    }
    if ( (mode < ALARM_DISPLAY_MODE.HISTORY) || (mode > ALARM_DISPLAY_MODE.ACTIVE) )
    {
        return;
    }

    var toBackup = false;
    if ( isBackup == true )
    {
        toBackup = true;
    }
    
    var ackTime = new Date().getTime();
    var alarmBlock = alarmBlocks[blockNumber];
    
    if ( (mode == ALARM_DISPLAY_MODE.HISTORY) &&
            (alarmBlock.mode[mode].limitRecordCount > 0) )
    {
//console.log("  ack update..... ")    
        updateAckField(alarmBlock, mode, ackTime, recordId, toBackup);
        toBackup = false;
    }
    
    if ( (mode == ALARM_DISPLAY_MODE.LOG) &&
            (alarmBlock.mode[mode].limitRecordCount > 0) )
    {
//console.log("  ack insert..... ")        
        insertLogAckRecord(alarmBlock, mode, ackTime, recordId, toBackup);
        toBackup = false;
    }
    
    if ( (mode == ALARM_DISPLAY_MODE.ACTIVE) &&
            (alarmBlock.mode[mode].limitRecordCount > 0) )
    {
        updateAckField(alarmBlock, mode, ackTime, recordId, toBackup);
    }    

}

function ackAllRecord(blockNumber, mode)
{
    if ( (blockNumber < 1) || (blockNumber > 8) )
    {
        return;
    }
    if ( (mode < ALARM_DISPLAY_MODE.HISTORY) || (mode > ALARM_DISPLAY_MODE.ACTIVE) )
    {
        return;
    }

    var toBackup = false;
    if ( isBackup == true )
    {
        toBackup = true;
    }
 
    var ackTime = new Date().getTime();
    var alarmBlock = alarmBlocks[blockNumber];
    
    if ( (mode == ALARM_DISPLAY_MODE.HISTORY) &&
            (alarmBlock.mode[mode].limitRecordCount > 0) )
    {
        updateAllAckField(alarmBlock, mode, ackTime, toBackup);
        toBackup = false;
    }
    
    if ( (mode == ALARM_DISPLAY_MODE.LOG) &&
            (alarmBlock.mode[mode].limitRecordCount > 0) )
    {
        insertAllLogAckRecord(alarmBlock, mode, ackTime, toBackup);
        toBackup = false;
    }
    
    if ( (mode == ALARM_DISPLAY_MODE.ACTIVE) &&
            (alarmBlock.mode[mode].limitRecordCount > 0) )
    {
        updateAllAckField(alarmBlock, mode, ackTime, toBackup);
    }
}







function delRecord(blockNumber, mode, recordId)
{
//console.log(" Service: delRecord ", blockNumber, mode, recordId)
    if ( (blockNumber < 1) || (blockNumber > 8) )
    {
        return;
    }
    if ( (mode < ALARM_DISPLAY_MODE.HISTORY) || (mode > ALARM_DISPLAY_MODE.ACTIVE) )
    {
        return;
    }
    var alarmBlock = alarmBlocks[blockNumber];

	alarmDB.transaction(
	    function(tx) {
            var sqlCmd = "DELETE FROM " + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] + " WHERE id = ?";
            tx.executeSql(sqlCmd, [recordId]);

			// DB Ͽ countü ٽ ԻϿ ҴѴ.
            var resultDB = tx.executeSql('SELECT COUNT(*) FROM ' + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode]);
            alarmBlock.mode[mode].currentRecordCount = resultDB.rows.item(0)["COUNT(*)"];
	    }
	)

    notifyChangeAlarm(blockNumber, mode);

/*	
	alarmDB.transaction(
	    function(tx) {
	        var sqlCmd = "SELECT COUNT(*) FROM " + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] + " WHERE id = ?";
	        var alarmRecord = tx.executeSql(sqlCmd, [recordId]);
	        var count = alarmRecord.rows.item(0)["COUNT(*)"];

	//console.log(" Service: delRecord cur record count ", alarmBlock.mode[mode].currentRecordCount, count)            

	        if ( count == 1 )
	        {
	            sqlCmd = "DELETE FROM " + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] + " WHERE id = ?";
	            tx.executeSql(sqlCmd, [recordId]);

	            alarmBlock.mode[mode].currentRecordCount--;
	            
	            notifyChangeAlarm(blockNumber, mode);
	        }            
	    }
	)
*/
}

function delActiveRecord(alarm)
{
    var alarmBlock = alarm.alarmBlock;

    alarmDB.transaction(
        function(tx) {    
            var sqlCmd = "DELETE FROM " + TABLE_NAME[alarmBlock.id] + MODE_NAME[ALARM_DISPLAY_MODE.ACTIVE] + " WHERE alarm_id = ?";
            tx.executeSql(sqlCmd, [alarm.id]);

			// DB Ͽ countü ٽ ԻϿ ҴѴ.
            var resultDB = tx.executeSql('SELECT COUNT(*) FROM ' + TABLE_NAME[alarmBlock.id] + MODE_NAME[ALARM_DISPLAY_MODE.ACTIVE]);
            alarmBlock.mode[ALARM_DISPLAY_MODE.ACTIVE].currentRecordCount = resultDB.rows.item(0)["COUNT(*)"];
        }
    ) 
		
    notifyChangeAlarm(alarmBlock.id, ALARM_DISPLAY_MODE.ACTIVE);

/*    
    alarmDB.transaction(
        function(tx) {
            var sqlCmd = "SELECT COUNT(*) FROM " + TABLE_NAME[alarmBlock.id] + MODE_NAME[ALARM_DISPLAY_MODE.ACTIVE] + " WHERE alarm_id = ?";
            var alarmRecord = tx.executeSql(sqlCmd, [alarm.id]);
            var count = alarmRecord.rows.item(0)["COUNT(*)"];

    //console.log(" Service: delRecord cur record count ", alarmBlock.mode[mode].currentRecordCount, count)            
    
            if ( count == 1 )
            {
                sqlCmd = "DELETE FROM " + TABLE_NAME[alarmBlock.id] + MODE_NAME[ALARM_DISPLAY_MODE.ACTIVE] + " WHERE alarm_id = ?";
                tx.executeSql(sqlCmd, [alarm.id]);

                alarmBlock.mode[ALARM_DISPLAY_MODE.ACTIVE].currentRecordCount--;
                
                notifyChangeAlarm(alarmBlock.id, ALARM_DISPLAY_MODE.ACTIVE);
            }            
        }
    )    
*/
	
}


function delRecoveryRecord(blockNumber, mode)
{
    if ( (blockNumber < 1) || (blockNumber > 8) )
    {
        return;
    }
    if ( (mode < ALARM_DISPLAY_MODE.HISTORY) || (mode > ALARM_DISPLAY_MODE.ACTIVE) )
    {
        return;
    }
    var alarmBlock = alarmBlocks[blockNumber];
    
    alarmDB.transaction(
        function(tx) {
            var sqlCmd = "DELETE FROM " + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] + " WHERE status = ?";
            tx.executeSql(sqlCmd, [ALARM_STATUS_TYPE.RECOVERY]);
            
            var resultDB = tx.executeSql('SELECT COUNT(*) FROM ' + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode]);
            alarmBlock.mode[mode].currentRecordCount = resultDB.rows.item(0)["COUNT(*)"];
        }
    )

    notifyChangeAlarm(blockNumber, mode);    
}

function delAckRecord(blockNumber, mode)
{
    if ( (blockNumber < 1) || (blockNumber > 8) )
    {
        return;
    }
    if ( (mode < ALARM_DISPLAY_MODE.HISTORY) || (mode > ALARM_DISPLAY_MODE.ACTIVE) )
    {
        return;
    }
    var alarmBlock = alarmBlocks[blockNumber];
    
    alarmDB.transaction(
        function(tx) {
            var sqlCmd = "DELETE FROM " + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] + " WHERE status = ?";
            tx.executeSql(sqlCmd, [ALARM_STATUS_TYPE.ACK]);
            
            var resultDB = tx.executeSql('SELECT COUNT(*) FROM ' + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode]);
            alarmBlock.mode[mode].currentRecordCount = resultDB.rows.item(0)["COUNT(*)"];
        }
    )

    notifyChangeAlarm(blockNumber, mode);    
}

function delCountRecord(blockNumber, mode, recordId)
{
    if ( (blockNumber < 1) || (blockNumber > 8) )
    {
        return;
    }
    if ( (mode < ALARM_DISPLAY_MODE.HISTORY) || (mode > ALARM_DISPLAY_MODE.ACTIVE) )
    {
        return;
    }
    var alarmBlock = alarmBlocks[blockNumber];

    alarmDB.transaction(
        function(tx) {
            var sqlCmd = "UPDATE " + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] + " SET count = 0 WHERE id = (SELECT id FROM "+ TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] +" WHERE alarm_id = (SELECT alarm_id FROM "+ TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] +" WHERE id = ?) ORDER BY id DESC LIMIT 1)";
            tx.executeSql(sqlCmd, [recordId]);
        }
    )

    notifyChangeAlarm(blockNumber, mode);    
}


function delAllCountRecord(blockNumber, mode)
{
    if ( (blockNumber < 1) || (blockNumber > 8) )
    {
        return;
    }
    if ( (mode < ALARM_DISPLAY_MODE.HISTORY) || (mode > ALARM_DISPLAY_MODE.ACTIVE) )
    {
        return;
    }
    var alarmBlock = alarmBlocks[blockNumber];

    alarmDB.transaction(
        function(tx) {
            var sqlCmd = "UPDATE " + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] + " SET count = 0 WHERE id IN (SELECT id FROM " + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode] + " GROUP BY alarm_id)";
            tx.executeSql(sqlCmd);
        }
    )

    notifyChangeAlarm(blockNumber, mode);    
}



















function delAllRecord(blockNumber, mode)
{
//console.log(" Service: delAllRecord ", blockNumber, mode)

    if ( (blockNumber < 1) || (blockNumber > 8) )
    {
        return;
    }
    if ( (mode < ALARM_DISPLAY_MODE.HISTORY) || (mode > ALARM_DISPLAY_MODE.ACTIVE) )
    {
        return;
    }
    var alarmBlock = alarmBlocks[blockNumber];
    
    alarmDB.transaction(
        function(tx) {
            var sqlCmd = "DELETE FROM " + TABLE_NAME[alarmBlock.id] + MODE_NAME[mode];
            tx.executeSql(sqlCmd);
        }
    )

    alarmBlock.mode[mode].currentRecordCount = 0;

    notifyChangeAlarm(blockNumber, mode);
}











function getRecord(blockNumber, mode, startPos, count)
{
    if ( (blockNumber < 1) || (blockNumber > 8) )
    {
        return;
    }
    if ( (mode < ALARM_DISPLAY_MODE.HISTORY) || (mode > ALARM_DISPLAY_MODE.ACTIVE) )
    {
        return;
    }

//console.log("getRecord ", blockNumber, mode, startPos, count);
//console.log(TABLE_NAME[blockNumber] + MODE_NAME[mode], count);

    var result = [];
    alarmDB.transaction(
        function(tx) {        
            var sqlCmd = "SELECT * FROM " + TABLE_NAME[blockNumber] + MODE_NAME[mode] + " ORDER BY id DESC LIMIT ?, ?";
            var alarmRecordList = tx.executeSql(sqlCmd, [startPos, count]);
                            
            for(var i = 0; i < alarmRecordList.rows.length; i++) {
                var item = {};
				var row_item = alarmRecordList.rows.item(i);
				
                item.record_id = row_item.id;
                item.status = row_item.status;
                item.message = row_item.message;
                
                var occur = row_item.occur_time;
                var recovery = row_item.recovery_time;
                var ack = row_item.ack_time;
                
                var occurDate = new Date(occur);
                var recoveryDate = new Date(recovery);
                var ackDate = new Date(ack);
                
                if ( item.status == ALARM_STATUS_TYPE.TRIGGER )
                {
                    item.date = (occur == 0) ? "" : occurDate.toLocaleDateString(Qt.locale(), "yy/MM/dd");
                }
                else if ( item.status == ALARM_STATUS_TYPE.RECOVERY )
                {
                    item.date = (recovery == 0) ? "" : recoveryDate.toLocaleDateString(Qt.locale(), "yy/MM/dd");
                }
                else 
                {
                    item.date = (ack == 0) ? "" : ackDate.toLocaleDateString(Qt.locale(), "yy/MM/dd");
                }        
                
                item.occur = (occur == 0) ? "" : occurDate.toLocaleTimeString(Qt.locale(), "hh:mm:ss");
                item.recovery = (recovery == 0) ? "" : recoveryDate.toLocaleTimeString(Qt.locale(), "hh:mm:ss");
                item.ack = (ack == 0) ? "" : ackDate.toLocaleTimeString(Qt.locale(), "hh:mm:ss");
                
                item.count = row_item.count;
                item.level = row_item.level;

/*
                //  ڵ,  ߻ϸ ȵ 
                if ( item.count == undefined )
                {
                    item.count = 0;
                }*/

//console.log(i, ")", item.record_id, item.date, item.occur, item.status, item.message, item.occur, item.count, item.level);                            
                
                result.push(item);    
            }                
        }
    )

//console.log(" getRecord return ");    
    
    return(result);
}    






function getAlarmCount(alarm)
{
    var rtn = 0;
    
    alarmDB.transaction(
        function(tx) {
            for(var mode=ALARM_DISPLAY_MODE.HISTORY; mode <= ALARM_DISPLAY_MODE.ACTIVE; mode++)
            {
                if ( alarm.alarmBlock.mode[mode].limitRecordCount > 0 )
                {
                    var sqlCmd = "SELECT count FROM " + TABLE_NAME[alarm.alarmBlock.id] + MODE_NAME[mode] + " WHERE alarm_id = ? ORDER BY id DESC LIMIT 1";
                    var alarmRecordList = tx.executeSql(sqlCmd, [alarm.id]);

                    if ( alarmRecordList.rows.length > 0 )
                    {
                        rtn = alarmRecordList.rows.item(0).count;
                        break;
                    }
                }
            }
        }
    )

    return(rtn);    
}





var ALARM_MONITORING_DATA_TYPE = { DEC_16BIT:0, HEX_16BIT:1 , DEC_32BIT:2, HEX_32BIT:3, TEXT:4 };
var CHECKED = 2;

function getAlarmMonitoringAddressValue(monitorId)
{
    var value = "";

    var alarmMonitor = alarmMonitorList[monitorId];
    if ( alarmMonitor == undefined )
    {
        return(value);
    }

    if( alarmMonitor.dataType == ALARM_MONITORING_DATA_TYPE.DEC_16BIT)
    {
        value = (alarmMonitor.signType == Qt.Checked) ? alarmMonitor.hAddr.readWord16().toString() : 
            alarmMonitor.hAddr.readUWord16().toString();

        var hasMinus = false;
    
        if (value.indexOf("-",0) != -1)
        {
            value = value.replace("-", "");
            hasMinus = true;
        }

        if (alarmMonitor.digit_visible == CHECKED)
        {
            var len = 5 - (String(value).length+1);
            value = len > 0? new Array(len).join('0')+value : value;

            //value = QString("%1").arg(value, maximumStringCount, '0');
        }
    
        if (value == "0" && alarmMonitor.zero_visible == CHECKED)
        {
            value = "";
        }
        else
        {
            if (alarmMonitor.decimalCount > 0)
            {
                if (value.length < alarmMonitor.decimalCount)
                {
                    var textLength = value.length;
                    for (var i = 0 ; i < alarmMonitor.decimalCount-textLength ; i++)
                    {
                        value = "0" + value;
                    }
                }

                var integerIndex = value.length - alarmMonitor.decimalCount;
                var integer = value.substr(0,integerIndex);
                var point = value.substr(integerIndex, alarmMonitor.decimalCount);

                value = (integer.length == 0 ? "0" : integer) + "." + (point.length == 0 ? "0" : point);
            }
        }

        if (hasMinus)
        {
            value = "-" + value;
        }
    }
    else if(alarmMonitor.dataType == ALARM_MONITORING_DATA_TYPE.HEX_16BIT)
    {
        value = (alarmMonitor.signType == Qt.Checked) ? alarmMonitor.hAddr.readUWord16().toString(16).toUpperCase() : 
            alarmMonitor.hAddr.readUWord16().toString(16);

        var temp = "";
        for (var i = value.length ; i < 4 ; i++)
        {
            temp += "0";
        }

        value = temp + value;
    }
    else if(alarmMonitor.dataType == ALARM_MONITORING_DATA_TYPE.DEC_32BIT)
    {
        value = (alarmMonitor.signType == Qt.Checked) ? alarmMonitor.hAddr.readWord32().toString() : 
            alarmMonitor.hAddr.readUWord32().toString();

        var hasMinus = false;
        if (value.indexOf("-",0) != -1)
        {
            value = value.replace("-", "");
            hasMinus = true;
        }

        if (alarmMonitor.digit_visible == CHECKED)
        {
            var len = 10 - (String(value).length+1);
            value = len > 0? new Array(len).join('0')+value : value;

            //value = QString("%1").arg(value, maximumStringCount, '0');
        }
    
        if (value == "0" && alarmMonitor.zero_visible == CHECKED)
        {
            value = "";
        }
        else
        {
            if (alarmMonitor.decimalCount > 0)
            {
                if (value.length < alarmMonitor.decimalCount)
                {
                    var textLength = value.length;
                    for (var i = 0 ; i < alarmMonitor.decimalCount-textLength ; i++)
                    {
                        value = "0" + value;
                    }
                }

                var integerIndex = value.length - alarmMonitor.decimalCount;
                var integer = value.substr(0,integerIndex);
                var point = value.substr(integerIndex, alarmMonitor.decimalCount);

                value = (integer.length == 0 ? "0" : integer) + "." + (point.length == 0 ? "0" : point);
            }
        }

        if (hasMinus)
        {
            value = "-" + value;
        }
    }
    else if(alarmMonitor.dataType == ALARM_MONITORING_DATA_TYPE.HEX_32BIT)
    {
        value = (alarmMonitor.signType == Qt.Checked) ? alarmMonitor.hAddr.readUWord32().toString(16).toUpperCase() : 
            alarmMonitor.hAddr.readUWord32().toString(16);

        var temp = "";
        for (var i = value.length ; i < 8 ; i++)
        {
            temp += "0";
        }

        value = temp + value;
    }
    else if(alarmMonitor.dataType == ALARM_MONITORING_DATA_TYPE.TEXT)
    {
        if ( alarmMonitor.textCount > 0 )
        {
            value = alarmMonitor.hAddr.readString(alarmMonitor.textCount);
        }
    }

    return value;
}


function makeAlarmMessage(alarm)
{
    var newMessage = "";

    if(alarm.message)
    {
        newMessage = alarm.message;
    }

    var offset = 0;
    while( newMessage.indexOf("%", offset) >= 0 )
    {
        offset = newMessage.indexOf("%", offset);
        if( offset > newMessage.length - 2 )
            return newMessage;

        var monAddrNumber = Number(newMessage.charAt(offset+1));

        if( monAddrNumber != "NaN" )
        {
            if ( monAddrNumber == 0 )
            {
                var newText;

                if ( alarm.dataType == DATA_TYPE.DEC32 )
                {
                    // signed
                    if (alarm.addressSignType == Qt.Checked) 
                    {
                        newText = wemx.get(alarm.addressId).readWord32().toString();
                    }
                    else
                    {
                        newText = wemx.get(alarm.addressId).readUWord32().toString();
                    }
                    
                }
                else if (alarm.dataType == DATA_TYPE.DEC16)
                {
                    // signed
                    if (alarm.addressSignType == Qt.Checked) 
                    {
                        newText = wemx.get(alarm.addressId).readWord16().toString();
                    }
                    else
                    {
                        newText = wemx.get(alarm.addressId).readUWord16().toString();
                    }
                }   
                else // DATA_TYPE.BIT
                {
                    newText = wemx.get(alarm.addressId).readBit();
                }

                var replaceText = newMessage.substr(offset, 2);
                newMessage = newMessage.replace(replaceText, newText);
            }
            else if ( (monAddrNumber >= 1) && (monAddrNumber <= 8) )
            {
                var newText = getAlarmMonitoringAddressValue(alarm.monitorAddressId[monAddrNumber-1]);
                var replaceText = newMessage.substr(offset, 2);
                newMessage = newMessage.replace(replaceText, newText);
            }
        }
        offset++;
    }

    return newMessage;
}


function readAlarmAddress(alarm)
{
	if ( alarm.dataType == DATA_TYPE.BIT )
	{
		var bit = alarm.hAddr.readBit();
		return(bit);
	}
	else
	{
        var readValue;
        if ( alarm.addressSignType == Qt.Checked )
        {
            readValue = (alarm.dataType == DATA_TYPE.DEC16) ? alarm.hAddr.readWord16() : alarm.hAddr.readWord32();
        }
        else
        {
            readValue = (alarm.dataType == DATA_TYPE.DEC16) ? alarm.hAddr.readUWord16() : alarm.hAddr.readUWord32();
        }
		return(readValue);
	}
}


function convertAlarmValue(alarm, u32Value)
{
	if ( alarm.dataType == DATA_TYPE.BIT )
	{
		var bit = (u32Value == 0) ? false : true;
		return(bit);
	}
	else
	{
        var readValue;
        if ( alarm.addressSignType == Qt.Checked )
        {
        	if ( alarm.dataType == DATA_TYPE.DEC16 )
    		{
				if (u32Value > 32767) 
				{
				  readValue = (-65536 + u32Value);
				} 
				else 
				{
				  readValue = u32Value;
				}    			
    		}
			else
			{
				readValue = u32Value >> 0;
			}		
        }
        else
        {
            readValue = u32Value;
        }
		return(readValue);
	}
}


function Alarm()
{
    // level
    // count
    //this.alarmCount = -1;

    this.isOnTrigger = function()
    {
        return(this.m_isOnTrigger);
    }

    this.checkTrigger = function(changedAlarmValue)
    {
        //console.log(" checkTrigger ", this.triggerValue, changedAlarmValue)

        if ( this.dataType == DATA_TYPE.BIT )
        {
            //console.log(" checkTrigger::dataType  ", DATA_TYPE.BIT );
            var bit = changedAlarmValue;	//this.hAddr.readBit();
            if ( bit == this.bitTriggerValue )       // bitTriggerValue = trigger_value == 2 ? 1 : 0;      
            {
        //console.log(" bitTriggerValue :", this.bitTriggerValue, ", bit : ", bit);
                if ( this.m_isOnTrigger )
                {
                    //console.log(" this.m_isOnTrigger :", this.m_isOnTrigger);
                    return(ALARM_STATUS_TYPE.NORMAL);
                }
                else
                {
                    this.m_isOnTrigger = true;
//console.log(" this.m_isOnTrigger :", this.m_isOnTrigger);
                    return(ALARM_STATUS_TYPE.TRIGGER);            
                }            
            }            
        }
        else        
        {    // addressValueType == VALUE_TYPE::WORD_ADDRESS
            var readValue = changedAlarmValue;
			/*
            if ( this.addressSignType == Qt.Checked )
            {
                readValue = (this.dataType == DATA_TYPE.DEC16) ? this.hAddr.readWord16() : this.hAddr.readWord32();
            }
            else
            {
                readValue = (this.dataType == DATA_TYPE.DEC16) ? this.hAddr.readUWord16() : this.hAddr.readUWord32();
            }*/

            if( this.triggerType == 0 ) // trigger type is alarm value
            {
                if( this.rangeType == 0 )
                {
                    if(readValue == this.alarmValue)
                    {
                        if ( this.m_isOnTrigger )
                        {
                            return(ALARM_STATUS_TYPE.NORMAL);
                        }
                        else
                        {
                            this.m_isOnTrigger = true;
                            return(ALARM_STATUS_TYPE.TRIGGER);            
                        }            
                    } 
                }
                else if(this.rangeType == 1)
                {
                    if(readValue < this.alarmValue)
                    {
                        if ( this.m_isOnTrigger )
                        {
                            return(ALARM_STATUS_TYPE.NORMAL);
                        }
                        else
                        {
                            this.m_isOnTrigger = true;
                            return(ALARM_STATUS_TYPE.TRIGGER);            
                        }            
                    } 
                }
                else if(this.rangeType == 2)
                {
                    if(readValue <= this.alarmValue)
                    {
                        if ( this.m_isOnTrigger )
                        {
                            return(ALARM_STATUS_TYPE.NORMAL);
                        }
                        else
                        {
                            this.m_isOnTrigger = true;
                            return(ALARM_STATUS_TYPE.TRIGGER);            
                        }            
                    } 
                }
                else if(this.rangeType == 3)
                {
                    if(readValue != this.alarmValue)
                    {
                        if ( this.m_isOnTrigger )
                        {
                            return(ALARM_STATUS_TYPE.NORMAL);
                        }
                        else
                        {
                            this.m_isOnTrigger = true;
                            return(ALARM_STATUS_TYPE.TRIGGER);            
                        }            
                    } 
                }
                else if(this.rangeType == 4)
                {
                    if(readValue > this.alarmValue)
                    {
                        if ( this.m_isOnTrigger )
                        {
                            return(ALARM_STATUS_TYPE.NORMAL);
                        }
                        else
                        {
                            this.m_isOnTrigger = true;
                            return(ALARM_STATUS_TYPE.TRIGGER);            
                        }            
                    } 
                }
                else if(this.rangeType == 5)
                {
                    if(readValue >= this.alarmValue)
                    {
                        if ( this.m_isOnTrigger )
                        {
                            return(ALARM_STATUS_TYPE.NORMAL);
                        }
                        else
                        {
                            this.m_isOnTrigger = true;
                            return(ALARM_STATUS_TYPE.TRIGGER);            
                        }            
                    } 
                }
                
            }
            else // trigger type is alarm range
            {
                if(this.rangeType == 1) // range type is "low value <= word address value <= upper value"
                {
                    if( (this.lowerValue <= readValue) && (readValue <= this.upperValue) )
                    {
                        if ( this.m_isOnTrigger )
                        {
                            return(ALARM_STATUS_TYPE.NORMAL);
                        }
                        else
                        {
                            this.m_isOnTrigger = true;
                            return(ALARM_STATUS_TYPE.TRIGGER);            
                        }            
                    } 
                }
                else if( this.rangeType == 2 ) // range type is "low value > word address value  or word address value > upper value"
                {
                    if( (this.lowerValue > readValue) || (readValue > this.upperValue) )
                    {
                        if ( this.m_isOnTrigger )
                        {
                            return(ALARM_STATUS_TYPE.NORMAL);
                        }
                        else
                        {
                            this.m_isOnTrigger = true;
                            return(ALARM_STATUS_TYPE.TRIGGER);            
                        }            
                    } 
                }
            }    
        }

        if ( this.m_isOnTrigger )
        {
            this.m_isOnTrigger = false;
            return(ALARM_STATUS_TYPE.RECOVERY);
        }
        return(ALARM_STATUS_TYPE.NORMAL);
    }
    
    
    this.trigger = function()
    {
//console.log(" alarm.trigger ... "); 


        var occurTime = new Date().getTime();

        //if ( this.alarmCount == undefined )
        //{
        //    this.alarmCount = getAlarmCount(this);
        //}
        this.alarmCount = getAlarmCount(this);
        this.alarmCount++;
        
        var makeMessage = makeAlarmMessage(this);
        for(var mode=ALARM_DISPLAY_MODE.HISTORY; mode <= ALARM_DISPLAY_MODE.ACTIVE; mode++)
        {
            if ( this.alarmBlock.mode[mode].limitRecordCount > 0 )
            {
                insertRecord(this, mode, ALARM_STATUS_TYPE.TRIGGER, occurTime, 0, 0, makeMessage, this.alarmCount, this.level);                                
            }
        }

        if ( isBackup == true )
        {
            Backup.insertRecord(this, ALARM_DISPLAY_MODE.LOG, ALARM_STATUS_TYPE.TRIGGER, occurTime, 0, 0, makeMessage, this.alarmCount, this.level);
        }

        if ( usePushNotification == true )
        {
            pushAlarmToPushNotificationService(this, ALARM_DISPLAY_MODE.LOG, ALARM_STATUS_TYPE.TRIGGER, occurTime, 0, 0, makeMessage, this.alarmCount, this.level);
        }
    }

    
    this.recovery = function()
    {
        var recoveryTime = new Date().getTime();

        this.alarmCount = getAlarmCount(this);
        
        var makeMessage = makeAlarmMessage(this);
        
        if ( this.alarmBlock.mode[ALARM_DISPLAY_MODE.HISTORY].limitRecordCount > 0 )
        {
            updateRecoveryField(this, ALARM_DISPLAY_MODE.HISTORY, recoveryTime);
        }
        
        if ( this.alarmBlock.mode[ALARM_DISPLAY_MODE.LOG].limitRecordCount > 0 )
        {
            insertRecord(this, ALARM_DISPLAY_MODE.LOG, ALARM_STATUS_TYPE.RECOVERY, 0, recoveryTime, 0, makeMessage, this.alarmCount, this.level);
        }

        if ( this.alarmBlock.mode[ALARM_DISPLAY_MODE.ACTIVE].limitRecordCount > 0 )
        {
            delActiveRecord(this);
        }            

        if ( isBackup == true )
        {
            Backup.insertRecord(this, ALARM_DISPLAY_MODE.LOG, ALARM_STATUS_TYPE.RECOVERY, 0, recoveryTime, 0, makeMessage, this.alarmCount, this.level);
        }

        if ( usePushNotification == true )
        {
            pushAlarmToPushNotificationService(this, ALARM_DISPLAY_MODE.LOG, ALARM_STATUS_TYPE.RECOVERY, 0, recoveryTime, 0, makeMessage, this.alarmCount, this.level);
        }
    }    
}


function changeAlarmState(alarmBlock)
{
    var alarmBlockTriggerState = false;

    if ( alarmBlock.occurHAddr != undefined )
    {
        var alarmList = alarmBlock.alarmList;
        for(var i=0; i < alarmList.length; i++)
        {
            alarmBlockTriggerState |= alarmList[i].isOnTrigger();
        }

        alarmBlock.occurHAddr.writeBit(alarmBlockTriggerState);
    }


//console.log(" OCCUR Alarm ... ", alarmBlock.occurHAddr, alarmBlockTriggerState);    
}


var MAX_ALARMSERVICE_QUEUING_COUNT 	= 1000;
function changeValueNotifyFunc(shareList, parm2, changedValue)
{
    var state;

//print(" alarm occur : shareList len ", shareList.length, u32ChangedValue );


	var cvCount = wemx.getChangeValueQueuingCount();

//console.log(" --------------Alarm Service  changeValueNotifyFunc ", shareList.length, changedValue, cvCount);

	if ( cvCount > MAX_ALARMSERVICE_QUEUING_COUNT )
	{
		console.log("WANRING) discard a alarm signal because of alarm signal queuing overflow ", cvCount);
		wemx.log_w("WANRING) discard a alarm signal because of alarm signal queuing overflow ");
		return;
	}

	for(var i=0; i < shareList.length; i++)
	{
//console.log(" --------------Alarm Service  changeValueNotifyFunc 2 ", i);

		var alarm = shareList[i];

		var readAlarmValue = changedValue;  //convertAlarmValue(alarm, u32ChangedValue);
	    state = alarm.checkTrigger(readAlarmValue);    
	    if ( state == ALARM_STATUS_TYPE.TRIGGER )
	    {
	        try {       
	            alarm.trigger();      
	        } catch(err) {
	            console.log(" ALARM ERRRR ", err)
	        }        
	    }
	    else if ( state == ALARM_STATUS_TYPE.RECOVERY )
	    {
	        try {
	            alarm.recovery();
	        } catch(err) {
	            console.log(" RECOVERY ERRRR ", err)
	        }            
	    }

	    changeAlarmState(alarm.alarmBlock);
	}
	
//console.log("^^^^      ^^^  alarm occur ...", shareList.length, u32ChangedValue);
}



var reg32hAddrHash = {};
var reg16hAddrHash = {};
var reg1hAddrHash = {};


function loadAlarmList(tx, alarmBlock)
{
    var alarmListDb = tx.executeSql("SELECT alarm_block_information_id, alarm_block_id, alarm_block_information.address_id, trigger_value, trigger_type, \
            alarm_value, upper_value, lower_value, range_type, message, level, count, alarm_block_information.address_display_name,\
            alarm_block_information.address_value_type, alarm_block_information.address_value_length, data_type, address_sign_type, \
            monitor1_address_id, monitor2_address_id, monitor3_address_id, monitor4_address_id, monitor5_address_id, monitor6_address_id, monitor7_address_id, monitor8_address_id \
            FROM alarm_block_information JOIN address ON alarm_block_information.address_id = address.address_id WHERE alarm_block_id = ?", [alarmBlock.id]);
    var alarmList = [];
    
    for(var i = 0; i < alarmListDb.rows.length; i++) 
    {
        var alarm = new Alarm();
        alarm.alarmBlock = alarmBlock;

        var row_item = alarmListDb.rows.item(i);
		
        alarm.id = i;
        alarm.addressId = row_item.address_id;
        alarm.triggerValue = row_item.trigger_value;
        alarm.triggerType = row_item.trigger_type;
        alarm.alarmValue = row_item.alarm_value;
        alarm.upperValue = row_item.upper_value;
        alarm.lowerValue = row_item.lower_value;
        alarm.rangeType = row_item.range_type;
        alarm.skipTrigger = false;

        if ( messageType == 1 )        // text table  
        {
            alarm.textIdx = row_item.message;
            alarm.message = wemx.getTableText(alarm.textIdx);
        }
        else
        {
            alarm.message = row_item.message;
        }
        alarm.level = row_item.level;

        alarm.addressValueType = row_item.address_value_type;
        alarm.addressValueLength = row_item.address_value_length;
        alarm.dataType = row_item.data_type;        
        alarm.addressSignType = row_item.address_sign_type;
        
        alarm.monitorAddressId = [];
        alarm.monitorAddressId[0] = row_item.monitor1_address_id;
        alarm.monitorAddressId[1] = row_item.monitor2_address_id;
        alarm.monitorAddressId[2] = row_item.monitor3_address_id;
        alarm.monitorAddressId[3] = row_item.monitor4_address_id;
        alarm.monitorAddressId[4] = row_item.monitor5_address_id;
        alarm.monitorAddressId[5] = row_item.monitor6_address_id;
        alarm.monitorAddressId[6] = row_item.monitor7_address_id;
        alarm.monitorAddressId[7] = row_item.monitor8_address_id;

        
        alarm.bitTriggerValue = (alarm.triggerValue == 2) ? true : false;
        alarm.m_isOnTrigger = false;        
        
        alarm.hAddr = wemx.get(alarm.addressId);
        if ( alarm.dataType == DATA_TYPE.DEC32 )
        {
            var hAddrShareAlarmList = reg32hAddrHash[alarm.hAddr];
            if ( hAddrShareAlarmList == undefined )
            {
                var shareList = [];
                shareList.push(alarm);
                reg32hAddrHash[alarm.hAddr] = shareList;

                alarm.hAddr.tagRegisterChangeNotify(changeValueNotifyFunc, shareList, null, 
                					( alarm.addressSignType == Qt.Checked ) ? wemx.REQ_INT32 : wemx.REQ_UINT32);	//, wemx, 1000);
            }
            else
            {
                hAddrShareAlarmList.push(alarm);
            }
        }
        else if (alarm.dataType == DATA_TYPE.DEC16)
        {
            var hAddrShareAlarmList = reg16hAddrHash[alarm.hAddr];
            if ( hAddrShareAlarmList == undefined )
            {
                var shareList = [];
                shareList.push(alarm);
                reg16hAddrHash[alarm.hAddr] = shareList;
			        
                alarm.hAddr.tagRegisterChangeNotify(changeValueNotifyFunc, shareList, null, 
										( alarm.addressSignType == Qt.Checked ) ? wemx.REQ_INT16 : wemx.REQ_UINT16);	//, wemx, 1000);
            }
            else
            {
                hAddrShareAlarmList.push(alarm);
            }			
        }   
        else // DATA_TYPE.BIT
        {
            var hAddrShareAlarmList = reg1hAddrHash[alarm.hAddr];
            if ( hAddrShareAlarmList == undefined )
            {
                var shareList = [];
                shareList.push(alarm);
                reg1hAddrHash[alarm.hAddr] = shareList;
			         
                alarm.hAddr.tagRegisterChangeNotify(changeValueNotifyFunc, shareList, null, wemx.REQ_BIT);	//1, wemx, 1000);
            }
            else
            {
                hAddrShareAlarmList.push(alarm);
            }			
        }
        
        //console.log(alarm.addressId, alarm.triggerValue);
            
        alarmList[i] = alarm;
    }
    
    
    alarmBlock.alarmList = alarmList;
}


function loadAlarmMonitoring(tx)
{
    var alarmListDb = tx.executeSql("SELECT * FROM alarm_monitoring");
    for(var i = 0; i < alarmListDb.rows.length; i++) 
    {
        var alarmMonitor = {};
		var row_item = alarmListDb.rows.item(i);
		
        alarmMonitor.id = row_item.alarm_monitoring_id;
        alarmMonitor.addressId = row_item.alarm_monitoring_address_id;
        alarmMonitor.dataType = row_item.alarm_monitoring_data_type;
        alarmMonitor.signType = row_item.alarm_monitoring_sign_type;
        alarmMonitor.decimalCount = row_item.alarm_monitoring_decimal_count;
        alarmMonitor.zeroVisible = row_item.alarm_monitoring_zero_visible;
        alarmMonitor.digitVisible = row_item.alarm_monitoring_digit_visible;
        alarmMonitor.textCount = row_item.alarm_monitoring_text_count;

        if ( alarmMonitor.addressId > 0 )
        {
            alarmMonitor.hAddr = wemx.get(alarmMonitor.addressId);
        }

        alarmMonitorList[alarmMonitor.id] = alarmMonitor;
    }    
}  



function isValidAlarmBlock(alarmBlock)
{
    if ( (alarmBlock.mode[ALARM_DISPLAY_MODE.HISTORY].check == Qt.Checked) 
        || (alarmBlock.mode[ALARM_DISPLAY_MODE.LOG].check == Qt.Checked) 
        || (alarmBlock.mode[ALARM_DISPLAY_MODE.ACTIVE].check == Qt.Checked) )
    {
        return(true);
    }
    else
    {
        return(false);
    }    
}


function alarmBackupControlCallback(hAddr, parm2, changedValue)
{
    isBackup = hAddr.readBit();
    
    if ( isBackup == true )
    {
        alarmStatusHAddr.writeWord16(1);    // 1:  
    }
    else
    {
        alarmStatusHAddr.writeWord16(0);    // 0: ⺻
    }    
}


function textTableChangeCallback(hAddr, parm2, changedValue)
{
    var newSelIdx = hAddr.readWord16();

    if ( textTableSelIdx == newSelIdx )
    {
        return;
    }
    
    textTableSelIdx = newSelIdx;
    
    for(var blkNum=1; blkNum < alarmBlocks.length; blkNum++)
    {
        var alarmList = alarmBlocks[blkNum].alarmList;

        for(var i=0; i < alarmList.length; i++)
        {
            alarmList[i].message = wemx.getTableText(alarmList[i].textIdx);        
        }
    }
}

function initService() 
{
    messageType = wemx.getSettings().getAlarmMessageType();
//console.log("ALARM MESSAGE TYPE ",     messageType);
    if ( messageType == 1 )
    {
        textTableHAddr = wemx.get("$control:TEXT_TABLE");
        textTableSelIdx = textTableHAddr.readWord16();
        textTableHAddr.tagRegisterChangeNotify(textTableChangeCallback, textTableHAddr, null, wemx.REQ_INT16);	//, wemx, 1000);
    }

    
    var db = Sql.LocalStorage.openDatabaseSync("aromaHMI", "1.0", "", 10000000);
    
    db.transaction(
        function(tx) {

            var alarmBlockDb = tx.executeSql('SELECT alarm_block_id, address_count, history_check, history_record, log_check, log_record, active_check, active_record, alarm_occur_address_use_type, alarm_occur_address_id FROM alarm_block ORDER BY alarm_block_id ASC');
            for(var i = 0; i < alarmBlockDb.rows.length; i++) {
                var alarmBlock = {};
				var row_item = alarmBlockDb.rows.item(i);
				
                alarmBlock.id = row_item.alarm_block_id;
                if ( (alarmBlock.id < 1) || (alarmBlock.id > 8) )
                {
                    continue;
                }
                alarmBlock.addressCount = row_item.address_count;
                
                alarmBlock.mode = [];
                var historyMode = {};                
                historyMode.check = row_item.history_check;
                historyMode.limitRecordCount = row_item.history_record;                        
                alarmBlock.mode[ALARM_DISPLAY_MODE.HISTORY] = historyMode;

                var logMode = {};                                
                logMode.check = row_item.log_check;
                logMode.limitRecordCount = row_item.log_record;                        
                alarmBlock.mode[ALARM_DISPLAY_MODE.LOG] = logMode;

                var activeMode = {};                                
                activeMode.check = row_item.active_check;
                activeMode.limitRecordCount = row_item.active_record;                        
                alarmBlock.mode[ALARM_DISPLAY_MODE.ACTIVE] = activeMode;
                
                var occurAddrUseType = row_item.alarm_occur_address_use_type;    
                var occurAddrId = row_item.alarm_occur_address_id;    
//console.log("  occurAddrUseType ", occurAddrUseType);
                if ( occurAddrUseType == Qt.Checked )
                {                
                    alarmBlock.occurHAddr = wemx.get(occurAddrId);
                }
                
                if ( isValidAlarmBlock(alarmBlock) )
                {
                    loadAlarmList(tx, alarmBlock);
                }
                
                alarmBlocks[alarmBlock.id] = alarmBlock;                                                    
            }

            loadAlarmMonitoring(tx);
        }
    )
        
    alarmDB = Sql.LocalStorage.openDatabaseSync("WEMXAlarmRecordDB", "1.0", "alarm record store db", 10000000);
    alarmDB.transaction(
        function(tx) {            
            for(var blkNum=1; blkNum < alarmBlocks.length; blkNum++)
            {
                for(var mode=ALARM_DISPLAY_MODE.HISTORY; mode <= ALARM_DISPLAY_MODE.ACTIVE; mode++)
                {
                    if ( alarmBlocks[blkNum].mode[mode].check == Qt.Checked )
                    {
                        var sqlCmd = 'CREATE TABLE IF NOT EXISTS ' + TABLE_NAME[blkNum] + MODE_NAME[mode] + ' (id INTEGER PRIMARY KEY AUTOINCREMENT, alarm_id INTEGER, occur_time INTEGER, recovery_time INTEGER, ack_time INTEGER, mode INTEGER, status INTEGER, message TEXT, count INTEGET, level INTEGER)'
                        tx.executeSql(sqlCmd);
                                                
                        var resultDB = tx.executeSql('SELECT COUNT(*) FROM ' + TABLE_NAME[blkNum] + MODE_NAME[mode]);
                        var count = resultDB.rows.item(0)["COUNT(*)"];
                        
                        alarmBlocks[blkNum].mode[mode].currentRecordCount = count;


                        var alarmList = alarmBlocks[blkNum].alarmList;
                
                        if (alarmList)
                        {
                            var query = 'SELECT alarm_id FROM (SELECT alarm_id, status FROM ' + TABLE_NAME[alarmBlocks[blkNum].id] + MODE_NAME[mode] + ' GROUP BY alarm_id) WHERE status == ' + ALARM_STATUS_TYPE.TRIGGER + ''//'SELECT alarm_id FROM ' + TABLE_NAME[alarmBlocks[blkNum].id] + MODE_NAME[mode] + ' WHERE recovery_time == 0';
                            var resultDB = tx.executeSql(query);

                            // #3157
                            for(var i=0; i < resultDB.rows.length; i++)
                            {
                                var id = resultDB.rows.item(i).alarm_id;
                                alarmList[id].skipTrigger = true;
                            }
                        }
                    }
                    else
                    {
                        alarmBlocks[blkNum].mode[mode].limitRecordCount = 0;
                    }
                }
            }
        }
    )

    if ( wemx.getSettings().getEnableAlarmBackup() == Qt.Checked )
    {
        if ( wemx.getSettings().getEnableAlarmBackupTrigger() == Qt.Checked )
        {
            alarmCtrlHAddr = wemx.get("$control:ALARM_BACKUP_CONTROL");
            alarmCtrlHAddr.tagRegisterChangeNotify(alarmBackupControlCallback, alarmCtrlHAddr, null, wemx.REQ_BIT);	//, wemx, 1000);

            isBackup = alarmCtrlHAddr.readBit();
        }
        else
        {    
            isBackup = true;
        }        


        alarmStatusHAddr = wemx.get("$control:ALARM_BACKUP_STATUS");        
        if ( isBackup == true )
        {
            alarmStatusHAddr.writeWord16(1);    // 1:  
        }
        else
        {
            alarmStatusHAddr.writeWord16(0);    // 0: ⺻
        }
            
//console.log("  IS BACK UP : ", isBackup);        
        Backup.init();
    }
    

    // #2405 fix
    for(var i = 1 ; i < alarmBlocks.length ; i++)
    {
        var alarmList = alarmBlocks[i].alarmList;
        if (alarmList)
        {
            //console.log("alarmList.length : ", alarmList.length );
            for(var j = 0 ; j < alarmList.length ; j++)
            {
            	var readAlarmValue = readAlarmAddress(alarmList[j]);
            	state = alarmList[j].checkTrigger(readAlarmValue);

            	if ( state == ALARM_STATUS_TYPE.TRIGGER )
            	{
            	    if ( alarmList[j].skipTrigger == false )
            	    {
            	        try {
            	            console.log("alarm.trigger() : ", alarmList[j].addressId);
            	            alarmList[j].trigger();
            	        } catch(err) {
            	            console.log(" ALARM ERRRR ", err)
            	        }
            	    }
            	}
            	else if ( state == ALARM_STATUS_TYPE.NORMAL )
            	{
            	    if ( alarmList[j].skipTrigger == true )
            	    {
            	        try {
            	            alarmList[j].recovery();
            	        } catch(err) {
            	            console.log(" ALARM ERRRR ", err)
            	        }
            	    }
            	}
            }

            changeAlarmState(alarmBlocks[i]);
        }
    }

    usePushNotification = wemx.getSettings().getUsePushNotification();

    wemx.conn.messageReceived.connect(onMessageReceived)       	

    pushNotificationService = wemx.getService("WEMXPushNotificationService");
	
    wemx.setService("WEMXAlarmService", true);  
}

function onMessageReceived(sender, msg) 
{
//console.log(" .................... FAST MESSAGE RECEIVE alarm service.... ", msg.kind);

	switch(msg.kind)
	{
        case "getRecord":
//print(" ----- getRecord ", msg.startPos, msg.count);			
            var resultMsg = { kind: "getRecordResult" };
            resultMsg.result = getRecord(msg.blockNumber, msg.mode, msg.startPos, msg.count);       
			resultMsg.dbAlarmCount = alarmBlocks[msg.blockNumber].mode[msg.mode].currentRecordCount;

//console.log("  ----- !!!   AlarmService getRecord ", resultMsg.result.length, resultMsg.dbAlarmCount);
			
            wemx.sendResponse(sender, resultMsg);
            break;
        
        case "ackRecord":
            ackRecord(msg.blockNumber, msg.mode, msg.recordId);
            break;

        case "ackAllRecord":
            ackAllRecord(msg.blockNumber, msg.mode);
            break;
            
        case "delRecord":
            delRecord(msg.blockNumber, msg.mode, msg.recordId);
            break;

        case "delAllRecord":
            delAllRecord(msg.blockNumber, msg.mode);
            break;
            
        case "delRecoveryRecord":
            delRecoveryRecord(msg.blockNumber, msg.mode);
            break;
            
        case "delAckRecord":
            delAckRecord(msg.blockNumber, msg.mode);
            break;    
            
        case "delCountRecord":
            delCountRecord(msg.blockNumber, msg.mode, msg.recordId);
            break;    
            
        case "delAllCountRecord":
            delAllCountRecord(msg.blockNumber, msg.mode);
            break;        

		default:
			wemx.log_d("WEMXAlarmService>> invalid message " + msg.kind);
			break;
/*	
        case "registerChangeAlarmNotify":
            registerChangeAlarmNotify(sender, msg.blockNumber, msg.mode);	//, msg.uniqueNumber);
            break;
            
        case "unregisterChangeAlarmNotify":
            unregisterChangeAlarmNotify(sender);
            break;			
            */
	}
}



