import QtQuick 2.0
import com.wemx 1.0

Item {
	id: plcDisconnectWrapper;
    
	//anchors.fill: parent;
    
	width:800
	height:480
	visible: false;
	z: 1;

	property int baseHorizontalMargin: 4;	
	property int baseVerticalMargin: 8;	
	property int baseIconWidth: 64 + 48;	
	property int baseIconHeight: 64;	
	property int baseListItemHeight: 20;	
	property int baseTextPointSize: 9;	

	//property real fitScale: 1.0;	
	property int horizontalMargin: 4;	
	property int verticalMargin: 8;	
	property int iconWidth: 64;	
	property int iconHeight: 64;	
	property int listItemHeight: 20;	
	property int textPointSize: 9;	

	property var displayListHash: new Object();

    property var commBlockHash: new Object();
    property var reconnTagList: new Array();
        
	
	Item {
		id: plcDisconnect;
		x: parent.width - iconWidth - horizontalMargin;
		y: verticalMargin;
		width: iconWidth + horizontalMargin;
		height: parent.height - (verticalMargin * 2);

		// signal playSound(int soundType);
		// property string fontFamily: "";
		// property int touchSoundType: 0;
		
		Item {
			id: plcDisconnectView;
			width: iconWidth;
			height: parent.height;

			Image {            
				id: plcDisconnectIcon;
				width: iconWidth;
				height: iconHeight;
				source: "disconnect.png";       
			}

			Item {
				width: iconWidth;
				height: iconHeight;   
			
				MouseArea {
					anchors.fill: parent

					onPressed: {
						// plcDisconnect.playSound(touchSoundType);
					}

					onClicked: {
						reconnect();
						//wemx.connectDrivers();
					}
				}
			}
		
			Rectangle {
				id: plcDisconnectListBG;
				y: iconHeight + verticalMargin;
				width: iconWidth;
				color: "#FF0F0F0F";
			}

			ListModel {
				id: plcDisconnectListModel;
			}

			ListView {
				id: plcDisconnectListView;
				y: iconHeight + verticalMargin;
				width: iconWidth;
				clip: true;
				orientation: ListView.Vertical;
				model: plcDisconnectListModel;
				delegate: plcDisconnectItemDelegate;
			}

			Component {       
				id: plcDisconnectItemDelegate;

				Item {
					width: iconWidth;
					height: listItemHeight;
				
					Rectangle {
						width: iconWidth;
						height: listItemHeight;
						color: "#FF0F0F0F";
						border.color: "#FF999B9D";
					}
				
					Text {
						width: iconWidth;
						height: listItemHeight;
						elide: Text.ElideRight
						horizontalAlignment: Text.AlignHCenter;
 						verticalAlignment: Text.AlignVCenter;
						// font.family: fontFamily;
 						font.bold: true
						//font.pixelSize: getFontPixelSize(parent.width, parent.height)
						font.pointSize: textPointSize;
						clip: true
						text: plcName;
						color: "#FFFFFFFF"
					}
				}
			}
	
			Rectangle {
				id: plcDisconnectListBorder;
				y: iconHeight + verticalMargin;
				width: iconWidth;
				color: "#00000000";
				border.width: 2;
				border.color: "#FF999B9D";
			}
		}
	}

/*		
	function getFontPixelSize(width, height)
	{
		var min = (width > height) ? height : width;
		return( min * 0.6 );
	}*/
	
	
	Timer {
		id: blinkTimer
		interval: 750; 
		repeat: true;
			
		onTriggered: {
			if (plcDisconnectIcon.visible) {
				plcDisconnectIcon.visible = false;
			} else {
				plcDisconnectIcon.visible = true;
			}
		}
	}
	
	function setConnectionState(deviceInfo, stateInfo) {

		horizontalMargin = baseHorizontalMargin;// * fitScale;
		verticalMargin = baseVerticalMargin;// * fitScale;
		iconWidth = baseIconWidth;// * fitScale;
		iconHeight = baseIconHeight;// * fitScale;
		listItemHeight = baseListItemHeight;// * fitScale;
		textPointSize = baseTextPointSize;// * fitScale;

		plcDisconnectWrapper.visible = true;        

//console.log(" --------- DISCONNECTION DISPLAY ", displayinfo, displayListHash[displayinfo]);	
        var insertStr = stateInfo + ":" + deviceInfo;
        if ( displayListHash[deviceInfo] == undefined )
		{			
			plcDisconnectListModel.append({ 'plcName': insertStr });
			displayListHash[deviceInfo] = plcDisconnectListModel.count - 1;
		}
		else
		{			
		    plcDisconnectListModel.set(displayListHash[deviceInfo], { 'plcName': insertStr })
		}


        if ( stateInfo.charAt(0) == 'N' )
        {
            plcDisconnectListModel.remove(displayListHash[deviceInfo], 1);
            displayListHash[deviceInfo] = undefined;            
        }

        if ( plcDisconnectListModel.count == 0 )
        {
    		if (blinkTimer.running) {
    			blinkTimer.stop();
    		}	            
            plcDisconnectWrapper.visible = false;
        }
                
		var itemCount = plcDisconnectListModel.count;
		
		plcDisconnectListBG.height = itemCount * listItemHeight;
		plcDisconnectListBorder.height = itemCount * listItemHeight;
		plcDisconnectListView.height = itemCount * listItemHeight;
		plcDisconnectView.visible = true;

		if (!blinkTimer.running) {

//console.log("blinkTimer start........................................");            
			blinkTimer.start();
		}		
	}



	function reconnect() {
        /*
		displayListHash = {};
		plcDisconnectListModel.clear();
		
		if (blinkTimer.running) {
			blinkTimer.stop();
		}			

		plcDisconnectWrapper.visible = false;*/

        for(var i=0; i < reconnTagList.length; i++)
        {
            reconnTagList[i].tagWriteInt64(1);
        }
	}

    function stateChangeCallback(parm1, parm2, changedValue, timestamp)
    {
        console.log("stateChangeCallback >> ", parm1, parm2, changedValue);

        setConnectionState("[" + parm2 + ":" + parm1 + "]", changedValue);
    }

    
    function setCommBlockStateIcon(msg)
    {
    /*
        var uniqueName = msg.driverName + "%" + msg.commBlockName;
        var commBlock = commBlockHash[uniqueName];
        if ( commBlock == undefined )
        {
            var stateTag = wemx.getTag(msg.stateTagName);
            if ( stateTag == null )
            {
                console.log("setCommBlockStateIcon >> invalid state tag name ", msg.stateTagName);
                return;
            }

            console.log("setCommBlockStateIcon >> invalid state tag name ", msg.commBlockName, msg.execId);
            
            stateTag.tagRegisterChangeNotify(stateChangeCallback, msg.commBlockName, msg.execId);

            var reconnTag = wemx.getTag(msg.reconnTagName);
            reconnTagList.push(reconnTag);
            
            commBlockHash[uniqueName] = true;
        }*/

        //setConnectionState("[" +  ":"  + "]", "*:5");
    }


	function onMessageReceived(sender, msg) 
    {		
    /*
		switch (msg.kind) {
            //case "SET.COMMBLOCK.STATE.ICON":
                //setCommBlockStateIcon(msg);
				break;
		}*/
    }


	Component.onCompleted: {
		console.log(">> start WEMX CommBlock State Display Service...");

		wemx.conn.messageReceived.connect(onMessageReceived);
		wemx.setService("WEMXCommBlockStateDisplayService", true);
	}
}
