.pragma library

var apiVersion = "1.0"

// default 5 minute
var defaultExpireTime = "3000" 

function loginResult(c, has, info) {
	return  {
		code : c,
		hasSession : has,
		session : info
	}
}

function createSession(ver, ip, sessionID, time) {
	return  {
		version : ver, 
		remoteIp : ip,
		createTime : new Date().toUTCString(),
		updateTime : new Date().toUTCString(),
		sid : sessionID,
		timeout : time
	};
}

function isEmpty(str) {
    return (!str || 0 === str.length);
}

function emptyJSON() {	
	var json = {};
	
	json["version"] = apiVersion;
	json["sid"] = "";
	json["timeout"] = "";
	
	return JSON.stringify(json);
}

function sidJSON(sid, out) {
	var json = {};
	
	json["version"] = apiVersion;
	json["sid"] = sid;
	json["timeout"] = out;	
	
	return JSON.stringify(json);
}

function doGet(http, wemx, parames, request, response) {
	var sid = "";
	var expireTime = defaultExpireTime;
	//console.log("responseService() accounts login");

	// Check Serurity Enable
	if (wemx.getSettings().securityEnabled() == 0) {
	
		response.writeHead(200);
		response.setHeader("Content-Type", "application/json; charset=UTF-8");
		response.write(emptyJSON());
		response.end();
		return 200;
		
	} else {
	
		var pw      = parames["pw"];
		var id      = parames["id"];
		//var utc     = parames["utc"];
		var timeout = parames["timeout"];
		
		if (isEmpty(pw)) {
			return 405;
		}
		
		// Normal Login			
		var second = Number(defaultExpireTime);
		if (wemx.getSettings().securityAutoLevelInitEnable() === true) {
			second = wemx.getSettings().securityAutoLevelInitTime() * 60;
			//console.log("securityAutoLevelInitTime : " + second);
		}
	
		if (!isEmpty(timeout)) {
			if (second < Number(timeout)) {
				timeout = String(second);
			}
		} else {
			timeout = 0;
		}
		
		//utc = new Date().toUTCString();
		expireTime = timeout;		
		
		if (wemx.login(parames["pw"], parames["id"]) === false) {
			return 401;
		}

		//var srcData = parames["id"] + pw + utc;
		var srcData = parames["id"] + pw;
		
		var sid = http.createSession(request.remoteAddress, srcData, Number(expireTime));
		var json = sidJSON(sid, timeout);
		//console.log("response body :" + json);
		
		response.setHeader("Content-Type", "application/json; charset=UTF-8;");
		response.setHeader("Connection", request.getHeaderHash("Connection"));
		response.setHeader("Keep-Alive", "timeout=5, max=100");
		response.setHeader("Content-Length", json.length);
		response.writeHead(200);		
		
		response.write(json);
		response.end();
		
		return 200;
	}
}

function doPost(http, wemx, parames, request, response) {
	return 410
}

function doPut(http, wemx, parames, request, response) {
	return 410
}

function doDelete(http, wemx, parames, request, response) {
	return 410
}