var alarmJson;
var totalCount = 0;
var pagePerCount = 10;
var currentPage = 0;
var alarmType;
var blockNumber = "1";

var ackItems = undefined;
var delItems = undefined;

window.onload = function () {
	var sid = getCookie("sid");
	if (sid == undefined) {	
		document.getElementById("logoutID").style.visibility = "hidden";
	} else {
		var id = getCookie( "loginid" );
		if (id) {
			document.getElementById("loginInfo").innerHTML = id + " | Logout";
		} else {
			document.getElementById("loginInfo").innerHTML = "Logout";
		}
	}
}

window.onunload = function () {
}

function isEmpty(str) {
	if (typeof str === 'string' || str instanceof String)
		return (!str || 0 === str.length);
	return true;
}

function createHttp() {
	if (window.ActiveXObject){
		try {
			return new ActiveXObject("Msxml2.XMLHTTP");
		} catch(e1) {
			try {
				return new ActiveXObject("Microsoft.XMLHTTP");
			}catch(e1){
				return null;
			}
		}
	} else if (window.XMLHttpRequest) {
		return new XMLHttpRequest();	
	}
	
	return null;
}

function request() {
	currentPage = 0;
	ackItems = undefined;
	delItems = undefined;
	getData(0);
}

function onAcknowledged() {
	if (ackItems != undefined) {
		return;
	}
	
	console.log("onAcknowledged");
	
	var items = [];	
	
	var count = alarmJson["count"];
	var results = alarmJson["results"];
	
	for (var i = 0; i < count; i++)
	{
		var alarms = document.getElementById("check" + i);
		if (alarms === undefined)
			continue;
		
		if (alarms.checked) {
			items.push(results[i].id.toString());
		}
	}
	
	console.log("items.length : " + items.length);
	if (items.length > 0) {
		ackItems = items;
		doAck();
	}
}

function doAck() {
	console.log("doAck() ackItems.length : " + ackItems.length);
	if (ackItems.length > 0) {
		var id = ackItems.pop();
		console.log("ackItems.length : " + ackItems.length);
		sendAcknowledged(id);
	}
}

function doDel() {
	console.log("doDel() delItems.length : " + delItems.length);
	if (delItems.length > 0) {
		var id = delItems.pop();
		console.log("delItems.length : " + delItems.length);
		sendDelete(id);
	}
}

function onDelete() {
	if (delItems != undefined) {
		return;
	}
	console.log("onDelete");
	
	var items = [];
	
	
	var results = alarmJson["results"];
	var count = alarmJson["count"];
	for (var i = 0; i < count; i ++)
	{
		var alarms = document.getElementById("check" + i);
		if (alarms === undefined)
			continue;
		
		if (alarms.checked) {
			items.push(results[i].id.toString());
		}
	}
	
	console.log("items.length : " + items.length);
	if (items.length > 0) {
		delItems = items;
		doDel();
	}
}

function sendAcknowledged(id) {
	console.log("sendAcknowledged : " + id);
	var url = "http://" + window.location.host + "/feeds/alarm/" + alarmType + "?block=" + blockNumber + "&id=" + id;

    var xmlhttp = createHttp();
    if (!xmlhttp) {
      alert('Giving up :( Cannot create an XMLHTTP instance');
      return;
    }
	
	var sid = getCookie("sid");
	
    xmlhttp.open("PUT", url, true);
	xmlhttp.setRequestHeader("weMX-Auth",sid);	
    xmlhttp.onreadystatechange = function () {
		
        if (xmlhttp.readyState == 4 /* XMLHttpRequest.DONE - ie state problem */) {			
			console.log("xmlhttp.status : " + xmlhttp.status);			
			
			if (xmlhttp.status == 200) {
				console.log(xmlhttp.responseText);
				if (ackItems != undefined && ackItems.length > 0) {
					setTimeout(doAck, 1);
				} else {
					ackItems = undefined;
					setTimeout(goCurrentPage, 1);
				}
			} else{
				displayError(xmlhttp.responseText);
			}
        }
    }

    xmlhttp.send();
}

function sendDelete(id) {	
	var url = "http://" + window.location.host + "/feeds/alarm/" + alarmType + "?block=" + blockNumber + "&id=" + id;	
	
    var xmlhttp = createHttp();
    if (!xmlhttp) {
      alert('Giving up :( Cannot create an XMLHTTP instance');
      return;
    }
	
	var sid = getCookie("sid");
	
    xmlhttp.open("DELETE", url, true);
	xmlhttp.setRequestHeader("weMX-Auth",sid);	
    xmlhttp.onreadystatechange = function () {
		
        if (xmlhttp.readyState == 4 /* XMLHttpRequest.DONE - ie state problem */) {			
			console.log("xmlhttp.status : " + xmlhttp.status);
			
			if (xmlhttp.status == 200) {
				console.log(xmlhttp.responseText);
				if (delItems != undefined && delItems.length > 0) {
					setTimeout(doDel, 1);
				} else {
					delItems = undefined;
					setTimeout(goCurrentPage, 1);
				}
			} else{
				displayError(xmlhttp.responseText);
			}
        }
    }

    xmlhttp.send();
}

function getFilter() {
	var filter = "";
	var message = document.getElementById("message");
	if (message != undefined && message.checked) {	
		filter += "message";
	}
	
	var status = document.getElementById("status");
	if (status != undefined && status.checked) {
		if (filter.length > 0) {
			filter += ",";
		}
		filter += "status";
	}
	
	var triggered = document.getElementById("triggered");
	if (triggered != undefined && triggered.checked) {
		if (filter.length > 0) {
			filter += ",";
		}
		filter += "triggered";
	}
	
	var acknowledged = document.getElementById("acknowledged");
	if (acknowledged != undefined && acknowledged.checked) {
		if (filter.length > 0) {
			filter += ",";
		}
		filter += "acknowledged";
	}
	
	var recovered = document.getElementById("recovered");
	if (recovered != undefined && recovered.checked) {
		if (filter.length > 0) {
			filter += ",";
		}
		filter += "recovered";
	}
	
	var count = document.getElementById("count");
	if (count != undefined && count.checked) {
		if (filter.length > 0) {
			filter += ",";
		}
		filter += "count";
	}
	
	var level = document.getElementById("level");
	if (level != undefined && level.checked) {
		if (filter.length > 0) {
			filter += ",";
		}
		filter += "level";
	}
	
	return filter;
}

function getData(page) {
	var blockNo = document.getElementById("blockno").value;
	var type = document.getElementById("type").value;
	var row  = document.getElementById("row").value;
	var filter = getFilter();
	
	pagePerCount = Number(row);
	alarmType = type;
	
	blockNumber = blockNo;//.value.toString();
	
	var startIndex = page * pagePerCount;
	var time = new Date().getTime();
	var url = "http://" + window.location.host + "/feeds/alarm/" + type + "?block=" + blockNumber + "&startindex=" + startIndex + "&count=" + row + "&filters=" + filter + "&time=" + time.toString();
	
    var xmlhttp = createHttp();
    if (!xmlhttp) {
      alert('Giving up :( Cannot create an XMLHTTP instance');
      return;
    }
	
	var sid = getCookie("sid");
	
    xmlhttp.open("GET", url, true);
	xmlhttp.setRequestHeader("weMX-Auth",sid);	
    xmlhttp.onreadystatechange = function () {
		
        if (xmlhttp.readyState == 4 /* XMLHttpRequest.DONE - ie state problem */) {			
			console.log("xmlhttp.status : " + xmlhttp.status);
			
			if (xmlhttp.status == 200) {
				console.log(xmlhttp.responseText);
				var json = JSON.parse(xmlhttp.responseText);
				
				if (json == undefined) {
					displayError("wrong data");
					return;
				}
				
				var error = json["error"];
				if (error != undefined) {
					displayError(error);
					return;
				}
				
				alarmJson = json;
				totalCount = Number(alarmJson["total"]);
				
				console.log( "totalCount : " + totalCount );
				
				var div = document.getElementById("buttonDiv");
				if (totalCount > 0) {	
					div.style.display = "block";
				} else {
					div.style.display = "none";
				}
				
				displayData(alarmJson);
				showPage(currentPage + 1);
			} else{
				displayError(xmlhttp.responseText);
			}
        }
    }

    xmlhttp.send();
}

function onCheck() {
	console.log("onCheck()");
	var results = alarmJson["results"];
	var count = alarmJson["count"];
	var index = 1;
	
	var allItem = document.getElementById("checkall");
	
	for (var i = 0; i < count; i ++)
	{
		var alarms = document.getElementById("check" + i);
		if (alarms == undefined)
			continue;
		
		alarms.checked = allItem.checked;
	}
}

function displayData(json) {
	var listContainer = document.getElementById("listContainer");

	while (listContainer.firstChild) {
		listContainer.removeChild(listContainer.firstChild);
	}
	
	var listElement = document.createElement("tr");
	listContainer.appendChild(listElement);
	listElement.style.border = "solid";
	listElement.style.borderColor = "#5B5B5B";
	listElement.style.borderWidth = "1px";
	listElement.style.backgroundColor = "#EEEEEE";
	listElement.height = "28px";
	listElement.style.fontSize = "12pt";
	listElement.style.fontWeight = "normal";
	listElement.style.textAlign = "center";	

	var listItem = document.createElement("th");
	listItem.style.border = "solid";
	listItem.style.borderColor = "#5B5B5B";
	listItem.style.borderWidth = "1px";
	var checkboxItem = document.createElement("input");
	checkboxItem.type = "checkbox";
	checkboxItem.id = "checkall";
	checkboxItem.onclick = onCheck;
	//checkboxItem.disabled = true;
	listItem.appendChild(checkboxItem);	
	listElement.appendChild(listItem);

	var message = document.getElementById("message");
	if (message != undefined && message.checked) {	
		listItem = document.createElement("th");
		listItem.style.border = "solid";
		listItem.style.borderColor = "#5B5B5B";
		listItem.style.borderWidth = "1px";
		listItem.innerHTML = "Message";
		listElement.appendChild(listItem);
	}

	var st = document.getElementById("status");
	if (st != undefined && st.checked) {
		listItem = document.createElement("th");
		listItem.style.border = "solid";
		listItem.style.borderColor = "#5B5B5B";
		listItem.style.borderWidth = "1px";
		listItem.innerHTML = "Status";
		listElement.appendChild(listItem);
	}

	var triggered = document.getElementById("triggered");
	if (triggered != undefined && triggered.checked) {
		listItem = document.createElement("th");
		listItem.style.border = "solid";
		listItem.style.borderColor = "#5B5B5B";
		listItem.style.borderWidth = "1px";
		listItem.innerHTML = "Triggered";
		listElement.appendChild(listItem);
	}
	
	var acknowledged = document.getElementById("acknowledged");
	if (acknowledged != undefined && acknowledged.checked) {
		listItem = document.createElement("th");
		listItem.style.border = "solid";
		listItem.style.borderColor = "#5B5B5B";
		listItem.style.borderWidth = "1px";
		listItem.innerHTML = "Acknowledged";
		listElement.appendChild(listItem);
	}
	
	var recovered = document.getElementById("recovered");
	if (recovered != undefined && recovered.checked) {
		listItem = document.createElement("th");
		listItem.style.border = "solid";
		listItem.style.borderColor = "#5B5B5B";
		listItem.style.borderWidth = "1px";
		listItem.innerHTML = "Recovered";
		listElement.appendChild(listItem);
	}
	
	var count = document.getElementById("count");
	if (count != undefined && count.checked) {
		listItem = document.createElement("th");
		listItem.style.border = "solid";
		listItem.style.borderColor = "#5B5B5B";
		listItem.style.borderWidth = "1px";
		listItem.innerHTML = "Count";
		listElement.appendChild(listItem);
	}
	
	var level = document.getElementById("level");
	if (level != undefined && level.checked) {
		listItem = document.createElement("th");
		listItem.style.border = "solid";
		listItem.style.borderColor = "#5B5B5B";
		listItem.style.borderWidth = "1px";
		listItem.innerHTML = "Level";
		listElement.appendChild(listItem);
	}

	var results = alarmJson["results"];
	var resultCount = alarmJson["count"];
	
	for (var i = 0 ; i < resultCount ; i++) {
	
		var listElement = document.createElement("tr");
		listContainer.appendChild(listElement);
		listElement.height = "36px";
		listElement.style.fontSize = "10pt";
		
		var listItem = document.createElement("td");
		listItem.style.border = "solid";
		listItem.style.borderColor = "#5B5B5B";
		listItem.style.borderWidth = "1px";
	
		var checkboxItem = document.createElement("input");
		checkboxItem.type = "checkbox";
		checkboxItem.id = "check" + i;
		checkboxItem.name = "alarm"
		listItem.align = "center";
		listItem.appendChild(checkboxItem);
		listElement.appendChild(listItem);

		if (message != undefined && message.checked) {	
			listItem = document.createElement("td");
			listItem.style.border = "solid";
			listItem.style.borderColor = "#5B5B5B";
			listItem.style.borderWidth = "1px";
			listItem.innerHTML = decodeURIComponent(results[i].message);
			listItem.marginLeft = "2px";
			listElement.appendChild(listItem);
		}

		if (st != undefined && st.checked) {
			listItem = document.createElement("td");
			listItem.style.border = "solid";
			listItem.style.borderColor = "#5B5B5B";
			listItem.style.borderWidth = "1px";
			listItem.innerHTML = results[i].status;
			listItem.align = "center";
			listElement.appendChild(listItem);
		}

		if (triggered != undefined && triggered.checked) {
			listItem = document.createElement("td");
			listItem.style.border = "solid";
			listItem.style.borderColor = "#5B5B5B";
			listItem.style.borderWidth = "1px";
			listItem.innerHTML = results[i].triggered;
			listItem.align = "center";
			listElement.appendChild(listItem);
		}

		if (acknowledged != undefined && acknowledged.checked) {
			listItem = document.createElement("td");
			listItem.style.border = "solid";
			listItem.style.borderColor = "#5B5B5B";
			listItem.style.borderWidth = "1px";
			listItem.innerHTML = results[i].acknowledged;
			listItem.align = "center";
			listElement.appendChild(listItem);
		}
		
		if (recovered != undefined && recovered.checked) {
			listItem = document.createElement("td");
			listItem.style.border = "solid";
			listItem.style.borderColor = "#5B5B5B";
			listItem.style.borderWidth = "1px";
			listItem.innerHTML = results[i].recovered;
			listItem.align = "center";
			listElement.appendChild(listItem);
		}
		
		if (count != undefined && count.checked) {
			listItem = document.createElement("td");
			listItem.style.border = "solid";
			listItem.style.borderColor = "#5B5B5B";
			listItem.style.borderWidth = "1px";
			listItem.innerHTML = results[i].count;
			listItem.align = "center";
			listElement.appendChild(listItem);
		}
		
		if (level != undefined && level.checked) {
			listItem = document.createElement("td");
			listItem.style.border = "solid";
			listItem.style.borderColor = "#5B5B5B";
			listItem.style.borderWidth = "1px";
			listItem.innerHTML = results[i].level;
			listItem.align = "center";
			listElement.appendChild(listItem);
		}
	}
}

function displayError(error) {
	var pageNavi = document.getElementById("pageNavi");
	if (pageNavi) {
		pageNavi.style.visibility = "hidden";
	}

	console.log("displayError()");
	var listContainer = document.getElementById("listContainer");

	while (listContainer.firstChild) {
		listContainer.removeChild(listContainer.firstChild);
	}
				
	var listElement = document.createElement("tr");
	listContainer.appendChild(listElement);
	listElement.style.border = "solid";
	listElement.style.borderColor = "#5B5B5B";
	listElement.style.borderWidth = "1px";
	listElement.style.backgroundColor = "#EEEEEE";
	listElement.height = "28px";
	listElement.style.fontSize = "12pt";
	listElement.style.fontWeight = "normal";
	listElement.style.textAlign = "center";

	var listItem = document.createElement("th");
	listItem.innerHTML = "Error";
	listElement.appendChild(listItem);

	listElement = document.createElement("tr");
	listContainer.appendChild(listElement);
	listElement.height = "28px";
	listElement.style.fontSize = "12pt";
	listElement.style.textAlign = "center";
	
	listItem = document.createElement("td");
	listItem.style.border = "solid";
	listItem.style.borderColor = "#5B5B5B";
	listItem.style.borderWidth = "1px";
	listItem.innerHTML = error;
	listElement.appendChild(listItem);
}

function goPrevBlockPage() {
	currentPage = currentPage - 10;
	if (currentPage < 0) {
		currentPage = 0;
	}
		
	getData(currentPage + 1);
}

function goPrevPage() {
	if (currentPage == 0) {
		return;
	}
		
	currentPage = currentPage - 1;;
	if (currentPage < 0) {
		currentPage = 0;
	}
		
	getData(currentPage + 1);
}

function goNextBlockPage() {	
	currentPage = currentPage + 10;
	
	var lastPageNum = Math.floor((totalCount - 1) / pagePerCount);
	if (currentPage >= lastPageNum) {
		currentPage = lastPageNum - 1;
	}
	
	getData(currentPage + 1);
}

function goNextPage() {
	currentPage = currentPage + 1;
	
	var lastPageNum = Math.floor((totalCount - 1) / pagePerCount);
	if (currentPage >= lastPageNum) {
		currentPage = lastPageNum - 1;
	}
	
	getData(currentPage + 1);
}

function goPage(num) {
	currentPage = Number(num) - 1;
	
	var lastPageNum = Math.floor((totalCount - 1) / pagePerCount);
	if (currentPage < 0) {
		currentPage = 0;
	} else if (currentPage >= lastPageNum) {
		currentPage = lastPageNum - 1;
	}
	
	getData(currentPage + 1);
}

function goCurrentPage() {
	getData(currentPage);
}

function showPage(startIndex) {
	var pagination = document.getElementById("paging");

	if (pagination) {
		console.log( "pagination");
		while (pagination.firstChild) {
			pagination.removeChild(pagination.firstChild);
		}
	}
				
	var page 			= currentPage;
	var total			= this.totalCount;
	var pageBlock		= pagePerCount;
	var navigatorNum    = Math.min(10, Math.floor( totalCount / pagePerCount ) + ( (totalCount % pagePerCount) == 0 ? 0 : 1 ));
	var firstPageNum	= 1;
	var lastPageNum		= Math.floor((total-1)/pageBlock) + 1;
	var previewPageNum  = page == 1 ? 1 : page-1;
	var nextPageNum		= page == lastPageNum ? lastPageNum : page+1;
	var indexNum		= startIndex <= navigatorNum  ? 0 : parseInt((startIndex-1)/navigatorNum) * navigatorNum;
	
	if (total > 1) {
		
		if (startIndex > 1) {
			var liItem = document.createElement("li");
			liItem.setAttribute("id", "prevBlock");
			liItem.setAttribute("onclick", "javascript:goPrevBlockPage()");
			liItem.appendChild(document.createTextNode("<< "));
			pagination.appendChild(liItem);
			
			liItem = document.createElement("li");
			liItem.setAttribute("id", "prev");
			liItem.setAttribute("onclick", "javascript:goPrevPage()");
			liItem.appendChild(document.createTextNode(" < "));
			pagination.appendChild(liItem);
		}
		console.log( "navigatorNum : " + navigatorNum);
		for (var i=1; i <= navigatorNum; i++) {
			var pageNum = i + indexNum;
			if (pageNum == startIndex) {
				var liItem = document.createElement("li");
				liItem.setAttribute("id", pageNum.toString());
				liItem.setAttribute("class", "page_select");
				liItem.setAttribute("onclick", "javascript:goPage(this.id)");
				liItem.appendChild(document.createTextNode(" " + pageNum.toString() + " "));
				pagination.appendChild(liItem);
			} else {
				var liItem = document.createElement("li");
				liItem.setAttribute("id", pageNum.toString());
				liItem.setAttribute("onclick", "javascript:goPage(this.id)");
				liItem.appendChild(document.createTextNode(" " + pageNum.toString() + " "));
				pagination.appendChild(liItem);
			}
			
			if (pageNum == lastPageNum - 1)
				break;
		}
		
		if (startIndex < lastPageNum - 1) {
			var liItem = document.createElement("li");
			liItem.setAttribute("id", "next");
			liItem.setAttribute("onclick", "javascript:goNextPage()");
			liItem.appendChild(document.createTextNode(" > "));
			pagination.appendChild(liItem);
			
			liItem = document.createElement("li");
			liItem.setAttribute("id", "nextBlock");
			liItem.setAttribute("onclick", "javascript:goNextBlockPage()");
			liItem.appendChild(document.createTextNode(" >>"));
			pagination.appendChild(liItem);
		}
	}
}