var timer;
var autoRead = false;
var refreshTime = 0;

window.onload = function () {
	autoRead = false;
	
	var sid = getCookie("sid");
	if (sid == undefined) {	
		document.getElementById("logoutID").style.visibility = "hidden";
	} else {
		var id = getCookie( "loginid" );
		if (id) {
			document.getElementById("loginInfo").innerHTML = id + " | Logout";
		} else {
			document.getElementById("loginInfo").innerHTML = "Logout";
		}
	}
}

window.onunload = function () {	
	autoRead = false;
}

function isEmpty(str) {
	if (typeof str === 'string' || str instanceof String)
		return (!str || 0 === str.length);
	return true;
}

function createHttp() {
	if (window.ActiveXObject){
		try {
			return new ActiveXObject("Msxml2.XMLHTTP");
		} catch(e1) {
			try {
				return new ActiveXObject("Microsoft.XMLHTTP");
			}catch(e1){
				return null;
			}
		}
	} else if (window.XMLHttpRequest) {
		return new XMLHttpRequest();	
	}
	
	return null;
}

function request() {
	var str = document.getElementById("getbtn").innerHTML;
	if (str == "Stop") {
		document.getElementById("getbtn").innerHTML = "Get";
		autoRead = false;
	} else {
		document.getElementById("getbtn").innerHTML = "Stop";
		autoRead = true;
		getData();
	}
}

function getData() {
	if (autoRead == false) {
		return;
	}

	var address = document.getElementById("address").value;
	var dataType = document.getElementById("dataType").value;
	var count = document.getElementById("count").value;
	
	refreshTime = Number(document.getElementById("refresh").value) * 1000;	
	
	var time = new Date().getTime();
	var url = "http://" + window.location.host + "/feeds/address?displayname=" + address + "&type=" + dataType + "&count=" + count + "&time=" + time.toString();

    var xmlhttp = createHttp();
    if (!xmlhttp) {
      alert('Giving up :( Cannot create an XMLHTTP instance');
      return;
    }
	
	var sid = getCookie("sid");
	
    xmlhttp.open("GET", url, true);
	xmlhttp.setRequestHeader("weMX-Auth",sid);	
    xmlhttp.onreadystatechange = function () {
		
        if (xmlhttp.readyState == 4 /* XMLHttpRequest.DONE - ie state problem */) {
			if (autoRead == false) {
				return;
			}
			
			console.log("xmlhttp.status : " + xmlhttp.status);
			
			if (xmlhttp.status == 200) {
				var json = JSON.parse(xmlhttp.responseText);
				
				if (json == undefined) {
					displayError("wrong data");
					return;
				}
				
				var error = json["error"];
				if (error != undefined) {
					displayError(error);
					return;
				}
				
				displayData(json);
			} else{
				displayError(xmlhttp.responseText);
			}
			
			if (refreshTime == 0) {
				document.getElementById("getbtn").innerHTML = "Get";
				autoRead = false;
				return;
			}
			
			if (autoRead == true) {
				
				setTimeout(getData, refreshTime);
			}
        }
    }

    xmlhttp.send();
}

function displayData(json) {
	var listContainer = document.getElementById("listContainer");

	while (listContainer.firstChild) {
		listContainer.removeChild(listContainer.firstChild);
	}
	
	var listElement = document.createElement("tr");
	listContainer.appendChild(listElement);
	listElement.style.border = "solid";
	listElement.style.borderColor = "#5B5B5B";
	listElement.style.borderWidth = "1px";
	listElement.style.backgroundColor = "#EEEEEE";
	listElement.height = "28px";
	listElement.style.fontSize = "12pt";
	listElement.style.fontWeight = "normal";
	listElement.style.textAlign = "center";

	var listItem = document.createElement("th");
	listItem.style.border = "solid";
	listItem.style.borderColor = "#5B5B5B";
	listItem.style.borderWidth = "1px";
	listItem.innerHTML = "No.";
	listElement.appendChild(listItem);

	var listItem = document.createElement("th");
	listItem.style.border = "solid";
	listItem.style.borderColor = "#5B5B5B";
	listItem.style.borderWidth = "1px";
	listItem.innerHTML = "Value";
	listElement.appendChild(listItem);
		
	var numberOfListItems = json["count"];
	
	if ( numberOfListItems == undefined || Number(numberOfListItems) == 1 ) {
		listElement = document.createElement("tr");
		listContainer.appendChild(listElement);
		listElement.height = "28px";
		listElement.style.fontSize = "12pt";
		listElement.style.textAlign = "center";

		listItem = document.createElement("td");
		listItem.style.border = "solid";
		listItem.style.borderColor = "#5B5B5B";
		listItem.style.borderWidth = "1px";
		listItem.width = "40px";
		listItem.innerHTML = "1";
		listElement.appendChild(listItem);

		listItem = document.createElement("td");
		listItem.style.border = "solid";
		listItem.style.borderColor = "#5B5B5B";
		listItem.style.borderWidth = "1px";
		listItem.innerHTML = decodeURIComponent(json["value"]);
		listElement.appendChild(listItem);
	} else {
		var values = decodeURIComponent(json["values"]);
		for (var i = 0 ; i < numberOfListItems ; ++i) {
			listElement = document.createElement("tr");
			listContainer.appendChild(listElement);
			listElement.height = "28px";
			listElement.style.fontSize = "12pt";
			listElement.style.textAlign = "center";

			listItem = document.createElement("td");
			listItem.style.border = "solid";
			listItem.style.borderColor = "#5B5B5B";
			listItem.style.borderWidth = "1px";
			listItem.width = "40px";
			var num = i + 1;
			listItem.innerHTML = num.toString();
			listElement.appendChild(listItem);

			listItem = document.createElement("td");
			listItem.style.border = "solid";
			listItem.style.borderColor = "#5B5B5B";
			listItem.style.borderWidth = "1px";
			listItem.innerHTML = values[i];
			listElement.appendChild(listItem);
		}
	}
}

function displayError(error) {
	var listContainer = document.getElementById("listContainer");

	while (listContainer.firstChild) {
		listContainer.removeChild(listContainer.firstChild);
	}
				
	var listElement = document.createElement("tr");
	listContainer.appendChild(listElement);
	listElement.style.border = "solid";
	listElement.style.borderColor = "#5B5B5B";
	listElement.style.borderWidth = "1px";
	listElement.style.backgroundColor = "#EEEEEE";
	listElement.height = "28px";
	listElement.style.fontSize = "12pt";
	listElement.style.fontWeight = "normal";
	listElement.style.textAlign = "center";

	var listItem = document.createElement("th");
	listItem.innerHTML = "Error";
	listElement.appendChild(listItem);

	listElement = document.createElement("tr");
	listContainer.appendChild(listElement);
	listElement.height = "28px";
	listElement.style.fontSize = "12pt";
	listElement.style.textAlign = "center";
	
	listItem = document.createElement("td");
	listItem.style.border = "solid";
	listItem.style.borderColor = "#5B5B5B";
	listItem.style.borderWidth = "1px";
	listItem.innerHTML = error;
	listElement.appendChild(listItem);
	
	autoRead = false;
}

function onCountIncrease() {
	var item = document.getElementById("count");
	if (item) {
		var value = Number(item.value);
		value = value + 1;
		if (value > 256) {
			value = 256;
		}
		item.value = value;
	}
}

function onCountDecrease() {
	var item = document.getElementById("count");
	if (item) {
		var value = Number(item.value);
		value = value - 1;
		if (value <= 0) {
			value = 1;
		}
		item.value = value;
	}
}

function onRefreshIncrease() {
	var item = document.getElementById("refresh");
	if (item) {
		var value = Number(item.value);
		value = value + 1;
		if (value > 60) {
			value = 60;
		}
		item.value = value;
	}
}

function onRefreshtDecrease() {
	var item = document.getElementById("refresh");
	if (item) {
		var value = Number(item.value);
		value = value - 1;
		if (value < 0) {
			value = 0;
		}
		item.value = value;
	}
}

