/****************************************************************************
**
** Copyright (C) 2013 Digia Plc and/or its subsidiary(-ies).
** Contact: http://www.qt-project.org/legal
**
** This file is part of the examples of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:BSD$
** You may use this file under the terms of the BSD license as follows:
**
** "Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are
** met:
**   * Redistributions of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**   * Redistributions in binary form must reproduce the above copyright
**     notice, this list of conditions and the following disclaimer in
**     the documentation and/or other materials provided with the
**     distribution.
**   * Neither the name of Digia Plc and its Subsidiary(-ies) nor the names
**     of its contributors may be used to endorse or promote products derived
**     from this software without specific prior written permission.
**
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
**
** $QT_END_LICENSE$
**
****************************************************************************/

import QtQuick 2.0

Item {
	property string modelName: "";
	property string screenSize: "";
	property string resolution: "";
	property string display: "";
	property string displayColor: "";
	property string touchPanel: "";

	property string trModelName: "Model Name";
	property string trScreenSize: "Screen Size";
	property string trResolution: "Resolution";
	property string trDisplay: "Display";
	property string trDisplayColor: "Display Color";
	property string trTouchPanel: "Touch Panel";

	// property string fontFamily: "";

	Rectangle {
		x: -1 * settingMain.mRatio
		y: ((41 * 0) - (1 * 0)) * settingMain.mRatio
		width: parent.width + 2
		height: 40 * settingMain.mRatio
		color: "#00000000"
		border.color: "#FFA5A5A5"
		border.width: 1
	}

	Rectangle {
		x: -1 * settingMain.mRatio
		y: ((41 * 1) - (1 * 1) - 1) * settingMain.mRatio
		width: parent.width + 2
		height: 41 * settingMain.mRatio
		color: "#00000000"
		border.color: "#FFA5A5A5"
		border.width: 1
	}

	Rectangle {
		x: -1 * settingMain.mRatio
		y: ((41 * 2) - (1 * 2) - 1) * settingMain.mRatio
		width: parent.width + 2
		height: 41 * settingMain.mRatio
		color: "#00000000"
		border.color: "#FFA5A5A5"
		border.width: 1
	}

	Rectangle {
		x: -1 * settingMain.mRatio
		y: ((41 * 3) - (1 * 3) - 1) * settingMain.mRatio
		width: parent.width + 2
		height: 41 * settingMain.mRatio
		color: "#00000000"
		border.color: "#FFA5A5A5"
		border.width: 1
	}

	Rectangle {
		x: -1 * settingMain.mRatio
		y: ((41 * 4) - (1 * 4) - 1) * settingMain.mRatio
		width: parent.width + 2
		height: 41 * settingMain.mRatio
		color: "#00000000"
		border.color: "#FFA5A5A5"
		border.width: 1
	}

	Rectangle {
		x: -1 * settingMain.mRatio
		y: ((41 * 5) - (1 * 5) - 1) * settingMain.mRatio
		width: parent.width + 2
		height: 41 * settingMain.mRatio
		color: "#00000000"
		border.color: "#FFA5A5A5"
		border.width: 1
	}

	Rectangle {
		x: 0
		y: 0
		width: 160 * settingMain.mRatio
		height: 40 * settingMain.mRatio
		color: "#7FE6E6E6"
		
		Text {
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: trModelName;
		}
	}

	Rectangle {
		x: (160 * settingMain.mRatio) + 1
		y: 0
		width: parent.width - ((160 * settingMain.mRatio) + 1)
		height: 40 * settingMain.mRatio
		color: "#4BE6E6E6"

		Text {
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: modelName;
		}
	}

	Rectangle {
		x: 0
		y: ((41 * 1) - (1 * 1)) * settingMain.mRatio
		width: 160 * settingMain.mRatio
		height: 40 * settingMain.mRatio
		color: "#7FE6E6E6"
		
		Text {
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: trScreenSize;
		}
	}

	Rectangle {
		x: (160 * settingMain.mRatio) + 1
		y: ((41 * 1) - (1 * 1)) * settingMain.mRatio
		width: parent.width - ((160 * settingMain.mRatio) + 1)
		height: 40 * settingMain.mRatio
		color: "#4BE6E6E6"

		Text {
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: screenSize;
		}
	}

	Rectangle {
		x: 0
		y: ((41 * 2) - (1 * 2)) * settingMain.mRatio
		width: 160 * settingMain.mRatio
		height: 40 * settingMain.mRatio
		color: "#7FE6E6E6"
		
		Text {
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: trResolution;
		}
	}

	Rectangle {
		x: (160 * settingMain.mRatio) + 1
		y: ((41 * 2) - (1 * 2)) * settingMain.mRatio
		width: parent.width - ((160 * settingMain.mRatio) + 1)
		height: 40 * settingMain.mRatio
		color: "#4BE6E6E6"

		Text {
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: resolution;
		}
	}

	Rectangle {
		x: 0
		y: ((41 * 3) - (1 * 3)) * settingMain.mRatio
		width: 160 * settingMain.mRatio
		height: 40 * settingMain.mRatio
		color: "#7FE6E6E6"
		
		Text {
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: trDisplay;
		}
	}

	Rectangle {
		x: (160 * settingMain.mRatio) + 1
		y: ((41 * 3) - (1 * 3))  * settingMain.mRatio
		width: parent.width - ((160 * settingMain.mRatio) + 1)
		height: 40 * settingMain.mRatio
		color: "#4BE6E6E6"

		Text {
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: display;
		}
	}

	Rectangle {
		x: 0
		y: ((41 * 4) - (1 * 4)) * settingMain.mRatio
		width: 160 * settingMain.mRatio
		height: 40 * settingMain.mRatio
		color: "#7FE6E6E6"
		
		Text {
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: trDisplayColor;
		}
	}

	Rectangle {
		x: (160 * settingMain.mRatio) + 1
		y: ((41 * 4) - (1 * 4)) * settingMain.mRatio
		width: parent.width - ((160 * settingMain.mRatio) + 1)
		height: 40 * settingMain.mRatio
		color: "#4BE6E6E6"

		Text {
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: displayColor;
		}
	}

	Rectangle {
		x: 0
		y: ((41 * 5) - (1 * 5)) * settingMain.mRatio
		width: 160 * settingMain.mRatio
		height: 40 * settingMain.mRatio
		color: "#7FE6E6E6"
		
		Text {
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: trTouchPanel;
		}
	}

	Rectangle {
		x: (160 * settingMain.mRatio) + 1
		y: ((41 * 5) - (1 * 5)) * settingMain.mRatio
		width: parent.width - ((160 * settingMain.mRatio) + 1)
		height: 40 * settingMain.mRatio
		color: "#4BE6E6E6"

		Text {
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: touchPanel;
		}
	}

	function setDisplayInfos(displayInfos)
	{
		modelName = displayInfos.modelName;
		screenSize = displayInfos.screenSize;
		resolution = displayInfos.resolution;
		display = displayInfos.display;
		displayColor = displayInfos.displayColor;
		touchPanel = displayInfos.touchPanel;
	}
}