/****************************************************************************
**
** Copyright (C) 2013 Digia Plc and/or its subsidiary(-ies).
** Contact: http://www.qt-project.org/legal
**
** This file is part of the examples of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:BSD$
** You may use this file under the terms of the BSD license as follows:
**
** "Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are
** met:
**   * Redistributions of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**   * Redistributions in binary form must reproduce the above copyright
**     notice, this list of conditions and the following disclaimer in
**     the documentation and/or other materials provided with the
**     distribution.
**   * Neither the name of Digia Plc and its Subsidiary(-ies) nor the names
**     of its contributors may be used to endorse or promote products derived
**     from this software without specific prior written permission.
**
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
**
** $QT_END_LICENSE$
**
****************************************************************************/

import QtQuick 2.0
import QtQuick.Controls 1.0

Item {
	property string trSystemLanguage: "System Language";
	property string trKorean: "Korean";
	property string trEnglish: "English";
	property string trDate: "Date";
	property string trTime: "Time";

	property string trDateYear: "Year";
	property string trDateMonth: "Month";
	property string trDateDay: "Day";
	property string trTimeHour: "Hour";
	property string trTimeMinite: "Minite";
	property string trTimeSecond: "Second";

	property int settingYear: 0
	property int settingMonth: 0
	property int settingDay: 0
	property int settingHour: 0
	property int settingMinite: 0
	property int settingSecond: 0

	property bool isSetting: false
	property bool isLanguageSelecting: false
	property string currentLanguage: ""
	// property string fontFamily: "";

	
	Rectangle {
		x: -1 * settingMain.mRatio
		y: ((41 * 0) - (1 * 0)) * settingMain.mRatio
		width: parent.width + 2
		height: 40 * settingMain.mRatio
		color: "#00000000"
		border.color: "#FFA5A5A5"
		border.width: 1
	}

	Rectangle {
		x: -1 * settingMain.mRatio
		y: ((41 * 1) - (1 * 1) - 1) * settingMain.mRatio
		width: parent.width + 2
		height: 41 * settingMain.mRatio
		color: "#00000000"
		border.color: "#FFA5A5A5"
		border.width: 1
	}

	Rectangle {
		x: -1 * settingMain.mRatio
		y: ((41 * 2) - (1 * 2) - 1) * settingMain.mRatio
		width: parent.width + 2
		height: 41 * settingMain.mRatio
		color: "#00000000"
		border.color: "#FFA5A5A5"
		border.width: 1
	}

	Rectangle {
		x: 0
		y: 0
		width: 160 * settingMain.mRatio
		height: 40 * settingMain.mRatio
		color: "#7FE6E6E6"
		
		Text {
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: trSystemLanguage;
		}
	}

	Rectangle {
		x: 0
		y: ((41 * 1) - (1 * 1)) * settingMain.mRatio
		width: 160 * settingMain.mRatio
		height: 40 * settingMain.mRatio
		color: "#7FE6E6E6"
		
		Text {
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: trDate + "(y-M-d)";
		}
	}

/*	
	Rectangle {
		x: (160 * settingMain.mRatio) + 1
		y: ((41 * 1) - (1 * 1)) * settingMain.mRatio
		width: parent.width - ((160 * settingMain.mRatio) + 1)
		height: 40 * settingMain.mRatio
		color: "#4BE6E6E6"

		SpinBox {
			id: dateYearSpinbox
			x: 13 * settingMain.mRatio
			y: 8 * settingMain.mRatio
			width: 106 * settingMain.mRatio
			height: 24 * settingMain.mRatio
            suffix: qsTr("")
			enabled: false
			maximumValue: 2074
			minimumValue: 1990
            font.pointSize: 10 * settingMain.mRatioFont

			onValueChanged: {
                settingYear = value;

				if (isSetting == false) {
					// settingMain.setDateTime(settingYear, settingMonth, settingDay, settingHour, settingMinite, settingSecond);
				}
			}		
		}
	
		SpinBox {
			id: dateMonthSpinbox
			x: (13 + 106 + 24) * settingMain.mRatio
			y: 8 * settingMain.mRatio
			width: 106 * settingMain.mRatio
			height: 24 * settingMain.mRatio
			enabled: false
			maximumValue: 12
			minimumValue: 1
            font.pointSize: 10 * settingMain.mRatioFont

			onValueChanged: {
				settingMonth = value;

			
				if (isSetting == false) {
					// settingMain.setDateTime(settingYear, settingMonth, settingDay, settingHour, settingMinite, settingSecond);
				}
			}		
		}

		SpinBox {
			id: dateDaySpinbox
			x: (13 + ((106 + 24) * 2)) * settingMain.mRatio
			y: 8 * settingMain.mRatio
			width: 106 * settingMain.mRatio
			height: 24 * settingMain.mRatio
            enabled: false
			maximumValue: 31
			minimumValue: 1
            font.pointSize: 10 * settingMain.mRatioFont

			onValueChanged: {
				settingDay = value;
			
				if (isSetting == false) {
					// settingMain.setDateTime(settingYear, settingMonth, settingDay, settingHour, settingMinite, settingSecond);
				}
			}	
		}
	}
*/

	Rectangle {
		x: 0
		y: ((41 * 2) - (1 * 2)) * settingMain.mRatio
		width: 160 * settingMain.mRatio
		height: 40 * settingMain.mRatio
		color: "#7FE6E6E6"

		Text {
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: trTime + "(h-m-s)";
		}
	}

/*
	Rectangle {
		x: (160 * settingMain.mRatio) + 1
		y: ((41 * 2) - (1 * 2)) * settingMain.mRatio
		width: parent.width- ((160 * settingMain.mRatio) + 1)
		height: 40 * settingMain.mRatio
		color: "#4BE6E6E6"
		
		SpinBox {
			id: timeHourSpinbox
			x: 13 * settingMain.mRatio
			y: 8 * settingMain.mRatio
			width: 106 * settingMain.mRatio
			height: 24 * settingMain.mRatio
			enabled: false
			maximumValue: 23
			minimumValue: 0
            font.pointSize: 10 * settingMain.mRatioFont

			onValueChanged: {
				settingHour = value;

				if (isSetting == false) {
					settingMain.setDateTime(settingYear, settingMonth, settingDay, settingHour, settingMinite, settingSecond);
				}
			}	
		}
	
		SpinBox {
			id: timeMiniteSpinbox
			x: (13 + 106 + 24) * settingMain.mRatio
			y: 8 * settingMain.mRatio
			width: 106 * settingMain.mRatio
			height: 24 * settingMain.mRatio
			enabled: false
			maximumValue: 59
			minimumValue: 0
            font.pointSize: 10 * settingMain.mRatioFont

			onValueChanged: {
				settingMinite = value;

				if (isSetting == false) {
					settingMain.setDateTime(settingYear, settingMonth, settingDay, settingHour, settingMinite, settingSecond);
				}
			}	
		}

		SpinBox {
			id: timeSecondSpinbox
			x: (13 + ((106 + 24) * 2)) * settingMain.mRatio
			y: 8 * settingMain.mRatio
			width: 106 * settingMain.mRatio
			height: 24 * settingMain.mRatio
			enabled: false
			maximumValue: 59
			minimumValue: 0
            font.pointSize: 10 * settingMain.mRatioFont

			onValueChanged: {
				settingSecond = value;

				if (isSetting == false) {
					settingMain.setDateTime(settingYear, settingMonth, settingDay, settingHour, settingMinite, settingSecond);
				}
			}	
		}
	}
*/

	Rectangle {
		x: (160 * settingMain.mRatio) + 1
		y: 0
		width: parent.width - ((160 * settingMain.mRatio) + 1)
		height: 40 * settingMain.mRatio
		color: "#4BE6E6E6"

		Rectangle {
			x: 12 * settingMain.mRatio
			y: 8 * settingMain.mRatio
			width: 108 * settingMain.mRatio
			height: 24 * settingMain.mRatio
			border.color: "#FF000000"
			border.width: 1
		
			MouseArea {
				anchors.fill: parent

				onPressed: {
					if (isLanguageSelecting == false) {
						// settingMain.playSound(settingMain.touchSoundType);
					}
				}

				onClicked: {
					if (isLanguageSelecting == false) {
						isLanguageSelecting = true;
						languageComboContentsFrame.visible = true;
					}
					else {
						isLanguageSelecting = false;
						languageComboContentsFrame.visible = false;
					}
				}
			}
				
			Image {
				width: 17 * settingMain.mRatio
				height: 18 * settingMain.mRatio
				anchors.right: parent.right;
				anchors.verticalCenter: parent.verticalCenter;
				anchors.rightMargin: 4 * settingMain.mRatio
				source: "../setting_main_combo_arrow_down.png";       
			}
		}

		Text {
			id: languageComboMain
			x: 16 * settingMain.mRatio
			y: 8 * settingMain.mRatio
			width: 100 * settingMain.mRatio
			height: 24 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FF000000"
			text: trKorean
		}

		Rectangle {
			id: languageComboContentsFrame
			x: 12 * settingMain.mRatio
			y: 32 * settingMain.mRatio
			z: 601
			width: 108 * settingMain.mRatio
			// height: 48
			height: 24 * settingMain.mRatio
			border.color: "#FF000000"
			border.width: 1
			visible: false			
			
			Text {
				x: 4 * settingMain.mRatio
				y: 0
				width: 100 * settingMain.mRatio
				height: 24 * settingMain.mRatio
				// font.family: fontFamily;
				font.bold: true
				font.pointSize: 10 * settingMain.mRatioFont
				color: "#FF000000"
				verticalAlignment: Text.AlignVCenter;
				text: trEnglish

				MouseArea {
					id: englishComboMouseArea
					anchors.fill: parent
					propagateComposedEvents: true

					onPressed: {
						if (isLanguageSelecting == true) {
							// settingMain.playSound(settingMain.touchSoundType);
						}
					}

					onClicked: {
						if (isLanguageSelecting == true) {
							isLanguageSelecting = false;
							languageComboContentsFrame.visible = false;

							currentLanguage = "english";
							// settingMain.setLanguage("english");
                        }
                        mouse.accepted = false
                    }
                }
            }
        }
    }
	
	function setLanguageTimeInfos(languageTimeInfos) {
		isLanguageSelecting = false;
		languageComboContentsFrame.visible = false;

		if (languageTimeInfos.language == "english") {
			currentLanguage = "english"
			languageComboMain.text = trEnglish
		}
		else {
			currentLanguage = "korean"
			languageComboMain.text = trKorean
		}		

		isSetting = true;

		settingYear = languageTimeInfos.year;
		settingMonth = languageTimeInfos.month;
		settingDay = languageTimeInfos.day;
		settingHour = languageTimeInfos.hour;
		settingMinite = languageTimeInfos.minite;
		settingSecond = languageTimeInfos.second;

		//dateYearSpinbox.value = languageTimeInfos.year;
		//dateMonthSpinbox.value = languageTimeInfos.month;
		//dateDaySpinbox.value = languageTimeInfos.day;
		//timeHourSpinbox.value = languageTimeInfos.hour;
		//timeMiniteSpinbox.value = languageTimeInfos.minite;
		//timeSecondSpinbox.value = languageTimeInfos.second;

		isSetting = false;
	}

	function cancelCombo() {
		isLanguageSelecting = false;
		languageComboContentsFrame.visible = false;
	}
}
