/****************************************************************************
**
** Copyright (C) 2013 Digia Plc and/or its subsidiary(-ies).
** Contact: http://www.qt-project.org/legal
**
** This file is part of the examples of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:BSD$
** You may use this file under the terms of the BSD license as follows:
**
** "Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are
** met:
**   * Redistributions of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**   * Redistributions in binary form must reproduce the above copyright
**     notice, this list of conditions and the following disclaimer in
**     the documentation and/or other materials provided with the
**     distribution.
**   * Neither the name of Digia Plc and its Subsidiary(-ies) nor the names
**     of its contributors may be used to endorse or promote products derived
**     from this software without specific prior written permission.
**
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
**
** $QT_END_LICENSE$
**
****************************************************************************/

import QtQuick 2.0
import QtQuick.Controls 1.0

Item {
	property string trAvailable: "Available";
	property string trUsage: "Usage";
	property string trTotal: "Total";
	property string trNotConnected: "Not Connected";
	// property string fontFamily: "";

	Rectangle {
		x: -1 * settingMain.mRatio
		y: 0
		width: parent.width + 2
		height: 40 * settingMain.mRatio
		color: "#00000000"
		border.color: "#FFA5A5A5"
		border.width: 1
	}

	Rectangle {
		x: -1 * settingMain.mRatio
		y: ((41 * 1) - (1 * 1) - 1) * settingMain.mRatio
		width: parent.width + 2
		height: 41 * settingMain.mRatio
		color: "#00000000"
		border.color: "#FFA5A5A5"
		border.width: 1
	}

	Rectangle {
		x: -1 * settingMain.mRatio
		y: ((41 * 2) - (1 * 2) - 1) * settingMain.mRatio
		width: parent.width + 2
		height: 41 * settingMain.mRatio
		color: "#00000000"
		border.color: "#FFA5A5A5"
		border.width: 1
	}

	Rectangle {
		x: -1 * settingMain.mRatio
		y: ((41 * 3) - (1 * 3) - 1) * settingMain.mRatio
		width: parent.width + 2
		height: 41 * settingMain.mRatio
		color: "#00000000"
		border.color: "#FFA5A5A5"
		border.width: 1
	}

	Rectangle {
		x: -1 * settingMain.mRatio
		y: ((41 * 4) - (1 * 4) - 1) * settingMain.mRatio
		width: parent.width + 2
		height: 41 * settingMain.mRatio
		color: "#00000000"
		border.color: "#FFA5A5A5"
		border.width: 1
	}

	Rectangle {
		x: 0
		y: 0
		width: 160 * settingMain.mRatio
		height: 40 * settingMain.mRatio
		color: "#7FE6E6E6"
	}

	Rectangle {
		id: header
		x: 160 * settingMain.mRatio + 1
		y: 0
		width: parent.width - (160 * settingMain.mRatio + 1)
		height: 40 * settingMain.mRatio
		color: "#00000000"
		
		Rectangle {
			x: 0
			y: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			color: "#7FE6E6E6"
		}

		Rectangle {
			x: ((parent.width - 2) / 3 + 1)
			y: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
            color: "#7FE6E6E6"
		}

		Rectangle {
			x: (((parent.width - 2) / 3) * 2 + 2)
			y: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
            color: "#7FE6E6E6"
		}

		Text {
			x: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			horizontalAlignment: Text.AlignHCenter;
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: trAvailable;
		}

		Text {
            x: ((parent.width - 2) / 3 + 1)
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			horizontalAlignment: Text.AlignHCenter;
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: trUsage;
		}

		Text {
            x: (((parent.width - 2) / 3) * 2 + 2)
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			horizontalAlignment: Text.AlignHCenter;
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: trTotal;
        }
	}

	Rectangle {
		x: 0
		y: ((41 * 1) - (1 * 1)) * settingMain.mRatio
		width: 160 * settingMain.mRatio
		height: 40 * settingMain.mRatio
		color: "#7FE6E6E6"

		Text {
			x: 12 * settingMain.mRatio
			width: parent.width - 12 * settingMain.mRatio
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: "RAM";
		}
	}

	Rectangle {
		x: (160 + 1) * settingMain.mRatio
		y: ((41 * 1) - (1 * 1)) * settingMain.mRatio
		width: parent.width - (160 * settingMain.mRatio + 1)
		height: 40 * settingMain.mRatio
		color: "#00000000"

		Rectangle {
			x: 0
			y: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			color: "#4BE6E6E6"
		}

		Rectangle {
			x: ((parent.width - 2) / 3 + 1)
			y: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			color: "#4BE6E6E6"
		}

		Rectangle {
			x: (((parent.width - 2) / 3) * 2 + 2)
			y: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			color: "#4BE6E6E6"
		}

		Text {
			id: availRam
			x: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			horizontalAlignment: Text.AlignHCenter;
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
		}

		Text {
			id: usageRam
			x: ((parent.width / 3) + 1)
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			horizontalAlignment: Text.AlignHCenter;
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
		}

		Text {
			id: totalRam
			x: ((parent.width / 3) * 2 + 1)
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			horizontalAlignment: Text.AlignHCenter;
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
		}
	}

	Rectangle {
		x: 0
		y: ((41 * 2) - (1 * 2)) * settingMain.mRatio
		width: 160 * settingMain.mRatio
		height: 40 * settingMain.mRatio
		color: "#7FE6E6E6"
		
		Text {
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: "ROM";
		}
	}

	Rectangle {
		x: (160 + 1) * settingMain.mRatio
		y: ((41 * 2) - (1 * 2)) * settingMain.mRatio
		width: parent.width - (160 * settingMain.mRatio + 1)
		height: 40 * settingMain.mRatio
		color: "#00000000"

		Rectangle {
			x: 0
			y: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			color: "#4BE6E6E6"
		}

		Rectangle {
			x: ((parent.width - 2) / 3 + 1)
			y: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			color: "#4BE6E6E6"
		}

		Rectangle {
			x: (((parent.width - 2) / 3) * 2 + 2)
			y: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			color: "#4BE6E6E6"
		}

		Text {
			id: availRom
			x: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			horizontalAlignment: Text.AlignHCenter;
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
		}

		Text {
			id: usageRom
			x: ((parent.width / 3) + 1)
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			horizontalAlignment: Text.AlignHCenter;
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
		}

		Text {
			id: totalRom
			x: ((parent.width / 3) * 2 + 1)
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			horizontalAlignment: Text.AlignHCenter;
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
		}
	}

	Rectangle {
		x: 0
		y: ((41 * 3) - (1 * 3)) * settingMain.mRatio
		width: 160 * settingMain.mRatio
		height: 40 * settingMain.mRatio
		color: "#7FE6E6E6"
		
		Text {
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: "SD Card";
		}
	}

	Rectangle {
		x: (160 + 1) * settingMain.mRatio
		y: ((41 * 3) - (1 * 3)) * settingMain.mRatio
		width: parent.width - (160 * settingMain.mRatio + 1)
		height: 40 * settingMain.mRatio
		color: "#00000000"

		Rectangle {
			id: availSdCardRect
			x: 0
			y: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			color: "#4BE6E6E6"
		}

		Rectangle {
			id: usageSdCardRect
			x: ((parent.width - 2) / 3 + 1)
			y: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			color: "#4BE6E6E6"
		}

		Rectangle {
			id: totalSdCardRect
			x: (((parent.width - 2) / 3) * 2 + 2)
			y: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			color: "#4BE6E6E6"
		}

		Text {
			id: availSdCard
			x: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			horizontalAlignment: Text.AlignHCenter;
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
		}

		Text {
			id: usageSdCard
			x: ((parent.width / 3) + 1)
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			horizontalAlignment: Text.AlignHCenter;
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
		}

		Text {
			id: totalSdCard
			x: ((parent.width / 3) * 2 + 1)
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			horizontalAlignment: Text.AlignHCenter;
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
		}

		Rectangle {
			id: notConnectedSdCardRect
			x: 0
			y: 0
			width: parent.width
			height: 40 * settingMain.mRatio
			color: "#4BE6E6E6"
		}

		Text {
			id: notConnectedSdCard
			x: 0
			width: parent.width
			height: 40 * settingMain.mRatio
			horizontalAlignment: Text.AlignHCenter;
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: trNotConnected
		}
	}

	Rectangle {
		x: 0
		y: ((41 * 4) - (1 * 4)) * settingMain.mRatio
		width: 160 * settingMain.mRatio
		height: 40 * settingMain.mRatio
		color: "#7FE6E6E6"
		
		Text {
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: "USB";
		}
	}

	Rectangle {
		x: (160 + 1) * settingMain.mRatio
		y: ((41 * 4) - (1 * 4)) * settingMain.mRatio
		width: parent.width - (160 * settingMain.mRatio + 1)
		height: 40 * settingMain.mRatio
		color: "#00000000"

		Rectangle {
			id: availUsbRect
			x: 0
			y: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			color: "#4BE6E6E6"
		}

		Rectangle {
			id: usageUsbRect
			x: ((parent.width - 2) / 3 + 1)
			y: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			color: "#4BE6E6E6"
		}

		Rectangle {
			id: totalUsbRect
			x: (((parent.width - 2) / 3) * 2 + 2)
			y: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			color: "#4BE6E6E6"
		}

		Text {
			id: availUsb
			x: 0
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			horizontalAlignment: Text.AlignHCenter;
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
		}

		Text {
			id: usageUsb
			x: ((parent.width / 3) + 1)
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			horizontalAlignment: Text.AlignHCenter;
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
		}

		Text {
			id: totalUsb
			x: ((parent.width / 3) * 2 + 1)
			width: ((parent.width - 2) / 3)
			height: 40 * settingMain.mRatio
			horizontalAlignment: Text.AlignHCenter;
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
		}

		Rectangle {
			id: notConnectedUsbRect
			x: 0
			y: 0
			width: parent.width
			height: 40 * settingMain.mRatio
			color: "#4BE6E6E6"
		}

		Text {
			id: notConnectedUsb
			x: 0
			width: parent.width
			height: 40 * settingMain.mRatio
			horizontalAlignment: Text.AlignHCenter;
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: trNotConnected
		}
    }

	function setMemoryInfos(memoryInfos)
	{
		availRam.text = memoryInfos.availRam;	
		usageRam.text = memoryInfos.usageRam;	
		totalRam.text = memoryInfos.totalRam;	

        availRom.text = memoryInfos.availRom;
        usageRom.text = memoryInfos.usageRom;
        totalRom.text = memoryInfos.totalRom;

		if (memoryInfos.connectedSdcard)
		{
			availSdCard.text = memoryInfos.availSdCard;	
			usageSdCard.text = memoryInfos.usageSdCard;	
			totalSdCard.text = memoryInfos.totalSdCard;	

			availSdCard.visible = true;
			usageSdCard.visible = true;
			totalSdCard.visible = true;
			availSdCardRect.visible = true;
			usageSdCardRect.visible = true;
			totalSdCardRect.visible = true;
			notConnectedSdCard.visible = false;
			notConnectedSdCardRect.visible = false;
		}
		else
		{
			availSdCard.visible = false;
			usageSdCard.visible = false;
			totalSdCard.visible = false;
			availSdCardRect.visible = false;
			usageSdCardRect.visible = false;
			totalSdCardRect.visible = false;
			notConnectedSdCard.visible = true;
			notConnectedSdCardRect.visible = true;
		}

		if(memoryInfos.connectedUsb)
		{
			availUsb.text = memoryInfos.availUsb;	
			usageUsb.text = memoryInfos.usageUsb;	
			totalUsb.text = memoryInfos.totalUsb;	

			availUsb.visible = true;
			usageUsb.visible = true;
			totalUsb.visible = true;
			availUsbRect.visible = true;
			usageUsbRect.visible = true;
			totalUsbRect.visible = true;
			notConnectedUsb.visible = false;
			notConnectedUsbRect.visible = false;
		}
		else
		{
			availUsb.visible = false;
			usageUsb.visible = false;
			totalUsb.visible = false;
			availUsbRect.visible = false;
			usageUsbRect.visible = false;
			totalUsbRect.visible = false;
			notConnectedUsb.visible = true;
			notConnectedUsbRect.visible = true;
        }
	}
}
