/****************************************************************************
**
** Copyright (C) 2013 Digia Plc and/or its subsidiary(-ies).
** Contact: http://www.qt-project.org/legal
**
** This file is part of the examples of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:BSD$
** You may use this file under the terms of the BSD license as follows:
**
** "Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are
** met:
**   * Redistributions of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**   * Redistributions in binary form must reproduce the above copyright
**     notice, this list of conditions and the following disclaimer in
**     the documentation and/or other materials provided with the
**     distribution.
**   * Neither the name of Digia Plc and its Subsidiary(-ies) nor the names
**     of its contributors may be used to endorse or promote products derived
**     from this software without specific prior written permission.
**
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
**
** $QT_END_LICENSE$
**
****************************************************************************/

import QtQuick 2.0

Item {
	property string com1: "";
	property string com2: "";
	property string com3: "";
	property string com4: "";

	// property string fontFamily: "";

	Rectangle {
		x: -1 * settingMain.mRatio
		y: ((41 * 0) - (1 * 0)) * settingMain.mRatio
		width: parent.width + 2
		height: 40 * settingMain.mRatio
		color: "#00000000"
		border.color: "#FFA5A5A5"
		border.width: 1
	}

	Rectangle {
		x: -1 * settingMain.mRatio
		y: ((41 * 1) - (1 * 1) - 1) * settingMain.mRatio
		width: parent.width + 2
		height: 41 * settingMain.mRatio
		color: "#00000000"
		border.color: "#FFA5A5A5"
		border.width: 1
	}

	Rectangle {
		x: -1 * settingMain.mRatio
		y: ((41 * 2) - (1 * 2) - 1) * settingMain.mRatio
		width: parent.width + 2
		height: 41 * settingMain.mRatio
		color: "#00000000"
		border.color: "#FFA5A5A5"
		border.width: 1
	}

	Rectangle {
		x: -1 * settingMain.mRatio
		y: ((41 * 3) - (1 * 3) - 1) * settingMain.mRatio
		width: parent.width + 2
		height: 41 * settingMain.mRatio
		color: "#00000000"
		border.color: "#FFA5A5A5"
		border.width: 1
	}

	Rectangle {
		x: 0
		y: 0
		width: 160 * settingMain.mRatio
		height: 40 * settingMain.mRatio
		color: "#7FE6E6E6"
		
		Text {
			id: com1Text
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: qsTr("COM 1");
		}
	}

	Rectangle {
		x: (160 * settingMain.mRatio) + 1
		y: 0
		width: parent.width - ((160 * settingMain.mRati) + 1)
		height: 40 * settingMain.mRatio
		color: "#4BE6E6E6"

		Text {
			id: com1InfoText
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: com1;
		}
	}

	Rectangle {
		x: 0
		y: ((41 * 1) - (1 * 1)) * settingMain.mRatio
		width: 160 * settingMain.mRatio
		height: 40 * settingMain.mRatio
		color: "#7FE6E6E6"
		
		Text {
			id: com2Text
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: qsTr("COM 2");
		}
	}

	Rectangle {
		x: (160 * settingMain.mRatio) + 1
		y: ((41 * 1) - (1 * 1)) * settingMain.mRatio
		width: parent.width - ((160 * settingMain.mRati) + 1)
		height: 40 * settingMain.mRatio
		color: "#4BE6E6E6"

		Text {
			id: com2InfoText
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: com2;
		}
	}

	Rectangle {
		x: 0
		y: ((41 * 2) - (1 * 2)) * settingMain.mRatio
		width: 160 * settingMain.mRatio
		height: 40 * settingMain.mRatio
		color: "#7FE6E6E6"
		
		Text {
			id: com3Text
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: qsTr("COM 3");
		}
	}

	Rectangle {
		x: (160 * settingMain.mRatio) + 1
		y: ((41 * 2) - (1 * 2)) * settingMain.mRatio
		width: parent.width - ((160 * settingMain.mRati) + 1)
		height: 40 * settingMain.mRatio
		color: "#4BE6E6E6"

		Text {
			id: com3InfoText
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: com3;
		}
	}

	Rectangle {
		x: 0
		y: ((41 * 3) - (1 * 3)) * settingMain.mRatio
		width: 160 * settingMain.mRatio
		height: 40 * settingMain.mRatio
		color: "#7FE6E6E6"
		
		Text {
			id: com4Text
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: qsTr("COM 4");
		}
	}

	Rectangle {
		x: (160 * settingMain.mRatio) + 1
		y: ((41 * 3) - (1 * 3)) * settingMain.mRatio
		width: parent.width - ((160 * settingMain.mRati) + 1)
		height: 40 * settingMain.mRatio
		color: "#4BE6E6E6"

		Text {
			id: com4InfoText
			x: 12 * settingMain.mRatio
			width: parent.width - (12 * settingMain.mRatio)
			height: 40 * settingMain.mRatio
			verticalAlignment: Text.AlignVCenter;
			// font.family: fontFamily;
			font.bold: true
			font.pointSize: 10 * settingMain.mRatioFont
			color: "#FFFFFFFF"
			text: com4;
		}
	}
	
	function setSerialInfos(serialInfos)
	{
		com1Text.visible = false;
		com2Text.visible = false;
		com3Text.visible = false;	
		com4Text.visible = false;

		com1InfoText.visible = false;
		com2InfoText.visible = false;
		com3InfoText.visible = false;	
		com4InfoText.visible = false;

		for (var i = 0; i < serialInfos.serials.length; i++)
		{
			if (i == 0)
			{
				com1 = serialInfos.serials[0];
				com1Text.visible = true;
				com1InfoText.visible = true;
			}
			else if (i == 1)
			{
				com2 = serialInfos.serials[1];
				com2Text.visible = true;
				com2InfoText.visible = true;
			}
			else if (i == 2)
			{
				com3 = serialInfos.serials[2];
				com3Text.visible = true;
				com3InfoText.visible = true;
			}
			else if (i == 3)
			{
				com4 = serialInfos.serials[3];
				com4Text.visible = true;
				com4InfoText.visible = true;
			}
		}
	}
}
