
var QT = { Checked:2 };

var LIMIT_OP = { OLDDELETE:0, STOP:1 };
var BACKUP_SAVE_PATH = { USB:0, SDCARD:1, INTERNAL:2 };
	
//const FILE_HEAD_SIZE = 128;
//const RECORD_SIZE = 128;


var codec = "EUC-KR";
var currentSize = [];
var oldFileTime = [];

var samplingGroupsKey = []
var samplingGroups = [];

var saveStorage = [];


var samplingStatusHAddr = [];

function init(keys, groups)
{
    //console.log(" .............. SamplingBackup new ...");

    samplingGroupsKey = keys;
    samplingGroups = groups;

    for (var i = 0 ; i < samplingGroupsKey.length ; i++)
    {
        var samplingNumber = samplingGroupsKey[i];
        var group = samplingGroups[samplingNumber];
        var samplingFileList = [];

        var savePath = group.document_save_storage_type;
        var storageStr;
        if (savePath == BACKUP_SAVE_PATH.USB)
        {
            storageStr = "USB";
        }
        else if (savePath == BACKUP_SAVE_PATH.SDCARD)
        {
            storageStr = "SDCARD";
        }
        else
        {
            storageStr = "APP_DATA";
        }

        saveStorage[samplingNumber] = storageStr;
        samplingStatusHAddr[samplingNumber] = group.backup_state_address;
        var file = wemx.allocFile();

        if (file.setStorage(storageStr)) {
            //currentSize[samplingNumber] = file.size("/data/sampling/");
            var dateStr = new Date().toLocaleDateString(Qt.locale(), "yyyyMMdd");
            currentSize[samplingNumber] = file.size("/data/sampling/wemx-sampling-" + samplingNumber + "-" + dateStr + ".csv");

            //console.log(" .............. currentSize[samplingNumber] : " + currentSize[samplingNumber]);

            var fileList = file.fileList("/data/sampling");
            for (var j = 0; j < fileList.length; j++) {
                var samplingFile = {};
                samplingFile.used = false;
                samplingFile.fileName = fileList[j];
                samplingFile.lastModified = file.lastModified("/data/sampling/" + fileList[j]);

                //console.log(" .............. file:: /data/sampling/" + fileList[i]);

                samplingFileList.push(samplingFile);
            }

            samplingFileList.sort(function (a, b) { return a.lastModified - b.lastModified });
            if (fileList.length > 0) {
                //console.log(" .............. oldFileTime[samplingNumber] : " + samplingFileList[fileList.length - 1].lastModified);
                oldFileTime[samplingNumber] = samplingFileList[fileList.length-1].lastModified;
                var dateStr = new Date(oldFileTime[samplingNumber]).toLocaleDateString(Qt.locale(), "yyyyMMdd");
            }

            group.samplingFileList = samplingFileList;
            samplingGroups[samplingNumber] = group;
        }

        wemx.freeFile(file);
    }
}


function openGroupFile(group)
{
    var file = group.samplingFile.file;
	
	var dateStr = new Date().toLocaleDateString(Qt.locale(), "yyyyMMdd");
	var fileName = "wemx-sampling-" + group.number + "-" + dateStr + ".csv";

	file.open("/data/sampling/" + fileName);
	//file.setCodec("UTF-8");

	//console.log(" .............. openGroupFile ... x1 ", group.number);

	var fileSize = file.size();
	if ( fileSize == 0 )	//< FILE_HEAD_SIZE )
	{
	    var backupFileHeader = "File Version, 0, 1\n" +
								"File Type, Sampling\n\n";
	    var firstRow = "Date, Time";

	    var samplingList = samplingGroups[group.number].samplingList;

	    //console.log(" .............. openGroupFile new groupFile ... x2 ", samplingList.length);
	    for (var i = 0 ; i < samplingList.length ; i++)
		{
		    var str = "";
		    var address = samplingList[i].address;
		    firstRow = firstRow + "," + wemx.getAddressName(address);
		}

		backupFileHeader =
            backupFileHeader +
            firstRow + "\n";

		var writtenLen = file.write(backupFileHeader, -1);
		if ( writtenLen < 0 )
		{
		    samplingStatusHAddr[group.number].writeWord16(4);	// 4:  
		}
		else
		{		
		    currentSize[group.number] += writtenLen;	//backupFileHeader.length;		//FILE_HEAD_SIZE;
		}

	    //console.log("head write ...", currentSize[group.number], writtenLen, backupFileHeader.length);

		var samplingFile = group.samplingFile;
		//samplingFile.file = file;
		samplingFile.fileName = fileName;
		samplingFile.lastModified = file.lastModified("/data/sampling/" + fileName);
		samplingFile.used = true;
	    //samplingGroups[group.number].samplingFileList.push(file);
		samplingGroups[group.number].samplingFileList.push(samplingFile);

		group.samplingFile = samplingFile;
	}
	else
	{
	    //console.log(" .............. openGroupFile groupFile ... x2 ", group.number);
		file.seek(fileSize);

		for (var i = 0; i < samplingGroups[group.number].samplingFileList.length; i++)
		{
		    if (samplingGroups[group.number].samplingFileList[i].fileName == fileName)
			{
		        //samplingGroups[group.number].samplingFile.used = true;
		        group.samplingFile = samplingGroups[group.number].samplingFileList[i];
		        group.samplingFile.file = file;
		        group.samplingFile.used = true;
				break;
			}
		}
	}
}

function closeGroupFile(group)
{
    //console.log("  closeGroupFile ");
    group.samplingFile.file.close();
    group.samplingFile.used = false;
    //group.samplingFile = null;
}





function deleteOldFile(groupNumber)
{
    //console.log("  BACKUP: deleteOldFile ");

    if (samplingGroups[groupNumber].samplingFile.used == true)
	{
		// old file ϴ   ʴ´. 
		return;
	}
	
	var file = wemx.allocFile();

    //console.log("DELETE: ", file);
	if (file.setStorage(saveStorage[groupNumber]))
	{
	    var dateStr = new Date(oldFileTime[groupNumber]).toLocaleDateString(Qt.locale(), "yyyyMMdd");
	    currentSize[groupNumber] -= file.size("/data/sampling/wemx-sampling-" + groupNumber + "-" + dateStr + ".csv");
	    oldFileTime[groupNumber] = samplingGroups[groupNumber].samplingFile.lastModified;
	    file.remove("/data/sampling/" + samplingGroups[groupNumber].samplingFile.fileName);

	    samplingGroups[groupNumber].samplingFileList.splice(0, 1);
	}

	wemx.freeFile(file);
}


function writeFile(groupNumber, storeData, dataCount)
{
    var currentTime = new Date().getTime();

    var group = samplingGroups[groupNumber];
	
    if (group.samplingFile == undefined)
	{
		var file = wemx.allocFile();

		if (file.setStorage(saveStorage[groupNumber]))
		{
		    file.setCodec(codec);

		    var samplingFile = {};

		    samplingFile.file = file;
		    samplingFile.number = groupNumber;
		    samplingFile.toDay = Math.floor(currentTime / (1000 * 60 * 60 * 24));
		    samplingFile.dataCount = dataCount;
		    group.samplingFile = samplingFile;

		    //groupFileList[groupNumber] = group;

		    //console.log(" .............. writeRecord groupFile ... x2", groupNumber);
		    openGroupFile(group);

		    if (oldFileTime[groupNumber] == 0)
		    {
		        //console.log(" .............. set oldFileTime[groupNumber] ... x1", samplingGroups[groupNumber].samplingFileList[0].lastModified);
		        oldFileTime[groupNumber] = samplingGroups[groupNumber].samplingFileList[0].lastModified;
		    }
		}
		else
		{
		    wemx.freeFile(file);
		}
			
	    //console.log(" .............. writeRecord groupFile ... ", groupNumber);
	}
	else
    {
        if (!samplingGroups[groupNumber].samplingFile.file.setStorage(saveStorage[groupNumber]))
	    {
            samplingStatusHAddr[groupNumber].writeWord16(4);
	        return;
        }
	}


    //console.log(" BACKUP : writeFile 1 ", currentSize[groupNumber], samplingGroups[groupNumber].document_limit_size);

	if (currentSize[groupNumber] >= samplingGroups[groupNumber].document_limit_size * 1000 * 1000)
	{
	    //console.log(" BACKUP : LIMIT_SIZE ");
	    if (samplingGroups[groupNumber].document_limit_condition == LIMIT_OP.STOP)
		{
		    samplingStatusHAddr[groupNumber].writeWord16(3);	// 3: 뷮ʰ 
			return;
		}
		else
	    {	// old data   
		    deleteOldFile(groupNumber);
		}
	}


	//console.log(" BACKUP : writeFile 2-2 ", currentTime, oldFileTime[groupNumber]);
	var elapsedDay = Math.floor((currentTime - oldFileTime[groupNumber]) / (1000 * 60 * 60 * 24));

    //console.log(" BACKUP : writeFile 3 ", elapsedDay, samplingGroups[groupNumber].document_limit_day);
	
	if (elapsedDay >= samplingGroups[groupNumber].document_limit_day)
	{
	    //console.log(" BACKUP : LIMIT_DAY ");
	    if (samplingGroups[groupNumber].document_limit_condition == LIMIT_OP.STOP)
		{
		    samplingStatusHAddr[groupNumber].writeWord16(2);	// 2:  ʰ  		
			return;
		}
		else
	    {	// old data   
		    deleteOldFile(groupNumber);
		}	
	}



	var currentDay = Math.floor(currentTime / (1000*60*60*24));

    //console.log(" BACKUP : writeFile 3 ", currentDay, groupFileList[groupNumber].toDay);

	//samplingStatusHAddr[groupNumber].writeWord16(1);
	openGroupFile(samplingGroups[groupNumber]);

	if (currentDay != samplingGroups[groupNumber].samplingFile.toDay)
	{
	    samplingGroups[groupNumber].samplingFile.toDay = currentDay;
	    closeGroupFile(samplingGroups[groupNumber]);
	    openGroupFile(samplingGroups[groupNumber]);
	}

	var writtenLen = samplingGroups[groupNumber].samplingFile.file.write(storeData, -1);
	if ( writtenLen < 0 )
	{
	    samplingStatusHAddr[groupNumber].writeWord16(4);	// 4:  
	}
	else
	{
	    currentSize[groupNumber] += writtenLen;	//storeData.length;	

	    //console.log("write size ", currentSize[groupNumber],  writtenLen, storeData.length);
		
	}

	closeGroupFile(samplingGroups[groupNumber]);

	//samplingStatusHAddr[groupNumber].writeWord16(0);
}




function insertRecord(groupNumber, time, dateFormat, timeFormat, samplingDatas)//alarm, mode, status, occurTime, recoveryTime, ackTime, message, count, level)
{
	
    //console.log("::::::::: Backup " + groupNumber + ", " + samplingDatas.length, groupNumber);
    var dateStr;
    var timeStr;

    var date = new Date(time);

    if (dateFormat == undefined)
    {
        dateStr = "";
    }
    else 
    {
        dateStr = date.toLocaleDateString(Qt.locale(), dateFormat);
    }

    if (timeFormat == undefined)
    {
        timeStr = "";
    }
    else 
    {
        timeStr = date.toLocaleTimeString(Qt.locale(), timeFormat);
    }
    	
    var storeData = dateStr + "," + timeStr;

    for (var i = 0 ; i < samplingDatas.length ; i++)
    {
        storeData = storeData + "," + "\"" + samplingDatas[i] + "\"";
    }

    storeData += "\n";
//console.log(storeData);	


try {
    writeFile(groupNumber, storeData, samplingDatas.length);
} catch (err) {
	console.log("ERRRRR ", err);
}


}


