import QtQuick 2.0

Item {	
	id: stub
	
    property var workingTimerList: new Array();
    property var timerObj : new Object();
    property var startTimerObj : new Object();
    property var samplingGroup;
    property var innerFunc ;
    property var setTimeInnerFunc ;
    property var startTime;
    property bool isRunning : false;

    function setStartDate(startDate)
    {
        var currentDate = new Date();

        if(currentDate > startDate)
        {
            startDate.setDate(currentDate.getDate() + 1);
        }
        else
        {
            startDate.setDate(currentDate.getDate());
        }
        
        startTime = startDate;

        var interval = startDate.getTime() - currentDate.getTime();

        var timerStr = 	'import QtQuick 2.0; Timer { id: timer; interval:' + interval + '; repeat: true; running: false }';
        startTimerObj = Qt.createQmlObject(timerStr, stub);

        setTimeInnerFunc = function() {
                            callStartTimeout(samplingGroup);
                        };

        startTimerObj.triggered.connect(setTimeInnerFunc);
        startTimerObj.start();
    }

    function callStartTimeout(samplingGroup)
    {
        startTimerObj.stop();
        startTimerObj.triggered.disconnect(setTimeInnerFunc);
        
        startTimer();

        setStartDate(startTime);
    }
	
	/*	
		local script인 경우, parent를 해당 script로 바꾸자. 
	*/	
    function setInterval(interval)
    {
        if(interval < 100)
        {
            interval = 100;
        }

        var timerStr = 	'import QtQuick 2.0; Timer { id: timer; interval:' + interval + '; repeat: true; running: false }';

        if(isRunning)
        {
            stopTimer();
            timerObj = Qt.createQmlObject(timerStr, stub);
            startTimer();
        }
        else
        {
            timerObj = Qt.createQmlObject(timerStr, stub);
        }
    }

    function startTimer()
    {
        if(!isRunning)
        {
            // connect가 func를 바로 전달하면 동작은 하나 function으로 인식하지 못해 error를 throw한다. 그래서
            // innerFunc으로 한번 wrapper를 쒸운다.

            innerFunc = function() {
                                samplingTimeout(samplingGroup);
                            };

            timerObj.triggered.connect(innerFunc);
            timerObj.start();
            isRunning = true;
        }
    }

    function stopTimer()
    {
        //console.log("into stopTimer");
        // connect가 func를 바로 전달하면 동작은 하나 function으로 인식하지 못해 error를 throw한다. 그래서
        // innerFunc으로 한번 wrapper를 쒸운다.

        if (innerFunc)
        {
            timerObj.triggered.disconnect(innerFunc);
            timerObj.stop();
            isRunning = false;
        }
    }

    function setGroup(group)
    {
        samplingGroup = group;
    }
}


