/****************************************************************************
**
** Copyright (C) 2013 Digia Plc and/or its subsidiary(-ies).
** Contact: http://www.qt-project.org/legal
**
** This file is part of the examples of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:BSD$
** You may use this file under the terms of the BSD license as follows:
**
** "Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are
** met:
**   * Redistributions of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**   * Redistributions in binary form must reproduce the above copyright
**     notice, this list of conditions and the following disclaimer in
**     the documentation and/or other materials provided with the
**     distribution.
**   * Neither the name of Digia Plc and its Subsidiary(-ies) nor the names
**     of its contributors may be used to endorse or promote products derived
**     from this software without specific prior written permission.
**
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
**
** $QT_END_LICENSE$
**
****************************************************************************/

import QtQuick 2.0
import com.wemx 1.0

Item {
	id: serviceMain;
	anchors.fill: parent;
	visible: false;
        
	z: 3;

    /*
    Rectangle {
        color: "black"
		anchors.fill: parent;
    }*/

	Text {
        id: textMsg
		anchors.centerIn: parent
		text: "Loading WEMXScreenChangeService..."
		font.pointSize: 24
		style: Text.Outline; styleColor: "white"
	}

	Loader { 
		id: pageLoader
		//anchors.fill: parent		
		asynchronous: true

        onStatusChanged:
        {
            if ( status == Loader.Ready )
            {
                textMsg.visible = false;
                pageLoader.item.show();
            }
        }        
	}

	function onMessageReceived(sender, msg) {
		switch (msg.kind) {
            case "MOUSE.DOUBLE_CLICK":
				serviceMain.visible = true;
                if ( pageLoader.status == Loader.Ready )
                {
//console.log(" -------------- item show .........................");                
                    pageLoader.item.show();
                }
                else
                {
				    pageLoader.source = "_component.qml"
                }
                   
                
/*
								
				var scaleValue = getFitToDisplayScale(800, 480, serviceMain.width, serviceMain.height);
				var scaleX = getFitToDisplayX(800, serviceMain.width);
				var scaleY = getFitToDisplayY(480, serviceMain.height);

//console.log(" -------------- ", pageLoader.width, pageLoader.height)				
				
//console.log("----- scale ------ >>>>>>>>>>>>>>>>. ", scaleValue, scaleX, scaleY);						
//console.log("----- scale ------ ", 800, 480, serviceMain.width, serviceMain.height);
		
				pageLoader.x = scaleX;
				pageLoader.y = scaleY;
				pageLoader.scale = scaleValue;
	*/			
				
				break;				
		}
    }

/*
	function getFitToDisplayScale(m_currentScreenWidth, m_currentScreenHeight, m_displayScreenWidth, m_displayScreenHeight)
	{
		var scale = 1.0;
		var widthScale, heightScale;
		
		if (m_displayScreenWidth == m_currentScreenWidth
			&& m_displayScreenHeight == m_currentScreenHeight)
		{
			scale = 1.0;
		}
		else if (m_currentScreenWidth > m_displayScreenWidth
			&& m_currentScreenHeight > m_displayScreenHeight)
		{
			widthScale = m_displayScreenWidth / m_currentScreenWidth;
			heightScale = m_displayScreenHeight / m_currentScreenHeight;

			if (widthScale < heightScale)
			{
				scale = widthScale;
			}
			else
			{
				scale = heightScale;
			}
		}
		else if (m_currentScreenWidth > m_displayScreenWidth
			&& m_currentScreenHeight <= m_displayScreenHeight)
		{
			scale = m_displayScreenWidth / m_currentScreenWidth;
		}
		else if (m_currentScreenHeight > m_displayScreenHeight
			&& m_currentScreenWidth <= m_displayScreenWidth)
		{
			scale = m_displayScreenHeight / m_currentScreenHeight;
		}
		else if (m_currentScreenHeight < m_displayScreenHeight
			&& m_currentScreenWidth < m_displayScreenWidth)
		{
			widthScale = m_displayScreenWidth / m_currentScreenWidth;
			heightScale = m_displayScreenHeight / m_currentScreenHeight;

			if (widthScale < heightScale)
			{
				scale = widthScale;
			}
			else
			{
				scale = heightScale;
			}
		}

		return scale;
	} 

	function getFitToDisplayX(m_currentScreenWidth, m_displayScreenWidth)
	{
		var calcX;
		
		if ( m_displayScreenWidth != m_currentScreenWidth )
		{
			calcX = (m_displayScreenWidth - m_currentScreenWidth) / 2;
		}
		else
		{
			calcX = 0;
		}
		return calcX;
	}

	function getFitToDisplayY(m_currentScreenHeight, m_displayScreenHeight)
	{
		var calcY;
		
		if ( m_displayScreenHeight != m_currentScreenHeight )
		{
			calcY = (m_displayScreenHeight - m_currentScreenHeight) / 2;
		}
		else
		{
			calcY = 0;
		}
		return calcY;
	}
*/



	
	Component.onCompleted: {
		console.log(">> start WEMX Screen Change Service...");
		
		wemx.conn.messageReceived.connect(onMessageReceived);
		wemx.setService("WEMXScreenChangeService", true);
	}
}

	
