import QtQuick 2.0
import QtQuick.LocalStorage 2.0
import com.wemx 1.0




Item {
	id: scriptServiceRootItem

	property var serviceName;
	
	property var scriptService: new Object()
//	property var execMagicNumber: 0
	property var execScriptInstance: null

    property var recipeServiceId: 0

	function s_call(screenNumber)
	{
		wemx.s_call(screenNumber);
	}

	
	function w_int32(strAddr)
	{
		var hAddr = wemx.get(strAddr, 32);
        if ( hAddr == undefined )   
        {
            throw "Exception: w_int32() invalid address " + strAddr;
        }
		return(hAddr.readWord32());
	}
		
	function w_uint16(strAddr)
	{
		var hAddr = wemx.get(strAddr, 16);
        if ( hAddr == undefined )   
        {
            throw "Exception: w_uint16() invalid address " + strAddr;
        }
		return(hAddr.readUWord16());
	}

	function w_uint32(strAddr)
	{
		var hAddr = wemx.get(strAddr, 32);
        if ( hAddr == undefined )   
        {
            throw "Exception: w_uint32() invalid address " + strAddr;
        }
		return(hAddr.readUWord32());
	}


	function w_int16(strAddr)
	{
		var hAddr = wemx.get(strAddr, 16);
        if ( hAddr == undefined )   
        {
            throw "Exception: w_int16() invalid address " + strAddr;
        }
		return(hAddr.readWord16());
	}
	

	function set_w_int16(strAddr, val)
	{
		var hAddr = wemx.get(strAddr, 16);
        if ( hAddr == undefined )   
        {
            throw "Exception: set_w_int16() invalid address " + strAddr;
        }
		hAddr.writeWord16(val);
	}	

	function set_w_uint16(strAddr, val)
	{
		var hAddr = wemx.get(strAddr, 16);
        if ( hAddr == undefined )   
        {
            throw "Exception: set_w_uint16() invalid address " + strAddr;
        }
		hAddr.writeUWord16(val);
	}	
			
	
	function set_w_int32(strAddr, val)
	{
		var hAddr = wemx.get(strAddr, 32);
        if ( hAddr == undefined )   
        {
            throw "Exception: set_w_int32() invalid address " + strAddr;
        }
		hAddr.writeWord32(val);
	}		
	

	function set_w_uint32(strAddr, val)
	{
		var hAddr = wemx.get(strAddr, 32);
        if ( hAddr == undefined )   
        {
            throw "Exception: set_w_uint32() invalid address " + strAddr;
        }
		hAddr.writeUWord32(val);
	}	
    
	function get_b(strAddr)
	{
		var hAddr = wemx.get(strAddr, 1);
        if ( hAddr == undefined )   
        {
            throw "Exception: get_b() invalid address " + strAddr;
        }
		return(hAddr.readBit());
	}	

		
	function set_b(strAddr, val)
	{
//console.log(" .......... set b ",	strAddr, serviceName);
		var hAddr = wemx.get(strAddr, 1);
        if ( hAddr == undefined )   
        {
            throw "Exception: set_b() invalid address " + strAddr;
        }
		hAddr.writeBit(val);
	}	
					

	function toggle_b(strAddr, val)
	{
		var hAddr = wemx.get(strAddr, 1);
        if ( hAddr == undefined )   
        {
            throw "Exception: toggle_b() invalid address " + strAddr;
        }
		var bVal = hAddr.readBit();
		hAddr.writeBit(!bVal);
	}	
		

	function w_hex16(strAddr)
	{
		var hAddr = wemx.get(strAddr, 16);
        if ( hAddr == undefined )   
        {
            throw "Exception: w_hex16() invalid address " + strAddr;
        }
		return(hAddr.readUWord16().toString(16));
	}
		
	function set_w_hex16(strAddr, val)
	{
		var hAddr = wemx.get(strAddr, 16);
        if ( hAddr == undefined )   
        {
            throw "Exception: set_w_hex16() invalid address " + strAddr;
        }
		hAddr.writeUWord16(parseInt(val,16));
	}
	
	function w_hex32(strAddr)
	{
		var hAddr = wemx.get(strAddr, 32);
        if ( hAddr == undefined )   
        {
            throw "Exception: w_hex32() invalid address " + strAddr;
        }
		return(hAddr.readUWord32().toString(16));
	}
	
	function set_w_hex32(strAddr, val)
	{
		var hAddr = wemx.get(strAddr, 32);
        if ( hAddr == undefined )   
        {
            throw "Exception: set_w_hex32() invalid address " + strAddr;
        }
		hAddr.writeUWord32(parseInt(val,16));
	}
	
	function w_string(strAddr, byteSize)
	{
		var hAddr = wemx.get(strAddr, byteSize << 3);
        if ( hAddr == undefined )   
        {
            throw "Exception: w_string() invalid address " + strAddr;
        }
		return hAddr.readString(byteSize);
	}
	
	function set_w_string(strAddr, byteSize, val)
	{
		var hAddr = wemx.get(strAddr, byteSize << 3);
        if ( hAddr == undefined )   
        {
            throw "Exception: set_w_string() invalid address " + strAddr;
        }
		hAddr.writeString(byteSize, val);
	}

    function get_data(strAddr, offset, arrBuf, bufOffset, nBits)
    {
        var hAddr = wemx.get(strAddr);  // ??? size  ʿ 
        if ( hAddr == undefined )   
        {
            throw "Exception: get_data() invalid address " + strAddr;
        }
        hAddr.readBits(offset, arrBuf, bufOffset, nBits);
    }

    function set_data(strAddr, offset, arrBuf, bufOffset, nBits)
    {
        var hAddr = wemx.get(strAddr);  // ??? size  ʿ        
        if ( hAddr == undefined )   
        {
            throw "Exception: set_data() invalid address " + strAddr;
        }
        hAddr.writeBits(offset, arrBuf, bufOffset, nBits);    
    }

/*   	
	function w_data(strAddr, wordSize)
	{
		return(wemx.w_data(strAddr, wordSize));
	}
	
	function set_w_data(strAddr, wordSize, val)
	{
		wemx.set_w_data(strAddr, wordSize, val);
	}		
*/

	function w_data8(strAddr, byteSize)
	{
	    var hAddr = wemx.get(strAddr, byteSize << 3);
        if ( hAddr == undefined )   
        {
            throw "Exception: w_data8() invalid address " + strAddr;
        }
        
        var readBuf = new ArrayBuffer(byteSize);
        hAddr.readBits(0, readBuf, 0, byteSize*8);
        
        var uint8View = new Uint8Array(readBuf);        
        return(uint8View);
        
		//return(wemx.w_data8(strAddr, byteSize));
	}
	
	function set_w_data8(strAddr, byteSize, arr)
	{
	    var hAddr = wemx.get(strAddr , byteSize << 3);
        if ( hAddr == undefined )   
        {
            throw "Exception: set_w_data8() invalid address " + strAddr;
        }
        
        var writeBuf = new ArrayBuffer(byteSize);
        var uint8View = new Uint8Array(writeBuf);         
        for(var i=0; i < uint8View.length; i++)
        {
            uint8View[i] = arr[i];
        }        
        hAddr.writeBits(0, writeBuf, 0, byteSize*8);        
    
		//wemx.set_w_data8(strAddr, byteSize, val);
	}	
	
	function w_data16(strAddr, wordSize)
	{
	    var hAddr = wemx.get(strAddr, wordSize << 4);
        if ( hAddr == undefined )   
        {
            throw "Exception: w_data16() invalid address " + strAddr;
        }
        
        var readBuf = new ArrayBuffer(wordSize*2);
        hAddr.readBits(0, readBuf, 0, wordSize*16);
        
        var uint16View = new Uint16Array(readBuf);        
        return(uint16View);

		//return(wemx.w_data16(strAddr, wordSize));
	}
	
	function set_w_data16(strAddr, wordSize, arr)
	{
	    var hAddr = wemx.get(strAddr, wordSize << 4);
        if ( hAddr == undefined )   
        {
            throw "Exception: set_w_data16() invalid address " + strAddr;
        }
        
        var writeBuf = new ArrayBuffer(wordSize*2);
        var uint16View = new Uint16Array(writeBuf);         
        for(var i=0; i < uint16View.length; i++)
        {
            uint16View[i] = arr[i];
        }        
        hAddr.writeBits(0, writeBuf, 0, wordSize*16);        
    
//		wemx.set_w_data16(strAddr, wordSize, val);
	}	



    function recipe_doTransfer(msg)
    {
        if ( recipeServiceId == 0 )
        {
            recipeServiceId = wemx.getService("WEMXRecipeService", true);
        }
  	    wemx.sendMessage(recipeServiceId, msg);
    }
        
	function recipe_transfer(control, group, block)
	{
		var msg = { 'kind': "transfer", 'control': control, 'group': group, 'block': block, 'index': 1, 'count': -1 }; 
        recipe_doTransfer(msg);
	}		
	
	function recipe_transfer2(control, group, block, index, count)
	{
		var msg = { 'kind': "transfer", 'control': control, 'group': group, 'block': block, 'index': index, 'count': count }; 
        recipe_doTransfer(msg);
	}		


	function delay()
	{
		console.log("no more not support delay() function");
		console.log("use setTimeout() or setInterval()");
	}
	
	function log_d(str)
	{
		wemx.log_d(str);
	}
	function log_e(str)
	{
		wemx.log_e(str);
	}
	function log_w(str)
	{
		wemx.log_w(str);
	}
	function log_i(str)
	{
		wemx.log_i(str);	
	}







	property var magicTimerId: 1
	property var wTimerIdToWTimerHash: new Object()
	property var freeWTimerList: new Array()
	property var useProgramTimer: true;
    property var isDaemon : false	    
	property var isConcurrent;
	property var scriptId;	

	
	function allocQMLTimer()	
	{	
		var timerStr =	'import QtQuick 2.0; Timer { property var wTimer: new Object(); onTriggered: { triggerTimer(wTimer);} }'; // interval:' + period + '; repeat: false; running: false }';	
		var timerObj = Qt.createQmlObject(timerStr, scriptServiceRootItem); 
		// connect func ٷ ϸ  ϳ function ν  error throwѴ. ׷	
		// innerFunc ѹ wrapper . 	
		
		return(timerObj)	
	}


	function generateMagicWTimerId()
	{
		if ( ++magicTimerId == 0 )
		{
			magicTimerId = 1;
		}
		return(magicTimerId);
	}
	
	function allocWEMXTimer()
	{
		var wTimer = freeWTimerList.pop();
		if ( wTimer == undefined )
		{
			wTimer = {};
			wTimer.qmlTimer = allocQMLTimer();
			wTimer.qmlTimer.wTimer = wTimer;		
		}

		wTimer.wTimerId = generateMagicWTimerId();
		wTimerIdToWTimerHash[wTimer.wTimerId] = wTimer;
		return(wTimer);
	}
	
	function freeWEMXTimer(wTimer)
	{
		delete wTimerIdToWTimerHash[wTimer.wTimerId];
		wTimer.wTimerId = 0;
		freeWTimerList.push(wTimer);	
	}
		
	function triggerTimer(wTimer)
	{
		//print("..... testExtCall ", wTimer.wTimerId);	//scriptInstance.runningTimerList.length);
		
		if ( wTimer.qmlTimer.repeat == true )
		{
			if ( isConcurrent == true )
			{
				wTimer.cbFunc();
			}
			else
			{
				wemx.scriptLock(scriptId);
				wTimer.cbFunc();
				wemx.scriptUnlock(scriptId);			
			}			
		}
		else
		{
			var clearWTimerId = wTimer.wTimerId;
			
			if ( isConcurrent == true )
			{
				wTimer.cbFunc();
			}
			else
			{
				wemx.scriptLock(scriptId);
				wTimer.cbFunc();
				wemx.scriptUnlock(scriptId);			
			}
			clearTimeout(clearWTimerId);
		}

//console.log(" triggerTime ... ", wTimer.scriptInstance.runningTimerCount, freeWTimerList.length);

		if ( (wTimer.scriptInstance.runningTimerCount == 0) && (isDaemon == false) )
		{
			execScriptInstance = null;
			wemx.scriptExecutionDone();
		}			
	}

	

	function setTimeoutWithInstance(func, period, bRepeat, parmScriptInstance)	
	{
		//console.log(" called setTimeout ... ");
		if ( useProgramTimer == false )
		{
			wemx.log_d("you cannot use setInterval(), setTimeout() function in script running with period option or switch invoke script")
			return(null);
		}
		
		var wTimer = allocWEMXTimer();
		wTimer.scriptInstance = parmScriptInstance;
		wTimer.cbFunc = func;
		if ( period <= 50 )
		{
			period = 50;
		}
		wTimer.qmlTimer.interval = period;
		wTimer.qmlTimer.repeat = bRepeat;
		
		parmScriptInstance.runningTimerList.push(wTimer);
		parmScriptInstance.runningTimerCount++;

//console.log("----------------- setTimeoutWithInstance -- ",	parmScriptInstance, parmScriptInstance.runningTimerList.length, parmScriptInstance.runningTimerCount);

		
		//wTimer.qmlTimer.start();

//print(" setTimeout id ... ", wTimer.wTimerId, parmScriptInstance.runningTimerList.length);
		
		return(wTimer);	//wTimer.wTimerId);  
	}

	
	function clearTimeout(wTimerId)
	{
	
//print(" clearTimeout id ... ", wTimerId);

		var wTimer = wTimerIdToWTimerHash[wTimerId];

//print(" clearTimeout id2  ... ", wTimer);

		if ( wTimer == undefined )
		{
//			wemx.log_d("try to clearTimeout at the invalid timer");
			return;
		}

		wTimer.qmlTimer.stop();
		var pos = wTimer.scriptInstance.runningTimerList.indexOf(wTimer);	
		if ( pos > -1 )
		{
			wTimer.scriptInstance.runningTimerList.splice(pos, 1);
			wTimer.scriptInstance.runningTimerCount--;
		}	
		freeWEMXTimer(wTimer);
	}	


	function clearInterval(wTimerId)
	{
		clearTimeout(wTimerId);
	}


		

	function initService() {
		scriptService.scriptHash = {};
	}
	
	
	function getScriptInstance(scriptId, path)
	{
		var scriptInstance = scriptService.scriptHash[scriptId];
		if ( scriptInstance == undefined )
		{
			//var path = wemx.resolvedPath(wemx.getSettings().projectFolder() + script.filePath);
//console.log("... -=================  script instance created... ", scriptId);

			//var path = wemx.scriptGetPath(scriptId);
		
			var stubStr = 'import QtQuick 2.0;import com.wemx 1.0;import "' + path + '" as Js;  WEMXScriptStub { id:stub; function startStub(period) { startMain(Js, period);}}';
			scriptInstance = Qt.createQmlObject(stubStr, scriptServiceRootItem);
			scriptService.scriptHash[scriptId] = scriptInstance;
		}
		return(scriptInstance);
	}



/*
    1. switch ũƮ ų 쿡 setTimeout  ʿ
*/
	function executeScript(parmScriptId, period, parmUseProgramTimer, path)
	{
		scriptId = parmScriptId;
		//isConcurrent = wemx.scriptIsConcurrent(parmScriptId);
		
		useProgramTimer = parmUseProgramTimer;
		//execMagicNumber = magicNumber;


//console.log("executeScript ", scriptId, period, ctrlAddrId, magicNumber);


		var scriptInstance = getScriptInstance(parmScriptId, path);
		execScriptInstance = scriptInstance;
		
		scriptInstance.startStub(period)
		
		if ( (scriptInstance.runningTimerCount == 0) && (isDaemon == false) )
		{
			execScriptInstance = null;
			wemx.scriptExecutionDone();
		}
	}


	function closeScript()
	{
//console.log("----------------- close Script -- ", 	execScriptInstance, execScriptInstance.runningTimerCount);

		if ( execScriptInstance != null )
		{
			var timerList = execScriptInstance.runningTimerList;
//console.log("----------------- close Script 2 -- ", 	timerList.length);			
			while( timerList.length > 0 )
			{
				clearTimeout(timerList[0].wTimerId);
			}

			if ( execScriptInstance.runningTimerCount > 0 )
			{
				execScriptInstance.stopPeriodTimer();
			}

			execScriptInstance = null;
		}
        
        wemx.scriptForceDone();    
	}


	
	function onMessageReceived(sender, msg) 
	{		
		//console.log("......... ScriptService onMessageReceived .........  ", msg.kind);
		
		switch(msg.kind)
		{
			case "execScript" :
                if ( msg.daemon == true )
                {
                    isDaemon = true;
                    wemx.conn.messageReceived.disconnect(onMessageReceived);
                }
                isConcurrent = msg.isConcurrent;

//console.log(" ---------- >> start ", msg.path, isConcurrent);

				executeScript(msg.scriptId, msg.period, msg.useProgramTimer, msg.path);
				break;
                
			case "forceCloseScript" :
				closeScript();
				break;
		}
	}




	Component.onCompleted: {
		wemx.conn.messageReceived.connect(onMessageReceived)		
		initService();
	}
}


