import QtQuick 2.0
import com.wemx 1.0


Item {	
	id: scriptInstance

	property var runningTimerCount;
	property var runningTimerList: new Array();

	
	function setInterval(func, period)	
	{
	/*
		if ( reqPeriod > 0 )
		{
			wemx.log_d("you cannot use setInterval() function in script running with period option")
			return;
		}*/

		var wTimer = setTimeoutWithInstance(func, period, true, scriptInstance);
		if ( wTimer == null )
		{
			return;
		}
		wTimer.qmlTimer.start();
		return(wTimer.wTimerId);
	}

	function setTimeout(func, period)	
	{
	/*
		if ( reqPeriod > 0 )
		{
			wemx.log_d("you cannot use setTimeout() function in script running with period option")
			return;
		}*/

		var wTimer = setTimeoutWithInstance(func, period, false, scriptInstance);
		if ( wTimer == null )
		{
			return;
		}		
		wTimer.qmlTimer.start();		
		return(wTimer.wTimerId);
	}


	function stopPeriodTimer()
	{
//print(" ---------- 	stopPeriodTimer() ..............", periodTimer.running, periodTimer);
		if ( periodTimer.running == true )
		{
			periodTimer.stop();
			runningTimerCount--;
		}

	}

	property var cbFunc;
	Timer {
		id: periodTimer
			
		repeat: true		
		onTriggered: {
//print(" .......... period timer callback ... ", periodTimer);
			if ( isConcurrent == true )
			{
				cbFunc() 
			}
			else
			{
				wemx.scriptLock(scriptId);
				cbFunc();
				wemx.scriptUnlock(scriptId);
			}
		}
	}


	function startMain(js, period)	//, parmCtrlAddrId)	
	{			
		if ( period > 0 )
		{	
			runningTimerCount = 1;
			
			cbFunc = js.startMain;
			periodTimer.interval = period;
			periodTimer.start();
		}
		else
		{
			runningTimerCount = 0;
			
			//console.log("  ... WEMX script stub... called .... ")
			if ( isConcurrent == true )
			{
				js.startMain();	
			}
			else
			{
				wemx.scriptLock(scriptId);
				js.startMain();
				wemx.scriptUnlock(scriptId);
			}

            if ( isDaemon == false )
            {
                wemx.scriptStartMainDone(scriptId);
            }
		}
	}	
}


