
var QT = { Checked:2 };

var LIMIT_OP = { OLDDELETE:0, STOP:1 };
var BACKUP_SAVE_PATH = { USB:0, SDCARD:1, INTERNAL:2 };
	
//const FILE_HEAD_SIZE = 128;
//const RECORD_SIZE = 128;


var codec = "EUC-KR";
var currentSize;
var oldFileTime = 0;
var limitSize;
var limitDay;
var onLimitOp;
var alarmFileList = [];


var blockFileList = [];
var saveStorage = "";
var dateFormat = "yyyy/MM/dd";
var timeFormat = "hh:mm:ss";
var alarmFolder = "/data/alarm";

var alarmStatusHAddr;

function init()
{
//	console.log(" .............. AlarmBackup new ...");

        var alarmStatusTagId = wemx.getSettings().getAlarmBackupStatusTag(); 
	alarmStatusHAddr = wemx.getTag(alarmStatusTagId)
	//alarmStatusHAddr = wemx.get("$control:ALARM_BACKUP_STATUS");

	var settings = wemx.getSettings();
	
	var wemxDataPath = settings.getWeMXDataPath();
	alarmFolder = wemxDataPath + "/alarm/";

	limitDay = settings.getAlarmBackupDayLimit();
	limitSize = settings.getAlarmBackupSizeLimit() * 1024 * 1024;
	onLimitOp = settings.getAlarmBackupLimitCondition();
	
	var savePath = settings.getAlarmBackupSavePath();
	if ( savePath == BACKUP_SAVE_PATH.USB )
	{
		saveStorage = "USB";
	}
	else if ( savePath == BACKUP_SAVE_PATH.SDCARD )
	{
		saveStorage = "SDCARD";
	}
	else
	{
		saveStorage = "APP_DATA";
	}

	if ( settings.getUseBackupDateFormat() == QT.Checked )
	{
		dateFormat = settings.getAlarmBackupDateFormat();
	}
	if ( settings.getUseBackupTimeFormat() == QT.Checked )
	{
		timeFormat = settings.getAlarmBackupTimeFormat();
	}
	
console.log(" ALARM ", limitDay, limitSize, onLimitOp, saveStorage, dateFormat, timeFormat);	

	var file = wemx.allocFile();

	if (file.setStorage(saveStorage))
	{
	    currentSize = file.size(alarmFolder);
	    //limitSize = 10*1024*1024;
	    //limitDay = 7;

	    var fileList = file.fileList(alarmFolder);
	    for(var i=0; i < fileList.length; i++)
	    {
	        //console.log("  list ... : ", fileList[i]);
		
	        var alarmFile = {};
	        alarmFile.used = false;
	        alarmFile.fileName = fileList[i];
	        alarmFile.lastModified = file.lastModified(alarmFolder + "/" + fileList[i]);

	        alarmFileList.push(alarmFile);
	    }
	
	    alarmFileList.sort(function(a, b) { return a.lastModified - b.lastModified } );
	    if( fileList.length > 0 )
	    {
	        oldFileTime = alarmFileList[0].lastModified;
	        var dateStr = new Date(oldFileTime).toLocaleDateString(Qt.locale(), "yyyyMMdd");
	        //console.log("LAST TIME ", oldFileTime, alarmFileList[0].fileName, dateStr);
	    }

	}

	wemx.freeFile(file);
}


function openBlockFile(block)
{
	var file = block.file;
	
	var dateStr = new Date().toLocaleDateString(Qt.locale(), "yyyyMMdd");
	var fileName = "wemx-alarm-" + block.blkNum + "-" + dateStr + ".csv";
		
	file.open(alarmFolder + "/" + fileName);

//console.log(" .............. writeRecord blockFile ... x1 ", block.blkNum);

	var fileSize = file.size();
	if ( fileSize == 0 )	//< FILE_HEAD_SIZE )
	{
		var backupFileHeader = 	"File Version, 0, 1\n" +
								"File Type, Alarm\n\n" +
								"Date, Time, Action, Message, Count, Level\n";
//								"Date, Time, Address, Action, Message, Count, Level\n";
		var writtenLen = file.write(backupFileHeader, -1);	//ILE_HEAD_SIZE);		
		if ( writtenLen < 0 )
		{
			alarmStatusHAddr.writeWord16(4);	// 4:  
		}
		else
		{		
			currentSize += writtenLen;	//backupFileHeader.length;		//FILE_HEAD_SIZE;
		}

//console.log("head write ...", currentSize, writtenLen, backupFileHeader.length);

		
		var alarmFile = {};
		alarmFile.fileName = fileName;
		alarmFile.lastModified = file.lastModified(alarmFolder + "/" + fileName);
		alarmFileList.push(alarmFile);

		alarmFile.used = true;
		block.alarmFile = alarmFile;
	}
	else
	{
		file.seek(fileSize);

		for(var i=0; i < alarmFileList.length; i++)
		{
			if ( alarmFileList[i].fileName == fileName )
			{
				alarmFileList[i].used = true;
				block.alarmFile = alarmFileList[i];
				break;
			}
		}		
	}
}

function closeBlockFile(block)
{
	block.file.close();
	block.alarmFile.used = false;
	block.alarmFile = null;
}





function deleteOldFile()
{
//console.log("  BACKUP: deleteOldFile ");

	if ( alarmFileList[0].used == true )
	{
		// old file ϴ   ʴ´. 
		return;
	}
	
	var file = wemx.allocFile();

	if (file.setStorage(saveStorage))
	{
	    currentSize -= file.size(alarmFolder + "/" + alarmFileList[0].fileName);
	    file.remove(alarmFolder + "/" + alarmFileList[0].fileName);
	    alarmFileList.splice(0, 1);

	    oldFileTime = alarmFileList[0].lastModified;
	}

	wemx.freeFile(file);
}


function writeFile(blkNum, storeData)
{
	var currentTime = new Date().getTime();
	
	if ( blockFileList[blkNum] == undefined )
	{
		var block = {};		
		var file = wemx.allocFile();

		if (file.setStorage(saveStorage))
		{
		    file.setCodec(codec);

		    block.file = file;
		    block.blkNum = blkNum;
		    block.toDay = Math.floor(currentTime / (1000*60*60*24));
			
		    blockFileList[blkNum] = block;


		    //console.log(" .............. writeRecord blockFile ... x2", blkNum);

		    openBlockFile(block);

		    if ( oldFileTime == 0 )
		    {
		        oldFileTime = alarmFileList[0].lastModified;
		    }
		}
		else
		{
		    wemx.freeFile(file);
		}
			
//console.log(" .............. writeRecord blockFile ... ", blkNum);
	}
	else
	{
	    if (!blockFileList[blkNum].file.setStorage(saveStorage))
	    {
	        alarmStatusHAddr.writeWord16(4);
	        return;
	    }
	}


//console.log(" BACKUP : writeFile 1 ", currentSize, limitSize);

	if ( currentSize >= limitSize )
	{
		if ( onLimitOp == LIMIT_OP.STOP )
		{
			alarmStatusHAddr.writeWord16(3);	// 3: 뷮ʰ 
			return;
		}
		else
		{	// old data   
			deleteOldFile();
		}
	}


	var elapsedDay = Math.floor( (currentTime - oldFileTime) / (1000*60*60*24) );

//console.log(" BACKUP : writeFile 2 ", elapsedDay, limitDay);
	
	if ( elapsedDay >= limitDay )
	{
		if ( onLimitOp == LIMIT_OP.STOP )
		{
			alarmStatusHAddr.writeWord16(2);	// 2:  ʰ  		
			return;
		}
		else
		{	// old data   
			deleteOldFile();
		}	
	}



	var currentDay = Math.floor(currentTime / (1000*60*60*24));

    //console.log(" BACKUP : writeFile 3 ", currentDay, blockFileList[blkNum].toDay);

	openBlockFile(blockFileList[blkNum]);

	if ( currentDay != blockFileList[blkNum].toDay )
	{
		blockFileList[blkNum].toDay = currentDay;
		closeBlockFile(blockFileList[blkNum]);
		openBlockFile(blockFileList[blkNum]);
	}

	var writtenLen = blockFileList[blkNum].file.write(storeData, -1);
	if ( writtenLen < 0 )
	{
		alarmStatusHAddr.writeWord16(4);	// 4:  
	}
	else
	{
		currentSize += writtenLen;	//storeData.length;		

//console.log("write size ", currentSize,  writtenLen, storeData.length);
		
	}

	closeBlockFile(blockFileList[blkNum]);
}




function insertRecord(alarm, mode, status, occurTime, recoveryTime, ackTime, message, count, level)
{
	
//console.log("::::::::: Backup ", alarm.alarmBlock.id);

	var dateStr;
	var date;
	if ( occurTime != 0 )
	{
		date = new Date(occurTime);
		dateStr = date.toLocaleDateString(Qt.locale(), dateFormat) + ", " + date.toLocaleTimeString(Qt.locale(), timeFormat) + ", TRIGGER";
	}
	else if ( recoveryTime != 0 )
	{
		date = new Date(recoveryTime);	
		dateStr = date.toLocaleDateString(Qt.locale(), dateFormat) + ", " + date.toLocaleTimeString(Qt.locale(), timeFormat) + ", RECOVERY";
	}
	else
	{
		date = new Date(ackTime);
		dateStr = date.toLocaleDateString(Qt.locale(), dateFormat) + ", " + date.toLocaleTimeString(Qt.locale(), timeFormat) + ", ACK";
	}
	
	var storeData = dateStr + ", " + message + ", " + count + ", " + level + "\n";
//console.log(storeData);	


try {
	writeFile(alarm.alarmBlock.id, storeData);
} catch (err) {
	console.log("ERRRRR ", err);
}


}


