

var WEMXRD_COMMSTATE_NONE =            (0x0000)
var WEMXRD_COMMSTATE_CONNECTING =      (0x0001)
var WEMXRD_COMMSTATE_CONNECTED =       (0x0002)
var WEMXRD_COMMSTATE_DISCONNECTED =    (0x0003)

//var WEMXRD_COMMERROR_NONE =                   (0x0000)
var WEMXRD_COMMERROR_NOTREACHABLEHOST =         (0x0100)
var WEMXRD_COMMERROR_MAXCONNECTION =            (0x0200)
var WEMXRD_COMMERROR_IDPWNOTMATCH =             (0x0300)
var WEMXRD_COMMERROR_UNAUTH =                   (0x0400)
var WEMXRD_COMMERROR_USERDISCONNECTED =         (0x0500)
var WEMXRD_COMMERROR_PEERDISCONNECTED =         (0x0600)
var WEMXRD_COMMERROR_WRONGPARM =                (0x0700)
var WEMXRD_COMMERROR_PROJECTVERSIONDONOTMATCH = (0x0800)

var WEMXRD_COMMERROR_DATACORRUPTED =    (0x1000)
var WEMXRD_COMMERROR_TIMEOUT       =    (0x2000)



var WEMXRD_TYPE_JSAPI0	=			1
var WEMXRD_TYPE_JSAPI1	=			2
var WEMXRD_TYPE_JSAPI2	=			3
var WEMXRD_TYPE_CAPI0   =           4
var WEMXRD_TYPE_CAPI1	=			5
var WEMXRD_TYPE_CAPI2  =			6
var WEMXRD_TYPE_REMOTE  =           21


var driverToInfoHash = {};

function getDispInfo(index)
{
    //console.log(" ---------------------------- >>>>>>>>>>>>>>>>>>         ----------- getDispInfo: ", index);
   return(listData[index].name + ":" + listData[index].stateStr + listData[index].stateCount);
}


function recoveryTimeoutCB(chInfo)
{
    for (var i=0; i < chInfo.driverInfoList.length; i++)
    {
        var driverInfo = chInfo.driverInfoList[i];
        if ( driverInfo.state != WEMXRD_COMMSTATE_CONNECTED )
        {                
            driverInfo.driver.connect();    //execute("connect", null, null);
        }
    }    
}

function changeSettingMap(chInfo, chDriver)
{
//console.log("ICON changeSettingMap >> ", tgDriver.name(), tgDriver.driverType());

    chInfo.recoveryCount = 0;

    switch(chDriver.driverType())
    {
        case WEMXRD_TYPE_CAPI1:
        case WEMXRD_TYPE_CAPI2:
        case WEMXRD_TYPE_JSAPI1:    // simple
        case WEMXRD_TYPE_JSAPI2:    // normal
        case WEMXRD_TYPE_REMOTE:
            var tgSettingMap = chDriver.executeS("getDeviceProperties", null, null);
            
            chInfo.maxRecoveryNumber = parseInt(tgSettingMap.RecoveryRetryCount);
            chInfo.recoveryTimeout = parseInt(tgSettingMap.WaitToRecoveryRetry);
            if ( chInfo.recoveryTimeout <= 0 )
            {
                chInfo.recoveryTimeout = 1;
            }

//console.log("StateIcon changeSettingMap >> ",   driverInfo.maxRecoveryNumber, driverInfo.recoveryTimeout);      
            return;

        default:
            chInfo.maxRecoveryNumber = 0;
            return;
    }    
}


function getChInfo(chDriver)
{
    var chInfo = chDriverToChInfoHash[chDriver];
    if ( chInfo == null )
    {
        chInfo = {};
        chInfo.driverInfoList = [];
        chInfo.recoveryTimer = timerService.executeS("getTimer", null, null);
        chInfo.recoveryTimer.setSingleShot(true);
        
        chDriverToChInfoHash[chDriver] = chInfo;        
    }
    return(chInfo);
}


var timerService;
var hideDelayTimer;

var chDriverToChInfoHash = {};
function updateDriverInfo(rscDriver, driverState)
{
    var driverName = rscDriver.fullName();  //name();
    var driverInfo = driverToInfoHash[driverName];
    if ( driverInfo == null )
    {
        driverInfo = {};
        driverInfo.name = driverName;
        driverInfo.driver = rscDriver;
        driverInfo.state = WEMXRD_COMMSTATE_NONE;
        driverInfo.stateCount = 0;

        
        var chDriver = (driverInfo.driver.parent() == null) ? driverInfo.driver : driverInfo.driver.parent();
        var chInfo = getChInfo(chDriver);
        driverInfo.chInfo = chInfo;
        chInfo.driverInfoList.push(driverInfo);
        
//console.log(" ------------------ updateDriverInfo::changeNotifySettingMap >> ", chDriver, chInfo);                
        changeSettingMap(chInfo, chDriver);
        driverToInfoHash[driverName] = driverInfo;
    }


    if ( driverInfo.state == driverState )
    {
        driverInfo.stateCount++;
    }
    else
    {
        driverInfo.stateCount = 1;
    }
    driverInfo.state = driverState;


    switch(driverState & 0x00FF)
    {
        case WEMXRD_COMMSTATE_DISCONNECTED:
        {
            var errState = driverState & 0xFF00;
            switch(errState)
            {
                case WEMXRD_COMMERROR_NOTREACHABLEHOST:
                    driverInfo.stateStr = "NR*";
                    break;

                case WEMXRD_COMMERROR_MAXCONNECTION:
                    driverInfo.stateStr = "MC*";
                    break;

                case WEMXRD_COMMERROR_IDPWNOTMATCH:
                    driverInfo.stateStr = "IP*";
                    break;

                case WEMXRD_COMMERROR_UNAUTH:
                    driverInfo.stateStr = "UA*";
                    break;
                    
                case WEMXRD_COMMERROR_USERDISCONNECTED:
                    driverInfo.stateStr = "UD*";
                    break;
    
                case WEMXRD_COMMERROR_PEERDISCONNECTED:
                    driverInfo.stateStr = "PD*";
                    break;

                case WEMXRD_COMMERROR_WRONGPARM:
                    driverInfo.stateStr = "WP*";
                    break;

                case WEMXRD_COMMERROR_PROJECTVERSIONDONOTMATCH:
                    driverInfo.stateStr = "PV*";
                    break;
                    
                case WEMXRD_COMMERROR_TIMEOUT:
                    driverInfo.stateStr = "TO*";
                    break;
            }            
            break;
        }
    
        case WEMXRD_COMMSTATE_CONNECTED:
        {
            var errState = driverState & 0xFF00;
            switch(errState)
            {
                case WEMXRD_COMMERROR_DATACORRUPTED:
                    driverInfo.stateStr = "DC";
                    break;
                    
                case WEMXRD_COMMERROR_TIMEOUT:
                    driverInfo.stateStr = "TO";
                    break;
    
                default:
                    driverInfo.stateStr = "~~";
                    driverInfo.stateCount = 0;
                    break;
            }     
            break;
        }
    }


    driverInfo.chInfo.bAllDisconnect = true;
    for(var i=0; i < driverInfo.chInfo.driverInfoList.length; i++)
    {
        var cbDriverInfo = driverInfo.chInfo.driverInfoList[i];
        if ( (cbDriverInfo.state & 0xff) != WEMXRD_COMMSTATE_DISCONNECTED )
        {
            driverInfo.chInfo.bAllDisconnect = false;
            break;
        }
    }

    return(driverInfo);
}



function setConnectionState(driverInfo) //, stateStr) 
{
    rotImage.visible = false;

//console.log(" --------- setConnectionState 1-----------::: ", driverInfo.name, stateStr);    //, driverInfo.recoveryCount, driverInfo.maxRecoveryNumber, driverInfo.recoveryTimeout);

    var chInfo = driverInfo.chInfo;
    if ( chInfo.bAllDisconnect == true )
    {
        if ( (chInfo.maxRecoveryNumber < 0) || (chInfo.recoveryCount < chInfo.maxRecoveryNumber) )
        {
            chInfo.recoveryCount++;
            chInfo.recoveryTimer.start(chInfo.recoveryTimeout, recoveryTimeoutCB, chInfo);
        }
    }
    else
    {
        chInfo.recoveryCount = 0;
    }


    var abnormalCount = 0;
    var tmpListData = []   
    for(var driverName in driverToInfoHash)
    {
        var tmpDriverInfo = driverToInfoHash[driverName];
        if ( tmpDriverInfo.state != WEMXRD_COMMSTATE_CONNECTED )
        {
            abnormalCount++;
            tmpListData.push(tmpDriverInfo);        
        }
        
//        tmpListData.push(tmpDriverInfo);        
    }
    listData = tmpListData;

   
    if ( abnormalCount == 0 )
    {
        hideDelayTimer.start(1000, hideDelayCB, null);
    }   
    else
    {    
        hideDelayTimer.stop();
        plcDisconnectView.visible = true;
        
    }

//console.log("setConnectionState 4 >> " , driverInfo, driverInfo.name, driverInfo.stateStr);
    doNotifyState(driverInfo);
}


function hideDelayCB()
{
    plcDisconnectView.visible = false;
}

function reconnect() 
{        
    for (var driverName in driverToInfoHash) 
    {
        var driverInfo = driverToInfoHash[driverName];
        if ( driverInfo.state != WEMXRD_COMMSTATE_CONNECTED )
        {                
//console.log("reconnect: ---------->>  ", driverInfo.name, driverInfo.stateStr);
            driverInfo.driver.connect();    //execute("connect", null, null);
        }
    }
}


var notifyListHash = {}

function doRegisterIconStateNotify(cb, connId)
{
//console.log("doRegisterIconStateNotify 1 >> --------------------------------------------- ", cb, connId);

    var cbList = notifyListHash[connId];
    if ( cbList == null )
    {
        cbList = [];
        notifyListHash[connId] = cbList;
    }

    cbList.push(cb);
    

    //  state notifyѴ. 
    for (var driverName in driverToInfoHash) 
    {
        var driverInfo = driverToInfoHash[driverName];
        
        var stateStr = driverInfo.stateStr + driverInfo.stateCount;                        
        commBlockIcon.callback(driverInfo.name, stateStr, cb);
    }


/*
    if ( notifyListHash[connId] != null )
    {
        console.log("WEMXCommBlockIcon >> already register ... ignore ...", connId, notifyHash[connId]);
        return;
    }
    notifyListHash[connId] = cb;

    //  state notifyѴ. 
    for (var driverName in driverToInfoHash) 
    {
        var driverInfo = driverToInfoHash[driverName];
        doNotifyState(driverInfo);  //.name, driverInfo.stateStr);
    }*/
}


function doDisConnection(connId)
{
//console.log("doDisConnection 1 >> --------------------------------------------- ", connId);

    notifyListHash[connId] = null;
}


function doNotifyState(driverInfo)  //driverName, stateStr)
{        
//console.log("WEMXCommBlockIcon 1 >> --------------------------------- ");

    for(var key in notifyListHash)
    {
        var cbList = notifyListHash[key];
        if ( cbList == null ) 
        {
            continue;
        }
                
        for(var i=0; i < cbList.length; i++)
        {
            var stateStr = driverInfo.stateStr + driverInfo.stateCount;                        
            commBlockIcon.callback(driverInfo.name, stateStr, cbList[i]);
        }
    }        
}


function doProgress(parm1, parm2)
{
//console.log(" ------------------------------------------- doProgress: ", parm1, parm2);

    switch(parm1)
    {
        case "start":
            remoteNameTextId.text = parm2;            
            pBar.value = 0;
            pTextId.text = "0";
            showProgress();
            break;
                        
        case "progress":
            pTextId.text = parm2.toString();
            pBar.value = parm2;
            break;
            
        case "end":
            hideProgress();
            break;
    }
}



function executed(cmd, args1, args2, cb, connId)
{
//console.log( "CommBlockIcon::executed >> ", cmd, args1, args2, cb, connId);

    switch(cmd)
    {
        case "newConnection":
            break;

        case "disConnection":
            doDisConnection(connId);
            break;

        case "reconnect":
            reconnect();
            break;

        case "registerIconStateNotify":
            doRegisterIconStateNotify(cb, connId);
            break;



            
        case "notifyDriverState":
//console.log("-------------------------- notifyDriverState >> ", args1, args2); 
            if ( (args2 == WEMXRD_COMMSTATE_NONE) || (args2 == WEMXRD_COMMSTATE_CONNECTING) )
            {
                return;
            }
            
            var driverInfo = updateDriverInfo(args1, args2);
            setConnectionState(driverInfo);                       
            break;

        case "notifyTransferState":
            doProgress(args1, args2);
            break;

        case "changeNotifySettingMap":
            var chInfo = getChInfo(args1);

//console.log(" ------------------ StateIconMain::changeNotifySettingMap >> ", args1, chInfo);          
            changeSettingMap(chInfo, args1);
            break;
            
        default:
            console.log("CommBlockIcon >> invalid command... ", cmd);
            break;
    }    
}


function init()
{
    commBlockIcon.conn.executed.connect(executed);
    commBlockIcon.setService("/local/CommBlockStateIcon", commBlockIcon);
    timerService = commBlockIcon.getService("/local/TimerService");

    hideDelayTimer = timerService.executeS("getTimer", null, null);
    hideDelayTimer.setSingleShot(true);    
}
  
