import QtQuick 2.0
import QtQuick.Controls 1.4
import com.wemx 1.0
import "StateIconMain.js" as Main


WEMXService {
	id: commBlockIcon

        
	width:800
	height:480
//	visible: false;
	z: 1;


//	property int horizontalMargin: 4;	
//	property int verticalMargin: 8;	
	property int iconWidth: 64 + 48;	
	property int iconHeight: 64;	
	property int listItemHeight: 20;	
	property int textPointSize: 9;	


	property var listData: new Array()


    Item {          // progress bar
        id: progressBarId
        anchors.top: parent.top
        anchors.topMargin: 8
        anchors.right: parent.right
        anchors.rightMargin: 4
        visible: false
        		
        width: iconWidth;
        height: iconHeight;

        Text {
            id: remoteNameTextId
            anchors.horizontalCenter: pBar.horizontalCenter    
            anchors.top: parent.top
        }
        
        ProgressBar {
            id: pBar
            anchors.top: remoteNameTextId.bottom
            width: iconWidth;
            height: 18
            minimumValue: 0
            maximumValue: 100
            value: 0
        }

        Text {
            id: pTextId
            anchors.horizontalCenter: pBar.horizontalCenter
            anchors.verticalCenter: pBar.verticalCenter
            //style: Text.Outline
            //styleColor: "white"
        }
    } 

    function showProgress()
    {
        progressBarId.visible = true
        plcDisconnect.y = 40
    }
    
    function hideProgress()
    {
        progressBarId.visible = false
        plcDisconnect.y = 8;
    }

	Item {
		id: plcDisconnect;
        y: 8
        anchors.right: parent.right
        anchors.rightMargin: 4
        
		width: iconWidth;
		height: parent.height;  // - (verticalMargin * 2);

		// signal playSound(int soundType);
		// property string fontFamily: "";
		// property int touchSoundType: 0;
		
		Item {
			id: plcDisconnectView;
			width: parent.width; //iconWidth;
			height: parent.height;
            visible: false
            
            onVisibleChanged: {
                if ( visible == true )
                {
                    blinkTimer.start();
                }
                else
                {
                    blinkTimer.stop();
                }
            }

            Image {    				
                id: plcDisconnectIcon;
				width: parent.width;    //iconWidth;
				height: iconHeight;
				source: "disconnect.png";       

                Timer {
                    id: blinkTimer
                    interval: 600; 
                    repeat: true;
                        
                    onTriggered: {
                        if (plcDisconnectIcon.visible) {
                            plcDisconnectIcon.visible = false;
                        } else {
                            plcDisconnectIcon.visible = true;
                        }
                    }
                }
			}

			Item {
				width: parent.width;    //iconWidth;
				height: iconHeight;   
			
				MouseArea {
					anchors.fill: parent

					onPressed: {
						// plcDisconnect.playSound(touchSoundType);
					}

					onClicked: {
                        plcDisconnectView.visible = false;
                        rotImage.visible = true;   
/*                        
                        if ( progressBarId.visible == true )
                        {
                            hideProgress();
                        }
                        else
                        {
                            showProgress();
                        }*/
						Main.reconnect();
					}
				}
			}
		
			Rectangle {
				id: plcDisconnectListBG;
                anchors.top: plcDisconnectIcon.bottom
				width: parent.width;    //iconWidth;
				height: listItemHeight * listData.length
				color: "#FF0F0F0F";
			}

/*
			ListModel {
				id: plcDisconnectListModel;
			}*/

			ListView {
				id: plcDisconnectListView;
                anchors.top: plcDisconnectIcon.bottom
				width: parent.width;    //iconWidth;
				height: listItemHeight * listData.length
				clip: true;
				orientation: ListView.Vertical;
                model: listData
				//model: plcDisconnectListModel;
				delegate: plcDisconnectItemDelegate;
			}

	
			Rectangle {
				id: plcDisconnectListBorder;
                anchors.top: plcDisconnectIcon.bottom
				width: parent.width;    //iconWidth;
				height: listItemHeight * listData.length
				color: "#00000000";
				border.width: 2;
				border.color: "#FF999B9D";
			}
		}

        Image {
            id: rotImage
            visible: false
            x: iconWidth*0.5/2
            y: iconWidth*0.5/2
    		width: iconWidth*0.5;
    		height: iconWidth*0.5;     
            source: "loading_1.png"

            RotationAnimation on rotation {
                loops: Animation.Infinite
                from: 0
                to: 360
                duration: 2000
            }
        }        
	}



    Component {       
        id: plcDisconnectItemDelegate;

        Item {
            width: iconWidth;
            height: listItemHeight;
        
            Rectangle {
                width: iconWidth;
                height: listItemHeight;
                color: "#FF0F0F0F";
                border.color: "#FF999B9D";
            }
        
            Text {
                width: iconWidth;
                height: listItemHeight;
                elide: Text.ElideLeft   //Text.ElideRight
                horizontalAlignment: Text.AlignHCenter;
                verticalAlignment: Text.AlignVCenter;
                // font.family: fontFamily;
                font.bold: true
                //font.pixelSize: getFontPixelSize(parent.width, parent.height)
                font.pointSize: textPointSize;
                clip: true
                text: Main.getDispInfo(index);  //plcName;
                color: "#FFFFFFFF"
            }
        }
    }


	Component.onCompleted: {
		console.log(">> start WEMXCommBlockIcon Service ...");
        Main.init();
	}
}
    
