
var WEMXRD_COMMSTATE_CONNECTING      = (0x0001)
var WEMXRD_COMMSTATE_CONNECTED       = (0x0002)
var WEMXRD_COMMSTATE_DISCONNECTED    = (0x0003)


var timerService;
var hideDelayTimer;

var driverToInfoHash = {}
var iconServicePeer = null;

function getDispInfo(index)
{
    //console.log(" ---------------------------- >>>>>>>>>>>>>>>>>>         ----------- getDispInfo: ", index);
    return( listData[index].name + ":" +  listData[index].stateStr );
}


function setConnectionState(driverName, stateStr) 
{
    rotImage.visible = false;

//console.log(" --------- setConnectionState CLIENT -----------::: ", driverName, stateStr)    //, stateParm[1]);	

    var driverInfo = driverToInfoHash[driverName];
    if ( driverInfo == null )
    {
        driverInfo = {};
        driverInfo.name = driverName;
        driverToInfoHash[driverName] = driverInfo;
    }

    driverInfo.stateStr = stateStr;


    var abnormalCount = 0;
    var tmpListData = []
    for(var driverName in driverToInfoHash)
    {
        var driverInfo = driverToInfoHash[driverName];
        if ( driverInfo.stateStr != "~~0" )
        {
            abnormalCount++;
            tmpListData.push(driverInfo);
        }
    }
    listData = tmpListData;


    if ( abnormalCount == 0 )   //listData.length == 0 )
    {
        hideDelayTimer.start(1000, hideDelayCB, null);
    }   
    else
    {    
        hideDelayTimer.stop();
        // plcDisconnectView.visible = true;
        
    }

/*
    if ( listData.length == 0 )
    {
        plcDisconnectView.visible = false;
        return;
    }   
    else
    {
        plcDisconnectView.visible = true;
    }*/
}


function hideDelayCB()
{
    plcDisconnectView.visible = false;
}


function reconnect() {     
    if ( iconServicePeer != null )
    {
        iconServicePeer.execute("reconnect", null, null);
    }
}



function itemOpenedParm(pIconServicePeer)
{
//console.log(">> start WEMXCommBlockIconClient ................... open: ", wemx, pRemoteDriver);

    if ( pIconServicePeer == null )
    {
        console.log("WEMXCommBlockIconClient itemOpenedParm >> can't find '/remote/local/CommBlockStateIcon' driver...");
        return;
    }

    iconServicePeer = pIconServicePeer;
}


function itemClosed()
{
//console.log(">> start WEMXCommBlockIconClient .................... close: ");

    hideDelayTimer.stop();


    driverToInfoHash = {}
    rotImage.visible = false;
    plcDisconnectView.visible = false;
    
    iconServicePeer = null;
}


function executed(cmd, args1, args2, cb, connId)
{
//console.log( "CommBlockIcon::executed >> ", cmd, args1, args2, cb, connId);

    switch(cmd)
    {
        case "notifyIconState":
            setConnectionState(args1, args2);   //driverName, stateStr);
            break;
            
        default:
            console.log("CommBlockIcon >> invalid command... ", cmd);
            break;
    }    
}


function init()
{
    wemx.conn.executed.connect(executed);
    wemx.conn.itemOpenedParm.connect(itemOpenedParm)    
    wemx.conn.itemClosed.connect(itemClosed)


    timerService = wemx.getService("/local/TimerService");

    hideDelayTimer = timerService.executeS("getTimer", null, null);
    hideDelayTimer.setSingleShot(true);      
}

