.pragma library

var API_VERSION = "2.0"

var sResponse = undefined;

var WEBSERVICE_TIMEOUT = 3000;

function isEmpty(str) {
	if (typeof str === 'string' || str instanceof String)
		return (!str || 0 === str.length);
	return true;
}

function makeDate(date, time) {
	if (isEmpty(date) || isEmpty(time)) {
		return "";
	}

	var str = "20" + date + " " + time;
	var date = new Date(str);	
	//console.log( "makeDate() : " + date.toISOString());
	
	return date.toISOString();
}


/**
GET https://10.0.0.1/service
*/
function doGet(http, wemx, parames, request, response) {
	return 410
}

/**
POST https://10.0.0.1/service
*/
function doPost(http, wemx, parames, request, response) {

	var json = JSON.parse(request.body);

	var path = json["path"];
	var command = json["command"];
	var param1 = json["param1"];
	var param2 = json["param2"];

	console.log( "doPost", path, command, param1, param2);

	if (isEmpty(path)) {
		console.log( "405 Wrong parameter path : " + path);
		return 405;
	}

	if (isEmpty(command)) {
		console.log( "405 Wrong parameter path : " + command);
		return 405;
	}

	var service = wemx.getService(path);

	if (!service) {
		console.log( "405 There are no service : " + path);
		return 405;
	}

	var result;
	var arrayParam1;

	try {
		arrayParam1 = JSON.parse(param1); 
	} catch (e){
		arrayParam1 = param1;
	}

	// if there are no return value for the command
	if (command == "alarmAck"
		|| command == "alarmAckAll") {
		service.executeS(command, arrayParam1, param2, 1000);
		result = "OK";
	} else {
		result = service.executeS(command, arrayParam1, param2, WEBSERVICE_TIMEOUT);
	}
	
	//console.log( "result : " + result);

	var json = {};
			
	json["version"] = API_VERSION;
	json["result"] 	= result;
	
	var str = JSON.stringify(json);
	//console.log("response body :" + str);
	
	response.setHeader("Content-Type", "application/json; charset=UTF-8;");
	response.setHeader("Connection", request.getHeaderHash("Connection"));
	response.setHeader("Keep-Alive", "timeout=5, max=100");
	response.setHeader("Content-Length", str.length);
	response.writeHead(200);
	
	response.write(str);
	response.end();
	return 200;	
}

/**
	PUT https://10.0.0.1/service
*/
function doPut(http, wemx, parames, request, response) {
	return 410
}

/**
	DELETE https://10.0.0.1/service
*/
function doDelete(http, wemx, parames, request, response) {
	return 410
}