.import "Util.js" as Util

var gSenderTimer;
var gServerUrl;
var gProjectName;
var gHostName;
var gHostPort;
var gUsePushNotification;
var gPushId;
var gAuthKey;
var gAlarmGroups = [];
var gAlarmLevelStart;
var gAlarmLevelEnd;
var gAlarmState = [];
var gStartScreen;
var gAlarmDataQueue;
var gPendingRequestData = "";
var gStopSendingPushData = false;

var gRemoteAccessExternalIPTag;
var gRemoteAccessExternalPortTag;

var gUsePinCode;
var gServerId;

var MAX_QUEUE_LENGTH = 128;

var HTTP_STATUS_TYPE = { IDLE:0, REQUESTING:1};
var HTTP_RETRY_DELAY = 10000;
var HTTP_REQUEST_DELAY = 500;
var HTTP_RETRY_DELAY_WHEN_REACH_LIMIT = 1000 * 60 * 60;

var http_status;

// 2.0 Push Notification Json 
/*
ALARM_TYPE { HIHI = 1, HI, LO, LOLO, RATE, MAJORDEV, MINORDEV, ON, OFF, ON_OFF, OFF_ON };

ALARM_STATE { OCCUR = 1, RECOVERY, OCCUR_ACK, RECOVERY_ACK };

ALARM_TIME_TYPE { OCCUR = 1, RECOVERY, OCCUR_ACK, RECOVERY_ACK };

item.ip_host = hostName;
item.port = hostPort
item.project_name = gProjectName;
item.time = alarmData.time;
item.message = alarmData.message;
item.type = "alarm"
item.screen = screenNumber;
item.ext_data.alarm_group = alarmData.group;
item.ext_data.time_type = alarmData.time_type;
item.ext_data.tag_name = alarmData.tag_name;
item.ext_data.tag_value = alarmData.tag_value;
item.ext_data.alarm_type = alarmData.alarm_type;
item.ext_data.state = alarmData.state;
item.ext_data.level = alarmData.level;   
item.ext_data.comment = alarmData.comment;
*/

var rdSetting;

function isEmpty(str) {
	return (str.length === 0 || !str.trim());
}

function initService(timer) {
//    console.log(">> initService()");

    gSenderTimer = timer;
    gSenderTimer.triggered.connect(sendPushData);
    http_status = HTTP_STATUS_TYPE.IDLE;

    gAlarmDataQueue = new Util.Queue(MAX_QUEUE_LENGTH);

    
    rdSetting = wemx.getRDSetting(); //getService("/local/SettingService");
/*    
    var pushAlarmSetting = rdSetting.PushAlarm;
    for(var key in pushAlarmSetting)
    {
console.log("rdSetting: ", key,  pushAlarmSetting[key]);   
    }*/
    

    gUsePushNotification = rdSetting.PushAlarm.UsePushNotification; //  wemx.getSettings().getUsePushNotification();

    gServerUrl = "https://wemx-player.appspot.com/";

    gProjectName = rdSetting.Information.ProjectName;   // wemx.getSettings().getProjectName();
    console.log(">> project name: " + gProjectName);

    //if (rdSetting.Communication.ConnectionType == "PIN Code" && !isEmpty(rdSetting.Communication.IpHostname)) {
	if (rdSetting.Communication.ConnectionType == "PIN Code" && !isEmpty(rdSetting.Communication.PinCode)) {
        gUsePinCode = true;
    } else {
        gUsePinCode = false;
    }

    gServerId = rdSetting.Communication.ServerId;
	console.log(">> ConnectionType: " + rdSetting.Communication.ConnectionType);
	console.log(">> IpHostname: " + rdSetting.Communication.IpHostname);
	console.log(">> PinCode: " + rdSetting.Communication.PinCode);
    console.log(">> gUsePinCode: " + gUsePinCode);
    console.log(">> gServerId: " + gServerId);

    var hostName = rdSetting.getDeviceInformations().hostName;      // wemx.getSettings().getDeviceInformations().hostName;
    var ipAddress = rdSetting.getDeviceInformations().ipAddress;    // wemx.getSettings().getDeviceInformations().ipAddress;

    if ( hostName && hostName.length !== 0 && hostName.indexOf(".") != -1) {
        gHostName = hostName;
    } else {
        gHostName = ipAddress;
    }

	gHostPort = 33000;
    if (gUsePinCode) {
        gHostName = "PINCODE:"+rdSetting.Communication.PinCode;
		gHostPort = gServerId;
    }

    console.log(">> host name: " + hostName);
    console.log(">> ip address: " + ipAddress);

    if (gUsePushNotification == true) {
        console.log(">> use push notification!");

        gPushId = rdSetting.PushAlarm.PushID;   // wemx.getSettings().getPushId();
        console.log(">> push id: " + gPushId);

        gAuthKey = rdSetting.PushAlarm.AuthKey; // wemx.getSettings().getPushAuthKey();
        console.log(">> push auth key: " + gAuthKey);

        if (rdSetting.PushAlarm.SpecifyHostInfo == true)    //if (wemx.getSettings().getPushSpecifyHost() == true)
        {
			if (!gUsePinCode )
			{
				gHostName = rdSetting.PushAlarm.HostName;   // wemx.getSettings().getPushHostName();
				gHostPort = rdSetting.PushAlarm.Port;       // wemx.getSettings().getPushHostPort();
			}
        }

        gAlarmGroups = JSON.parse(rdSetting.PushAlarm.AlarmGroups); // wemx.getSettings().getPushAlarmGroups());
        gAlarmLevelStart = rdSetting.PushAlarm.AlarmLevelStart; // wemx.getSettings().getPushAlarmLevelStart();
        gAlarmLevelEnd = rdSetting.PushAlarm.AlarmLevelEnd;     // wemx.getSettings().getPushAlarmLevelEnd();
        var alarmState = JSON.parse(rdSetting.PushAlarm.AlarmStateInfo);    // wemx.getSettings().getPushAlarmStateInfo());

        for(var i = 0; i < alarmState.length ; i++)
        {
            if (alarmState[i] === "Occurrence")
            {
                gAlarmState.push(1);
            } 
            else if (alarmState[i] === "Acknowledge")
            {
                gAlarmState.push(3);
                gAlarmState.push(4);
            }
            else if (alarmState[i] === "Recovery")
            {
                gAlarmState.push(2); 
            }            
        }

        if (rdSetting.PushAlarm.SpecifyStartScreen == true) //if (wemx.getSettings().getPushSpecifyStartScreen() == true)
        {
            gStartScreen = rdSetting.PushAlarm.StartScreen; // wemx.getSettings().getPushStartScreen();
        }
        else
        {
            gStartScreen = "";
        }
        
        console.log(">> gUsePinCode: " + gUsePinCode);
        console.log(">> gHostName: " + gHostName);
        console.log(">> gHostPort: " + gHostPort);
        console.log(">> gAlarmGroups: " + JSON.stringify(gAlarmGroups));
        console.log(">> gAlarmLevelStart: " + gAlarmLevelStart);
        console.log(">> gAlarmLevelEnd: " + gAlarmLevelEnd);
        console.log(">> gAlarmState: " + JSON.stringify(gAlarmState));
        console.log(">> gStartScreen: " + gStartScreen);
    }

    wemx.conn.executed.connect(executed);
    wemx.setService("/local/PushNotificationService", wemx);
}

function executed(cmd, args1, args2, cb, connId)    
{
    console.log(">> executed:", cmd);

    if (gStopSendingPushData == true) {
        console.log(">> executed: gStopSendingPushData == true");        
        return;
    }

    if ( cmd == "appendAlarmPushData" )
    {
        console.log(">> received appendAlarmPushData");

        var pushData = {};
/*
        pushData.group = args1[0];
        pushData.tag_name = args1[1];
        pushData.tag_value = args1[2];
        pushData.alarm_type = args1[3];
        pushData.time_type = args1[4];
        pushData.time = args1[5];
        pushData.message = args1[6];
        pushData.comment = args1[7];
        pushData.level = args1[8];
        pushData.state = args1[9];
        pushData.active = args1[10];
*/
        pushData.ext_data = {};

        pushData.ext_data.alarm_group = args1[0];
        pushData.ext_data.tag_name = args1[1];
        pushData.ext_data.tag_value = args1[2];
        pushData.ext_data.alarm_type = args1[3];
        pushData.ext_data.time_type = args1[4];
        pushData.time = args1[5];
        pushData.message = args1[6];
        pushData.type = "alarm";
        pushData.ext_data.comment = args1[7];
        pushData.ext_data.level = args1[8];
        pushData.ext_data.state = args1[9];
        pushData.ext_data.active = args1[10];
        console.log(">> received pushData : ", JSON.stringify(pushData));

        if ((gAlarmGroups[0] === true || contains(gAlarmGroups, pushData.ext_data.alarm_group)) 
                && gAlarmLevelStart <= pushData.ext_data.level
                && gAlarmLevelEnd >= pushData.ext_data.level
                && contains(gAlarmState, parseInt(pushData.ext_data.state)))
        {
            console.log(">> received pushData enqueue");

            // Convert int to readable string
            pushData.ext_data.time_type = getTimeTypeString(pushData.ext_data.time_type);
            pushData.ext_data.state = getStateString(pushData.ext_data.state);
            pushData.ext_data.alarm_type = getAlarmTypeString(pushData.ext_data.alarm_type);
            pushData.ext_data.level = pushData.ext_data.level.toString();

            gAlarmDataQueue.enqueue(pushData);
            if (http_status == HTTP_STATUS_TYPE.IDLE) {
                gSenderTimer.interval = HTTP_REQUEST_DELAY;
                gSenderTimer.restart();
            }
        }
    }
    else if ( cmd == "appendUserPushData" )
    {
        console.log(">> received appendUserPushData");

        var pushData = {};
        pushData.ext_data = {};

        pushData.time = args1[0];
        pushData.message = args1[1];
        pushData.type = "user";
        pushData.ext_data = args1[2];
        pushData.screen = args1[3];
        console.log(">> received pushData : ", JSON.stringify(pushData));     

        gAlarmDataQueue.enqueue(pushData);
        if (http_status == HTTP_STATUS_TYPE.IDLE) {
            gSenderTimer.interval = HTTP_REQUEST_DELAY;
            gSenderTimer.restart();
        }
    }
}

function getStateString(state) {
    var stateString;

    switch(parseInt(state)) {
        case 1:
            stateString = "OCCUR";
            break;
        case 2:
            stateString = "RECOVERY";
            break;
        case 3:
            stateString = "OCCUR_ACK";
            break;
        case 4:
            stateString = "RECOVERY_ACK";
            break;
        default:
            stateString = "UNKNOWN";
            break;
    }
    return stateString;
}

function getTimeTypeString(timeType) {
    var timeTypeString;

    switch(parseInt(timeType)) {
        case 1:
            timeTypeString = "OCCUR";
            break;
        case 2:
            timeTypeString = "RECOVERY";
            break;
        case 3:
            timeTypeString = "OCCUR_ACK";
            break;
        case 4:
            timeTypeString = "RECOVERY_ACK";
            break;
        default:
            timeTypeString = "UNKNOWN";
            break;
    }
    return timeTypeString;
}

function getAlarmTypeString(alarmType) {
    var alarmTypeString;

    switch(parseInt(alarmType)) {
        case 0:
            alarmTypeString = "HiHi";
            break;
        case 1:
            alarmTypeString = "Hi";
            break;
        case 2:
            alarmTypeString = "LO";
            break;
        case 3:
            alarmTypeString = "LOLO";
            break;
        case 4:
            alarmTypeString = "RATE";
            break;
        case 5:
            alarmTypeString = "MAJORDEV";
            break;
        case 6:
            alarmTypeString = "MINORDEV";
            break;
        case 7:
            alarmTypeString = "ON";
            break;
        case 8:
            alarmTypeString = "OFF";
            break;
        case 9:
            alarmTypeString = "ON_OFF";
            break;
        case 10:
            alarmTypeString = "OFF_ON";
            break;
        default:
            alarmTypeString = "UNKNOWN";
            break;
    }
    return alarmTypeString;
}

function contains(a, obj) {
    var i = a.length;
    while (i--) {
       if (a[i] === obj) {
           return true;
       }
    }
    return false;
}

function isEmpty(str) {
    return (!str || 0 === str.length);
}

function clearAlarmDataQueue() {
    while (gAlarmDataQueue.isEmpty() != true){
        gAlarmDataQueue.dequeue();
    }
}

function getRequestDataString() {
    var requestData = {};
    var requestDataString;

    requestData.push_user_id = gPushId;

    var itemArray = [];

    while (gAlarmDataQueue.isEmpty() != true){
        var item = {};
        var alarmData = {};

        alarmData = gAlarmDataQueue.dequeue();

        item.ip_host = gHostName;
        item.port = gHostPort;

        if (rdSetting.PushAlarm.SpecifyHostInfo != true)        //if (wemx.getSettings().getPushSpecifyHost() != true)
        {
            if (gUsePinCode == false && rdSetting.Communication.UseUPNP == true)
            {
                if (gRemoteAccessExternalIPTag == null || gRemoteAccessExternalIPTag == null)
                {
                    gRemoteAccessExternalIPTag = wemx.get("RemoteAccessExternalIP");
                    gRemoteAccessExternalPortTag = wemx.get("RemoteAccessExternalPort");
                }

                if (gRemoteAccessExternalIPTag != null && gRemoteAccessExternalPortTag != null)
                {
                    var externalIp = gRemoteAccessExternalIPTag.readString();
                    var externalPort = gRemoteAccessExternalPortTag.readInteger();

                    if (!isEmpty(externalIp) && externalPort != 0)
                    {
                        console.log(">> externalIp: " + externalIp);
                        console.log(">> externalPort: " + externalPort);
                        item.ip_host = externalIp;
                        item.port = externalPort;
                    }
                    else
                    {
                        console.log(">> externalIp: empty ");
                        var deviceInfo = rdSetting.getDeviceInformations();
                        var hostName = rdSetting.getDeviceInformations().hostName;
                        var ipAddress = rdSetting.getDeviceInformations().ipAddress;

                        if ( hostName && hostName.length !== 0 && hostName.indexOf(".") != -1) {
                            item.ip_host = hostName;
                        } else {
                            item.ip_host = ipAddress;
                        }
                    }
                }
            }
        }

console.log(">> item.ip_host: " + item.ip_host);
console.log(">> item.port: " + item.port);        

        item.project_name = gProjectName;
        var date = new Date(parseInt(alarmData.time))
        item.time = date.toISOString();
        item.message = alarmData.message;
        item.type = alarmData.type;
        item.screen = gStartScreen;
        item.ext_data = {};
        if (item.type == "alarm")
        {
            item.ext_data.alarm_group = alarmData.ext_data.alarm_group;
            item.ext_data.time_type = alarmData.ext_data.time_type;
            item.ext_data.tag_name = alarmData.ext_data.tag_name;
            item.ext_data.tag_value = alarmData.ext_data.tag_value;
            item.ext_data.alarm_type = alarmData.ext_data.alarm_type;
            item.ext_data.state = alarmData.ext_data.state;
            item.ext_data.level = alarmData.ext_data.level;   
            item.ext_data.comment = alarmData.ext_data.comment;            
        }
        else if (item.type == "user")
        {
            item.ext_data = alarmData.ext_data;
            item.screen = alarmData.screen;
        }

        itemArray.push(item);
    }

    requestData.data = itemArray;
    requestDataString = JSON.stringify(requestData);

    console.log(">> getRequestDataString: " + requestDataString);
    return requestDataString;
}

function sendPushData() {
    if ((!gPendingRequestData || gPendingRequestData.length === 0)
            && gAlarmDataQueue.isEmpty()) {
        return;
    }

    if (gPendingRequestData.length == 0 || gAlarmDataQueue.getLength() >= MAX_QUEUE_LENGTH) {
        gPendingRequestData = getRequestDataString();
    }
    http_status = HTTP_STATUS_TYPE.REQUESTING;

    
    postJson(gPendingRequestData, function (status, response) {
        console.log(">> postJson callback");
        console.log(">> status: " + status);

        if (status == 200) {
            if (response || response != undefined) {
                console.log(">> response: " + response);
                gPendingRequestData = "";

                if (response.saved_count == 0 && response.error != undefined) {
                    console.log(">> response.error : " + response.error);
                    gSenderTimer.interval = HTTP_RETRY_DELAY_WHEN_REACH_LIMIT;
                    gSenderTimer.restart();
                    return;
                }
            }
        } else if (status == 401) {
            //console.log(">> response: " + response);
            gPendingRequestData = "";
            clearAlarmDataQueue();
            gStopSendingPushData = true;
        }else {
            if (response || response != undefined) {
                //console.log(">> response: " + response);
            }
        }

        if (gPendingRequestData.length > 0) {
            gSenderTimer.interval = HTTP_RETRY_DELAY;
            gSenderTimer.restart();
        } else if (gAlarmDataQueue.getLength() > 0) {
            gSenderTimer.interval = HTTP_REQUEST_DELAY;
            gSenderTimer.restart();
        } else {
            http_status = HTTP_STATUS_TYPE.IDLE;
        }
    });  
}

function postJson(data, callback) {
    console.log(">>postJson()");

    var requestUrl = gServerUrl + "v2/push/user/alarm"

    var xmlhttp = new XMLHttpRequest();

    xmlhttp.open("POST", requestUrl);
    xmlhttp.setRequestHeader("Content-Type", "application/json; charset=utf-8");
    xmlhttp.setRequestHeader("Auth-Key", gAuthKey);
    
    xmlhttp.onreadystatechange = function() {
        //console.log(">>readyState: " + xmlhttp.readyState + ", " + "status: " + xmlhttp.status);
        if (xmlhttp.readyState == 4) {
            var responseData;
            if (xmlhttp.status == 200) {
                console.log(">> response: " + JSON.stringify(xmlhttp.responseText));
                responseData = JSON.parse(xmlhttp.responseText);
            }
            console.log(">> status: " + xmlhttp.status);
            callback(xmlhttp.status, responseData);
        }
    }

    //wemx.log_e(">> xmlhttp.send: " + data);
    //console.log(">> xmlhttp.send: " + data);
    xmlhttp.send(data);
}
