


var wTimerService;
var scriptHash = {}
//var scriptLocalExecHash = {}
//var scriptGlobalExecHash = {}
var screenToScriptExecHash = {}


var scriptExecFreeList = [];

function getScriptExec()
{
    var scriptExec;
    
    if ( scriptExecFreeList.length == 0 )
    {
        scriptExec = {};
        scriptExec.periodTimer = wTimerService.executeS("getTimer", null, null);
        return(scriptExec);
    }

    scriptExec = scriptExecFreeList.pop();
    return(scriptExec);    
}

function freeScriptExec(scriptExec)
{
    scriptExecFreeList.push(scriptExec);
}


function getScriptInstance(path)
{
	var script = scriptHash[path];
	if ( script == null )
	{
		var stubStr =   'import QtQuick 2.0;\
		                import com.wemx 1.0;\
		                import "' + path + '" as Js;\
		                Item {\
		                    function startFunc() {\
		                        Js.startMain()\
		                    }\
		                }';		// "

        try {
		    script = Qt.createQmlObject(stubStr, wemx);
        } catch(Err) {
            console.log(Err);
            return(null);
        }         
		scriptHash[path] = script;
	}
	return(script);
}


function __wemx_wrapperCallScript(path)
{
	var script = getScriptInstance(path);
    if ( script == null )
    {
    	console.log("callScirpt >> invalid script path : ", path);
    	return;
    }
	script.startFunc();
}
	


function startScript(scriptInfo)
{    
//console.log("startScript >> scrNum ==> ", scriptInfo.scrNum);

	wemx.__wemx_setCurScrNum(scriptInfo.scrNum);
    scriptInfo.script.startFunc();
}


function executeScript(execId, period, path, scrNum, cb)
{
//console.log("executeScript ", execId, period, path, bIsLocal);

	var script = getScriptInstance(path);
    if ( script == null )
    {
        wemx.callback(execId, null, cb);
        return;
    }

	var scriptInfo = {};
	scriptInfo.script = script;
	scriptInfo.scrNum = scrNum;

//console.log("executeScript >> scrNum ==> ", scriptInfo.scrNum, scrNum);

    if ( period > 0 )
    {
        var scriptExecHash = screenToScriptExecHash[scrNum];
        if ( scriptExecHash == null )
        {
            scriptExecHash = {};
            screenToScriptExecHash[scrNum] = scriptExecHash;
        }
        
        if ( scriptExecHash[execId] != null )
        {
            console.log("you do try to exec script about already exist execId ", execId);
            return;
        }

        var scriptExec = getScriptExec();
        scriptExec.cb = cb;
        
	    startScript(scriptInfo);
        scriptExec.periodTimer.start(period, startScript, scriptInfo);

        scriptExecHash[execId] = scriptExec;
    }
    else
    {
	    startScript(scriptInfo);
		wemx.callback(execId, null, cb);
    }
}


function closeScriptPriv(execId, scriptExec)
{
//    console.log(" close scriptPriv: ", scriptExec );        

    scriptExec.periodTimer.stop();
    wemx.callback(execId, null, scriptExec.cb);
    
    freeScriptExec(scriptExec);
}

function closeGlobalScript(execId)
{
    var scriptExecHash = screenToScriptExecHash[0];    
    var scriptExec = scriptExecHash[execId];
    if ( scriptExec == null )
    {
        console.log("you do try to close global script about invalid execId ", execId);
        return;
    }

    closeScriptPriv(execId, scriptExec);
    scriptExecHash[execId] = null;
}

function closeLocalScript(execId, scrNum)
{
    var scriptExecHash = screenToScriptExecHash[scrNum];    
    if ( scriptExecHash == null )
    {
        console.log("you do try to close local script about invalid execId or screen number(s1)", execId, scrNum);
        return;
    }
    var scriptExec = scriptExecHash[execId];
    if ( scriptExec == null )
    {
        console.log("you do try to close local script about invalid execId or screen number(s2)", execId, scrNum);
        return;
    }

    closeScriptPriv(execId, scriptExec);
    scriptExecHash[execId] = null;
}


function closeScreenLocalScripts(scrNum)
{ 
	// screen Ҽӵ local script  setTimeout()  clearѴ. 
	wemx.__wemx_clearTimeouts(scrNum);

	
    var scriptExecHash = screenToScriptExecHash[scrNum];    
    if ( scriptExecHash == null )
    {
  		// ֱ local script մ  
  		//console.log("SCRIPT >> closeScreenLocalScripts   period local script ... 0.... ");
        return;
    }

    for(var execId in scriptExecHash)
    {
        var scriptExec = scriptExecHash[execId];
        if ( scriptExec == null )
        {
            continue;
        }

        closeScriptPriv(execId, scriptExec);
        scriptExecHash[execId] = null;
    }
}


function executed(cmd, args1, args2, cb, connId)
{
//console.log( "Script Driver executed >> ", cmd, args1, args2, cb, connId);

    switch(cmd)
    {
        case "execScript":
             executeScript(args1.execId, args1.period, args1.path, args1.scrNum, cb);
            break;

        case "closeLocalScript":
            closeLocalScript(args1.execId, args1.scrNum);
            break;

        case "closeGlobalScript":
            closeGlobalScript(args1.execId);
            break;
            
        case "closeScreenLocalScripts":
            closeScreenLocalScripts(args1.scrNum);
            break;
            
        default:
            console.log("WEMXCommBlockIcon >> invalid command... ", cmd);
            break;
    }    
}    



function init()
{	
	wemx.__wemx_setWrapperCallScriptFunc(__wemx_wrapperCallScript);
    wemx.conn.executed.connect(executed);
    wTimerService = wemx.getService("/local/TimerService");
}



